function CreatePlaylist(pl_place, pl_name){      
    var QuestionString = "Give your playlist a name."
    var result = InputBox(QuestionString, "Create New Playlist", "New Playlist");
	if (result){
		if (result == "") {
			plman.CreatePlaylist(pl_place, "New Playlist");
		} else plman.CreatePlaylist(pl_place, result);
		//on_playlist_switch();
		return true;
	} else return false;
}
function CreateAutoPlaylist(pl_place, pl_name, query){      
    var QuestionString = "Give your playlist a name."
    var result = InputBox(QuestionString, "Create New Autoplaylist", "New Autoplaylist");
	if (result){
		if (result == "") {
			plman.CreateAutoPlaylist(pl_place, "New Autoplaylist", query);
		} else plman.CreateAutoPlaylist(pl_place, result, query);
		on_playlist_switch();	
	}
	 plman.ShowAutoPlaylistUI(plman.PlaylistCount-1);
}
function DeletePlaylist(pid){
    parsed_tabname = plman.GetPlaylistName(pid);
      
    var QuestionString = "Delete the playlist '"+parsed_tabname+"' ?";
    var result = MsgBox(QuestionString, 4, "Please confirm");
    if (result == 6) {
		if(plman.ActivePlaylist == pid){
			if(pid==plman.PlaylistCount-1) plman.ActivePlaylist = pid-1;
			else plman.ActivePlaylist = pid+1;
		}
        plman.RemovePlaylistSwitch(pid);    
    }

}

properties = {
	panelName: 'WSHsmoothplaylistmanager',			
    defaultRowHeight: window.GetProperty("PROPERTY: Row Height", 46),
    enableDiskCache: window.GetProperty("COVER Disk Cache", true),		
    rowHeight: window.GetProperty("PROPERTY: Row Height", 42),
    rowScrollStep: 3,
    thumbnailWidthMax: 300,		
    drawAlternateBG: window.GetProperty("PROPERTY: Alternate row background", true), 		
    scrollSmoothness: 3.0,
    refreshRate: 40,
    showHeaderBar: window.GetProperty("DISPLAY: Show Top Bar", false),
    showNewPlaylistButton: window.GetProperty("DISPLAY: Show new playlist button", true),	
    defaultHeaderBarHeight: 40,
    headerBarHeight: 40,
    headerBarPaddingTop: 0,		
    paddingTopDefault: 45,	
    globalFontAdjustement: window.GetProperty("MAINPANEL: Global Font Adjustement", -1),
    showFilterBox: window.GetProperty("PROPERTY: Enable Playlist Filterbox in Top Bar", true),
    drawUpAndDownScrollbar: window.GetProperty("PROPERTY: Draw Up and Down Scrollbar Buttons", false),
    drawItemsCounter: window.GetProperty("PROPERTY: Show numbers of items", true),			
	darklayout: window.GetProperty("_DISPLAY: Dark layout", false),	    
	showwallpaper: window.GetProperty("_DISPLAY: Show Wallpaper", false),	
    wallpaperblurred: window.GetProperty("_DISPLAY: Wallpaper Blurred", true),
    wallpaperblurvalue: window.GetProperty("_DISPLAY: Wallpaper Blur Value", 1.05),
    wallpapermode: window.GetProperty("_SYSTEM: Wallpaper Mode", 0),
	wallpaperpath: theme_img_path+"\\nothing_played_full.png",		
    wallpaperdisplay: window.GetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", 0),		
    enableTouchControl: window.GetProperty("PROPERTY: Touch control", false),
    enableCustomColors: window.GetProperty("CUSTOM COLOR: enable", true),	
	customColorTextNormal: window.GetProperty("CUSTOM COLOR: text normal", "0-0-0"),
	customColorTextSelected: window.GetProperty("CUSTOM COLOR: text selected", "0-0-0"),
	customColorBgNormal: window.GetProperty("CUSTOM COLOR: background normal", "250-250-250"),
	customColorBgSelected: window.GetProperty("CUSTOM COLOR: background selected", "015-177-255"),
	customColorHightlight: window.GetProperty("CUSTOM COLOR: highlight", "235-235-235"),
    addedRows_end_default: window.GetProperty("_PROPERTY: empty rows at the end", 1),
    showPlaylistIcons: window.GetProperty("_PROPERTY: show an icon before the playlist name", true),
	panelFontAdjustement: -1	
};
properties.wallpapermode_temp = properties.wallpapermode;
var cover = {
    nocover_img: gdi.Image(theme_img_path+"\\no_cover.png"),	
    stream_img: gdi.Image(theme_img_path+"\\stream_icon.png"),
};
// wallpaper infos
var wpp_img_info = {orient: 0, cut: 0, cut_offset: 0, ratio: 0, x: 0, y: 0, w: 0, h: 0};
var g_wallpaperImg = null;
var update_wallpaper = false;
var update_size = true;
var first_on_size = true;

var g_rightClickedIndex = -1;
var Update_Required_function = "";
var avoidDbleClick = avoidDbleClickTimer = false;
//var isHoverCreatePlaylist = isHoverCreatePlaylistSaved = false;
var g_image_cache = false;

cPlaylistManager = {
    playlist_switch_pending: false,
    drag_clicked: false,
    drag_droped: false,
    drag_x: -1,
    drag_y: -1,
    drag_source_id: -1,
    drag_target_id: -1,
    inputbox_w: 0,
    inputbox_h: 0
};

cTouch = {
    down: false,
    y_start: 0,
    y_end: 0,
    y_current: 0,
    y_prev: 0,
    y_move: 0,
    scroll_delta: 0,
    t1: null, 
    timer: false,
    multiplier: 0,
    delta: 0
};

cSettings = {
    visible: false
};

cFilterBox = {
    enabled: window.GetProperty("PROPERTY: Enable Filter Box", true),
    default_w: 120,
    default_h: 20,
    x: 10,
    y: 2,
    w: 120,
    h: 20
};

cColumns = {
    dateWidth: 0,
    albumArtistWidth: 0,
    titleWidth: 0,
    genreWidth: 0
};

images = {
    path: theme_img_path + "\\"
};
            
blink = {
    x: 0,
    y: 0,
    totaltracks: 0,
    id: -1,
    counter: -1,
    timer: false
};

timers = {
    mouseWheel: false,
    saveCover: false,
    mouseDown: false,
    movePlaylist: false,
    deletePlaylist: false,
    rightClick: false,
    addPlaylistDone: false,
	sendManagerHeight:false
};

//=================================================// Extra functions for playlist manager panel
function renamePlaylist() {
    if(!brw.inputbox.text || brw.inputbox.text == "" || brw.inputboxID == -1) brw.inputbox.text = brw.rows[brw.inputboxID].name;
    if (brw.inputbox.text.length > 1 || (brw.inputbox.text.length == 1 && (brw.inputbox.text >= "a" && brw.inputbox.text <= "z") || (brw.inputbox.text >= "A" && brw.inputbox.text <= "Z") || (brw.inputbox.text >= "0" && brw.inputbox.text <= "9"))) {
        brw.rows[brw.inputboxID].name = brw.inputbox.text;
        plman.RenamePlaylist(brw.rows[brw.inputboxID].idx, brw.inputbox.text);
        brw.repaint();
    };
    brw.inputboxID = -1;
};

/* 
===================================================================================================
    Objects
===================================================================================================
*/
oPlaylist = function(idx, rowId, name) {
    this.idx = idx;
    this.rowId = rowId;
    this.name = name;
	try {
		if(idx>=0)
			this.isAutoPlaylist = plman.IsAutoPlaylist(idx);
		else this.isAutoPlaylist = false;
	} catch(e){
		this.isAutoPlaylist = false;
	}
	try {
		if(idx>=0)
			this.isLockedPlaylist = plman.IsPlaylistLocked(idx);
		else this.isLockedPlaylist = false;
	} catch(e){
		this.isLockedPlaylist = false;
	}

	this.setIcon = function() {
		this.icon = playlistName2icon(this.name, this.isAutoPlaylist);			
	}
	this.setIcon();
};

oFilterBox = function() {
	this.images = {
        resetIcon_off: null,
        resetIcon_ov: null
	};

    this.getImages = function() {
		var gb;
        var w = Math.round(18 * g_zoom_percent / 100);
        
		if(properties.darklayout){
			this.images.search_icon = gdi.Image(theme_img_path + "\\icons\\white\\search_icon.png");	
		} else {
			this.images.search_icon = gdi.Image(theme_img_path + "\\icons\\search_icon.png");			
		}
		this.search_bt = new button(this.images.search_icon, this.images.search_icon, this.images.search_icon);
		
        this.images.resetIcon_off = gdi.CreateImage(w, w);
        gb = this.images.resetIcon_off.GetGraphics();
            gb.setSmoothingMode(2);
            gb.DrawLine(5, 5, w-5, w-5, 1.0, g_color_normal_txt);
            gb.DrawLine(5, w-5, w-5, 5, 1.0, g_color_normal_txt);
            gb.setSmoothingMode(0);
        this.images.resetIcon_off.ReleaseGraphics(gb);

        this.images.resetIcon_ov = gdi.CreateImage(w, w);
        gb = this.images.resetIcon_ov.GetGraphics();
            gb.setSmoothingMode(2);
            gb.DrawLine(4, 4, w-4, w-4, 1.0, g_color_normal_txt);
            gb.DrawLine(4, w-4, w-4, 4, 1.0, g_color_normal_txt);
            gb.setSmoothingMode(0);
        this.images.resetIcon_ov.ReleaseGraphics(gb);

        this.images.resetIcon_dn = gdi.CreateImage(w, w);
        gb = this.images.resetIcon_dn.GetGraphics();
            gb.setSmoothingMode(2);
            gb.DrawLine(4, 4, w-4, w-4, 1.0, reseticon_down);
            gb.DrawLine(4, w-4, w-4, 4, 1.0, reseticon_down);
            gb.setSmoothingMode(0);
        this.images.resetIcon_dn.ReleaseGraphics(gb);

        this.reset_bt = new button(this.images.resetIcon_off, this.images.resetIcon_ov, this.images.resetIcon_dn);
	};
	this.getImages();
    
	this.on_init = function() {
		this.inputbox = new oInputbox(cFilterBox.w, cFilterBox.h, "", "Playlists...", g_color_normal_txt, 0, 0, g_color_selected_bg, g_sendResponse, "brw");
        this.inputbox.autovalidation = true;
    };
	this.on_init();
    
    this.reset_colors = function() {
        this.inputbox.textcolor = g_color_normal_txt;
        this.inputbox.backselectioncolor = g_color_selected_bg;
    };

    this.setSize = function(w, h, font_size) {
        this.inputbox.setSize(w, h, font_size);
        this.getImages();
    };

    this.clearInputbox = function() {
        if(this.inputbox.text.length > 0) {
            this.inputbox.text = "";
            this.inputbox.offset = 0;
            filter_text = "";
        };
    };
    
	this.draw = function(gr, x, y) {
        var bx = x;
		var by = y + properties.headerBarPaddingTop;
        var bw = this.inputbox.w + Math.round(44 * g_zoom_percent / 100);
        
        if(this.inputbox.edit) {
            gr.SetSmoothingMode(2);
            gr.SetSmoothingMode(0);
        };

        if(this.inputbox.text.length > 0) {
            this.reset_bt.draw(gr, bx+2, by+1, 255);
        } else {
			this.search_bt.draw(gr, bx, by-2, 255);			
			//gr.DrawImage(this.images.search_icon, bx, by+Math.round(this.inputbox.h/2-this.images.search_icon.Height/2), this.images.search_icon.Width, this.images.search_icon.Height, 0, 0, this.images.search_icon.Width, this.images.search_icon.Height, 0, 255);
        };
		this.inputbox.draw(gr, bx+Math.round(22 * g_zoom_percent / 100)+7, by, 0, 0);
    };
    
    this.on_mouse = function(event, x, y, delta) {
        switch(event) {
            case "lbtn_down":
				this.inputbox.check("down", x, y);
                if(this.inputbox.text.length > 0) this.reset_bt.checkstate("down", x, y);
				else this.search_bt.checkstate("down", x, y);				
                break;
            case "lbtn_up":
                if(this.inputbox.text.length > 0) {
                    if(this.reset_bt.checkstate("up", x, y) == ButtonStates.hover && !this.inputbox.drag) {
                        this.inputbox.text = "";
                        this.inputbox.offset = 0;
                        g_sendResponse();
                    };
                } else {
					if(this.search_bt.checkstate("up", x, y) == ButtonStates.hover && !this.inputbox.drag) {
						this.inputbox.activate(x,y);
						this.inputbox.repaint();
					};					
				}
				this.inputbox.check("up", x, y);				
                break;
            case "lbtn_dblclk":
				this.inputbox.check("dblclk", x, y);
                break;
            case "rbtn_down":
				this.inputbox.check("right", x, y);
                break;
            case "move":
				this.inputbox.check("move", x, y);
                if(this.inputbox.text.length > 0) this.reset_bt.checkstate("move", x, y);
                break;
        };
    };
    
    this.on_key = function(event, vkey) {
        switch(event) {
            case "down":
				this.inputbox.on_key_down(vkey);
                break;
        };
    };
    
    this.on_char = function(code) {
        this.inputbox.on_char(code);
    };
    
	this.on_focus = function(is_focused) {
		this.inputbox.on_focus(is_focused);
	};
};

oScrollbar = function(themed) {
    this.themed = themed;
    this.showButtons = true;
    this.buttons = Array(null, null, null);
    this.buttonType = {cursor: 0, up: 1, down: 2};
    this.buttonClick = false;
    this.cursorHover = false;
    this.cursorDrag = false;
    this.color_bg = g_color_normal_bg;
    this.color_txt = g_color_normal_txt;
    
    if(this.themed) {
        this.theme = window.CreateThemeManager("scrollbar");
    } else {
        this.theme = false;
    };
    
    this.setNewColors = function() {
        this.color_bg = g_color_normal_bg;
        this.color_txt = g_color_normal_txt;  
        this.setButtons();
        this.setCursorButton();
    };

    this.setButtons = function() {
        // normal scroll_up Image
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            this.upImage_normal = gdi.CreateImage(this.w, this.w);
            var gb = this.upImage_normal.GetGraphics();
            try {
                this.theme.SetPartAndStateId(1, 1);
                this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
            } catch(e) {
                DrawPolyStar(gb, 4, 4, this.w-8, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.5), 0, 255);
            };
        } else {
            this.upImage_normal = gdi.CreateImage(70, 70);
            var gb = this.upImage_normal.GetGraphics();
            DrawPolyStar(gb, 11, 16, 44, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.5), 0, 255);
        };
        this.upImage_normal.ReleaseGraphics(gb);

        // hover scroll_up Image
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            this.upImage_hover = gdi.CreateImage(this.w, this.w);
            gb = this.upImage_hover.GetGraphics();
            try {
                this.theme.SetPartAndStateId(1, 2);
                this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
            } catch(e) {
                DrawPolyStar(gb, 4, 4, this.w-8, 1, 3, 0, blendColors(this.color_txt, this.color_bg, 0.3), blendColors(this.color_txt, this.color_bg, 0.3), 0, 255);
            };
        } else {
            this.upImage_hover = gdi.CreateImage(70, 70);
            var gb = this.upImage_hover.GetGraphics();
            DrawPolyStar(gb, 11, 16, 44, 1, 3, 0, blendColors(this.color_txt, this.color_bg, 0.3), blendColors(this.color_txt, this.color_bg, 0.3), 0, 255);
        };
        this.upImage_hover.ReleaseGraphics(gb);

        // down scroll_up Image
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            this.upImage_down = gdi.CreateImage(this.w, this.w);
            gb = this.upImage_down.GetGraphics();
            try {
                this.theme.SetPartAndStateId(1, 3);
                this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
            } catch(e) {
                DrawPolyStar(gb, 4, 4, this.w-8, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.05), 0, 255);
            };
        } else {
            this.upImage_down = gdi.CreateImage(70, 70);
            gb = this.upImage_down.GetGraphics();
            DrawPolyStar(gb, 11, 13, 44, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.05), 0, 255);
        };
        this.upImage_down.ReleaseGraphics(gb);

        // normal scroll_down Image
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            this.downImage_normal = gdi.CreateImage(this.w, this.w);
            gb = this.downImage_normal.GetGraphics();
            try {
                this.theme.SetPartAndStateId(1, 5);
                this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
            } catch(e) {
                DrawPolyStar(gb, 4, 4, this.w-8, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.5), 180, 255);
            };
        } else {
            this.downImage_normal = gdi.CreateImage(70, 70);
            gb = this.downImage_normal.GetGraphics();
            DrawPolyStar(gb, 11, 10, 44, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.5), 180, 255);
        };
        this.downImage_normal.ReleaseGraphics(gb);

        // hover scroll_down Image
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            this.downImage_hover = gdi.CreateImage(this.w, this.w);
            gb = this.downImage_hover.GetGraphics();
            try {
                this.theme.SetPartAndStateId(1, 6);
                this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
            } catch(e) {
                DrawPolyStar(gb, 4, 4, this.w-8, 1, 3, 1, blendColors(this.color_txt, this.color_bg, 0.3), blendColors(this.color_txt, this.color_bg, 0.3), 180, 255);
            };
        } else {
            this.downImage_hover = gdi.CreateImage(70, 70);
            gb = this.downImage_hover.GetGraphics();
            DrawPolyStar(gb, 11, 10, 44, 1, 3, 1, blendColors(this.color_txt, this.color_bg, 0.3), blendColors(this.color_txt, this.color_bg, 0.3), 180, 255);
        };
        this.downImage_hover.ReleaseGraphics(gb);

        // down scroll_down Image
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            this.downImage_down = gdi.CreateImage(this.w, this.w);
            gb = this.downImage_down.GetGraphics();
            try {
                this.theme.SetPartAndStateId(1, 7);
                this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
            } catch(e) {
                DrawPolyStar(gb, 4, 4, this.w-8, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.05), 180, 255);
            };
        } else {
            this.downImage_down = gdi.CreateImage(70, 70);
            gb = this.downImage_down.GetGraphics();
            DrawPolyStar(gb, 11, 13, 44, 1, 3, 0, g_color_normal_txt, blendColors(this.color_txt, this.color_bg, 0.05), 180, 255);
        };
        this.downImage_down.ReleaseGraphics(gb);
        
        for(i = 1; i < this.buttons.length; i++) {
            switch(i) {
            case this.buttonType.cursor:
                this.buttons[this.buttonType.cursor] = new button(this.cursorImage_normal, this.cursorImage_hover, this.cursorImage_down);
                break;
            case this.buttonType.up:
                this.buttons[this.buttonType.up] = new button(this.upImage_normal.Resize(this.w,this.w,2), this.upImage_hover.Resize(this.w,this.w,2), this.upImage_down.Resize(this.w,this.w,2));
                break;
            case this.buttonType.down:
                this.buttons[this.buttonType.down] = new button(this.downImage_normal.Resize(this.w,this.w,2), this.downImage_hover.Resize(this.w,this.w,2), this.downImage_down.Resize(this.w,this.w,2));
                break;
            };
        };
    };

    this.setCursorButton = function() {
        // normal cursor Image
        this.cursorImage_normal = gdi.CreateImage(this.cursorw, this.cursorh);
        var gb = this.cursorImage_normal.GetGraphics();
		//gb.FillSolidRect(1, 0, this.cursorw-2, this.cursorh, blendColors(this.color_txt, this.color_bg, 0.5) & 0x88ffffff);
		//gb.DrawRect(1, 0, this.cursorw-2 - 1, this.cursorh - 1, 1.0, this.color_txt & 0x44ffffff);		
		gb.FillSolidRect(this.cursorw-cScrollBar.normalWidth-1, cScrollBar.marginTop, cScrollBar.normalWidth-2, this.cursorh-cScrollBar.marginTop-cScrollBar.marginBottom, scrollbar_normal_cursor_color);
        this.cursorImage_normal.ReleaseGraphics(gb);
        
        // hover cursor Image
        this.cursorImage_hover = gdi.CreateImage(this.cursorw, this.cursorh);
        gb = this.cursorImage_hover.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            try {
                this.theme.SetPartAndStateId(3, 2);
                this.theme.DrawThemeBackground(gb, 0, 0, this.cursorw, this.cursorh);
                if(this.cursorh >= 30) {
                    this.theme.SetPartAndStateId(9, 2);
                    this.theme.DrawThemeBackground(gb, 0, 0, this.cursorw, this.cursorh);
                };
            } catch(e) {
                gb.FillSolidRect(1, 0, this.cursorw-2, this.cursorh, blendColors(this.color_txt, this.color_bg, 0.3));
            };
        } else {
            //gb.FillSolidRect(1, 0, this.cursorw-2, this.cursorh, blendColors(this.color_txt, this.color_bg, 0.3) & 0x88ffffff);
            //gb.DrawRect(1, 0, this.cursorw-2 - 1, this.cursorh - 1, 1.0, this.color_txt & 0x44ffffff);
			gb.FillSolidRect(this.cursorw-cScrollBar.hoverWidth, 0, cScrollBar.hoverWidth, this.cursorh,scrollbar_hover_cursor_color);
        };
        this.cursorImage_hover.ReleaseGraphics(gb);
		
        // down cursor Image
        this.cursorImage_down = gdi.CreateImage(this.cursorw, this.cursorh);
        gb = this.cursorImage_down.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        if(this.themed) {
            try {
                this.theme.SetPartAndStateId(3, 3);
                this.theme.DrawThemeBackground(gb, 0, 0, this.cursorw, this.cursorh);
                if(this.cursorh >= 30) {
                    this.theme.SetPartAndStateId(9, 3);
                    this.theme.DrawThemeBackground(gb, 0, 0, this.cursorw, this.cursorh);
                };
            } catch(e) {
                gb.FillSolidRect(1, 0, this.cursorw-2, this.cursorh, blendColors(this.color_txt, this.color_bg, 0.05));
            };
        } else {
            //gb.FillSolidRect(1, 0, this.cursorw-2, this.cursorh, blendColors(this.color_txt, this.color_bg, 0.05) & 0x88ffffff);
            //gb.DrawRect(1, 0, this.cursorw-2 - 1, this.cursorh - 1, 1.0, this.color_txt & 0x44ffffff);
			gb.FillSolidRect(this.cursorw-cScrollBar.downWidth, 0, cScrollBar.downWidth, this.cursorh,scrollbar_down_cursor_color);
        };
        this.cursorImage_down.ReleaseGraphics(gb);
		
        // create/refresh cursor Button in buttons array
        this.buttons[this.buttonType.cursor] = new button(this.cursorImage_normal, this.cursorImage_hover, this.cursorImage_down);
        this.buttons[this.buttonType.cursor].x = this.x;
        this.buttons[this.buttonType.cursor].y = this.cursory;
    };
    
    this.draw = function(gr) {
        // scrollbar background
        if(this.themed) {
            try {
                this.theme.SetPartAndStateId(6, 1);
                this.theme.DrawThemeBackground(gr, this.x, this.y, this.w, this.h);
            } catch(e) {
                //gr.FillSolidRect(this.x, this.y, this.w, this.h, this.color_bg & 0x25ffffff);
                //gr.FillSolidRect(this.x, this.y, 1, this.h, this.color_txt & 0x05ffffff);
            };
        } else {
           // gr.FillSolidRect(this.x, this.y, this.w, this.h, this.color_bg & 0x25ffffff);
            //gr.FillSolidRect(this.x, this.y, 1, this.h, this.color_txt & 0x05ffffff);
        };
        // scrollbar buttons
        if(cScrollBar.visible) this.buttons[this.buttonType.cursor].draw(gr, this.x, this.cursory, 255);
        if(this.showButtons && properties.drawUpAndDownScrollbar) {
            this.buttons[this.buttonType.up].draw(gr, this.x, this.y, 255);
            this.buttons[this.buttonType.down].draw(gr, this.x, this.areay + this.areah, 255);
        };
    };
       
    this.updateScrollbar = function() {
        var prev_cursorh = this.cursorh;
        this.total = (brw.rowsCount+properties.addedRows_end);
        this.rowh = properties.rowHeight;
        this.totalh = this.total * this.rowh;
        // set scrollbar visibility
        cScrollBar.visible = (this.totalh > brw.h+5);
        // set cursor width/height
        this.cursorw = cScrollBar.width;
        if(this.total > 0) {
            this.cursorh = Math.round((brw.h / this.totalh) * this.areah);
            if(this.cursorh < cScrollBar.minCursorHeight) this.cursorh = cScrollBar.minCursorHeight;
			if(this.cursorh > cScrollBar.maxCursorHeight) this.cursorh = cScrollBar.maxCursorHeight;			
        } else {
            this.cursorh = cScrollBar.minCursorHeight;
        };
        // set cursor y pos
        this.setCursorY();
        if(this.cursorh != prev_cursorh) this.setCursorButton();
    };
    
    this.setCursorY = function() {
        // set cursor y pos
        var ratio = scroll / (this.totalh - brw.h);
        this.cursory = this.areay + Math.round((this.areah - this.cursorh) * ratio);
    };
    
    this.setSize = function() {
        if(properties.drawUpAndDownScrollbar) this.buttonh = cScrollBar.width;
		else this.buttonh = 0;		
        this.x = brw.x + brw.w-cScrollBar.width;
        this.y = brw.y - properties.headerBarHeight*0;
        this.w = cScrollBar.width;
        this.h = brw.h + properties.headerBarHeight*0;
        if(this.showButtons) {
            this.areay = this.y + this.buttonh;
            this.areah = this.h - (this.buttonh * 2);
        } else {
            this.areay = this.y;
            this.areah = this.h;
        };
        this.setButtons();
    };
    
    this.setScrollFromCursorPos = function() {
        // calc ratio of the scroll cursor to calc the equivalent item for the full list (with gh)
        var ratio = (this.cursory - this.areay) / (this.areah - this.cursorh);
        // calc idx of the item (of the full list with gh) to display at top of the panel list (visible)
        scroll = Math.round((this.totalh - brw.h) * ratio);
    };

    this.cursorCheck = function(event, x, y) {
		if(!this.buttons[this.buttonType.cursor]) return;
        switch(event) {
        case "down":
            var tmp = this.buttons[this.buttonType.cursor].checkstate(event, x, y);
			if(tmp == ButtonStates.down) {
                this.cursorClickX = x;
                this.cursorClickY = y;
                this.cursorDrag = true;
                this.cursorDragDelta = y - this.cursory;
            };
            break;
        case "up":
			this.buttons[this.buttonType.cursor].checkstate(event, x, y);
            if(this.cursorDrag) {
                this.setScrollFromCursorPos();
                brw.repaint();
            };
            this.cursorClickX = 0;
            this.cursorClickY = 0;
            this.cursorDrag = false;
            break;
        case "move":
			var state = this.buttons[this.buttonType.cursor].checkstate(event, x, y);
			if(state == ButtonStates.hover && !this.cursorHover) {
				this.cursorHover = true;
				brw.repaint();
			} else if(this.cursorHover && state != ButtonStates.hover){
				this.cursorHover = false;
				brw.repaint();
			}
            if(this.cursorDrag) {
                this.cursory = y - this.cursorDragDelta;
                if(this.cursory + this.cursorh > this.areay + this.areah) {
                    this.cursory = (this.areay + this.areah) - this.cursorh;
                };
                if(this.cursory < this.areay) {
                    this.cursory = this.areay;
                };
                this.setScrollFromCursorPos();
                brw.repaint();
            };
            break;
		case "leave":
			this.buttons[this.buttonType.cursor].checkstate(event, 0, 0);
			break;
        };
    };
    
    this._isHover = function(x, y) {
        return (x >= this.x && x <= this.x + this.w && y >= this.y && y <= this.y + this.h);
    };

    this._isHoverArea = function(x, y) {
        return (x >= this.x && x <= this.x + this.w && y >= this.areay && y <= this.areay + this.areah);
    };

    this._isHoverCursor = function(x, y) {
        return (x >= this.x && x <= this.x + this.w && y >= this.cursory && y <= this.cursory + this.cursorh);
    };

    this.on_mouse = function(event, x, y, delta) {
        this.isHover = this._isHover(x, y);
        this.isHoverArea = this._isHoverArea(x, y);
        this.isHoverCursor = this._isHoverCursor(x, y);
        this.isHoverButtons = this.isHover && !this.isHoverCursor && !this.isHoverArea;
        this.isHoverEmptyArea = this.isHoverArea && !this.isHoverCursor;
        
        var scroll_step = properties.rowHeight;
        var scroll_step_page = brw.h;

        switch(event) {
            case "down":
            case "dblclk":
                if((this.isHoverCursor || this.cursorDrag) && !this.buttonClick && !this.isHoverEmptyArea) {
                    this.cursorCheck(event, x, y);
                } else {					
                    // buttons events
                    var bt_state = ButtonStates.normal;
                    for(var i = 1; i < 3; i++) {
                        switch(i) {
                            case 1: // up button
                                bt_state = this.buttons[i].checkstate(event, x, y);
                                if((event == "down" && bt_state == ButtonStates.down) || (event == "dblclk" && bt_state == ButtonStates.hover)) {
                                    this.buttonClick = true;
                                    scroll = scroll - scroll_step;
                                    scroll = check_scroll(scroll);
                                    if(!cScrollBar.timerID) {
                                        cScrollBar.timerID = window.SetInterval(function() {
                                            if(cScrollBar.timerCounter > 6) {
                                                scroll = scroll - scroll_step;
                                                scroll = check_scroll(scroll);
                                            } else {
                                                cScrollBar.timerCounter++;
                                            };
                                        }, 80);
                                    };
                                };
                                break;
                            case 2: // down button
                                bt_state = this.buttons[i].checkstate(event, x, y);
                                if((event == "down" && bt_state == ButtonStates.down) || (event == "dblclk" && bt_state == ButtonStates.hover)) {
                                    this.buttonClick = true;
                                    scroll = scroll + scroll_step;
                                    scroll = check_scroll(scroll);
                                    if(!cScrollBar.timerID) {
                                        cScrollBar.timerID = window.SetInterval(function() {
                                            if(cScrollBar.timerCounter > 6) {
                                                scroll = scroll + scroll_step;
                                                scroll = check_scroll(scroll);
                                            } else {
                                                cScrollBar.timerCounter++;
                                            };
                                        }, 80);
                                    };
                                };
                                break;
                        };
                    };
                    if(!this.buttonClick && this.isHoverEmptyArea) {
                        // check click on empty area scrollbar
                        if(y < this.cursory) {
                            // up
                            this.buttonClick = true;
                            scroll = scroll - scroll_step_page;
                            scroll = check_scroll(scroll);
                            if(!cScrollBar.timerID) {
                                cScrollBar.timerID = window.SetInterval(function() {
                                    if(cScrollBar.timerCounter > 6 && m_y < brw.scrollbar.cursory) {
                                        scroll = scroll - scroll_step_page;
                                        scroll = check_scroll(scroll);
                                    } else {
                                        cScrollBar.timerCounter++;
                                    };
                                }, 80);
                            };
                        } else {
                            // down
                            this.buttonClick = true;
                            scroll = scroll + scroll_step_page;
                            scroll = check_scroll(scroll);
                            if(!cScrollBar.timerID) {
                                cScrollBar.timerID = window.SetInterval(function() {
                                    if(cScrollBar.timerCounter > 6 && m_y > brw.scrollbar.cursory + brw.scrollbar.cursorh) {
                                        scroll = scroll + scroll_step_page;
                                        scroll = check_scroll(scroll);
                                    } else {
                                        cScrollBar.timerCounter++;
                                    };
                                }, 80);
                            };
                        };
                    };
                };
                break;
            case "right":
            case "up":
                if(cScrollBar.timerID) {
                    window.ClearInterval(cScrollBar.timerID);
                    cScrollBar.timerID = false;
                };
                cScrollBar.timerCounter = -1;
                
                this.cursorCheck(event, x, y);
                for(var i = 1; i < 3; i++) {
                    this.buttons[i].checkstate(event, x, y);
                };
                this.buttonClick = false;
                break;
            case "move":			
                this.cursorCheck(event, x, y);
                for(var i = 1; i < 3; i++) {
                    this.buttons[i].checkstate(event, x, y);
                };
                break;
            case "wheel":
                if(!this.buttonClick) {
                    this.updateScrollbar();
                };
                break;
            case "leave":
                this.cursorCheck(event, 0, 0);
                for(var i = 1; i < 3; i++) {
                    this.buttons[i].checkstate(event, 0, 0);
                };
                break;
        };
    };
};

oBrowser = function(name) {
    this.name = name;
    this.rows = [];
    this.SHIFT_start_id = null;
    this.SHIFT_count = 0;
    this.scrollbar = new oScrollbar(themed = cScrollBar.themed);
    this.keypressed = false;
    this.inputbox = null;
    this.inputboxID = -1;
    this.selectedRow = plman.ActivePlaylist;
	this.playing_icon_x = 0;
	this.playing_icon_y = 0;	
	this.playing_icon_w = 0;		
	this.playing_icon_h = 0;
    this.launch_populate = function() {
        var launch_timer = window.SetTimeout(function(){
            brw.populate(is_first_populate = true, 2, reset_scroll = true);
            launch_timer && window.ClearTimeout(launch_timer);
            launch_timer = false;
        }, 50);
    };
    
    this.repaint = function() {
        if(!window.IsVisible) return;
        repaint_main1 = repaint_main2;
    };
    
    this.setSize = function(x, y, w, h) {
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
        this.marginLR = 0;
        this.paddingLeft = 8;		
        this.paddingRight = 12;			
        this.totalRows = Math.ceil(this.h / properties.rowHeight);
        this.totalRowsVis = Math.floor(this.h / properties.rowHeight);
        
        this.getlimits();
        
        g_filterbox.setSize(ww, cFilterBox.h+2, g_fsize+1);
        
        if(this.inputboxID > -1) {
            var rh = properties.rowHeight - 10;
            var tw = this.w - rh - 10;
            this.inputbox && this.inputbox.setSize(tw, rh, g_fsize+1);
        };
        
        this.scrollbar.setSize();
       
        scroll = Math.round(scroll / properties.rowHeight) * properties.rowHeight;
        scroll = check_scroll(scroll);
        scroll_ = scroll;
        
        // scrollbar update       
        this.scrollbar.updateScrollbar();
    };
          
    this.init_groups = function() {
        var rowId = 0;
        var name = "";
        var total = plman.PlaylistCount;
        this.previous_playlistCount = total;
		this.rows.splice(0, this.rows.length);
        CollectGarbage();
        var str_filter = process_string(filter_text);
		
		// draw Create playlist Button
		 if(properties.showNewPlaylistButton) {
			this.rows.push(new oPlaylist(-1, rowId, "Create Playlist"));
			rowId++;
		 }
		
		for(var i = 0; i < total; i++) {
			name = plman.GetPlaylistName(i);
			if(ExcludePlaylist(name)){
				var toAdd = false;  
			} else if(str_filter.length > 0) {
				var toAdd = match(name, str_filter);
			} else {
				var toAdd = true;  
			};
			if(toAdd) {
				this.rows.push(new oPlaylist(i, rowId, name));
				rowId++;
			};
		};
        this.rowsCount = rowId;
        this.getlimits();
    };

    this.getlimits = function() {
        if(this.rowsCount <= this.totalRowsVis) {
            var start_ = 0;
            var end_ = this.rowsCount - 1;
        } else {
            if(scroll_ < 0) scroll_ = scroll;
            var start_ = Math.round(scroll_ / properties.rowHeight + 0.4);
            var end_ = start_ + this.totalRows;
            // check boundaries
            start_ = start_ > 0 ? start_ - 1 : start_;
            if(start_ < 0) start_ = 0;
            if(end_ >= this.rows.length) end_ = this.rows.length - 1;
        };
        g_start_ = start_;
        g_end_ = end_;
    };
      
    this.populate = function(is_first_populate, call_id, reset_scroll) {
		console.log("--> populate smoothPlaylistManager call_id:"+call_id)				
        this.init_groups();
        if(reset_scroll) scroll = scroll_ = 0;
        this.scrollbar.updateScrollbar();
        this.repaint();
        g_first_populate_done = true;
    };
       
    this.getRowIdFromIdx = function(idx) {
        var total = this.rows.length;
        var rowId = -1;
        if(plman.PlaylistCount > 0) {
            for(var i=0; i < total; i++) {
                if(this.rows[i].idx == idx) {
                    rowId = i;
                    break;
                };
            };
        };
        return rowId;
    };
    this.setIcons = function(idx) {
        var total = this.rows.length;
		for(var i=0; i < total; i++) {
			this.rows[i].setIcon();
		};
    };
    this.isVisiblePlaylist = function(idx) {
        var rowId = this.getRowIdFromIdx(idx);
        var offset_active_pl = properties.rowHeight * rowId;
        if(offset_active_pl < scroll || offset_active_pl + properties.rowHeight > scroll + this.h) {
            return false;
        } else {
            return true;  
        };
    };
    
    this.showSelectedPlaylist = function() {
        var rowId = this.getRowIdFromIdx(brw.selectedRow);
        
        if(!this.isVisiblePlaylist(brw.selectedRow)) {
            scroll = (rowId - Math.floor(this.totalRowsVis / 2)) * properties.rowHeight;
            scroll = check_scroll(scroll);
            this.scrollbar.updateScrollbar();
        };
    };

    this.showActivePlaylist = function() {
        var rowId = this.getRowIdFromIdx(plman.ActivePlaylist);
        
        if(!this.isVisiblePlaylist(plman.ActivePlaylist)) {
            scroll = (rowId - Math.floor(this.totalRowsVis / 2)) * properties.rowHeight;
            scroll = check_scroll(scroll);
            this.scrollbar.updateScrollbar();
        };
    };
	this.FindPlayingPlaylist = function() {
		if(!fb.IsPlaying) this.PlayingPlaylist = -1;
		this.PlayingPlaylist = this.getRowIdFromIdx(plman.PlayingPlaylist);
	}
    this.draw = function(gr) {
        
        if(cPlaylistManager.playlist_switch_pending) {
            window.SetCursor(IDC_ARROW);
            cPlaylistManager.playlist_switch_pending = false;
        };
        
        if(repaint_main || !repaintforced){
            repaint_main = false;
            repaintforced = false;
            						
			var ax = this.marginLR;
			var ay = 0;
			var aw = this.w;
			var ah = properties.rowHeight;
			var g = 0;			
			gr.SetTextRenderingHint(globalProperties.TextRendering);
			
            if(this.rows.length > 0) {
				headerBarFix = (properties.showHeaderBar)?1:0;            
                for(var i = g_start_;i <= g_end_;i++){
                    
                    ay = Math.floor(this.y + (i * ah) - scroll_);
                    this.rows[i].x = ax;
                    this.rows[i].y = ay;
					if(ay > this.y - properties.headerBarHeight - ah && ay < this.y + this.h) {						
                        // =========
                        // row bg
                        // =========
						if(i % 2 == 0 && properties.drawAlternateBG && !(this.rows[i].idx == plman.ActivePlaylist)) {
							gr.FillSolidRect(ax, ay, aw, ah, g_color_alternate_row);
						};
						
                        // active playlist row bg
                        if(this.rows[i].idx == plman.ActivePlaylist || (i==g_rightClickedIndex && g_rightClickedIndex > -1)) {
                            gr.FillSolidRect(ax, ay, aw, ah, selected_item_bg);
							//top
							if(i>0 ){
							gr.FillSolidRect(ax, ay, aw-1, 1, selected_item_line);		
							}
							//bottom
							gr.FillSolidRect(ax, ay+ah-1, aw-1, 1, selected_item_line);								
                        }; 
						
                        // hover item
                        if((((g_rightClickedIndex > -1 && g_rightClickedIndex == i) || i == this.activeRow) && !(this.scrollbar.cursorDrag || this.scrollbar.cursorHover) && !g_dragndrop_status && !(cPlaylistManager.drag_clicked && cPlaylistManager.drag_source_id!=i)) ||  (cPlaylistManager.drag_clicked && cPlaylistManager.drag_source_id==i && !g_dragndrop_status)) {
							gr.FillSolidRect(ax, ay, width_marker_hover_item, ah, color_marker_hover_item);	
                        };
                        
                        // target location mark
                        if(cPlaylistManager.drag_target_id == i) {
                            if(cPlaylistManager.drag_target_id > cPlaylistManager.drag_source_id) {
                                gr.FillSolidRect(ax, ay + properties.rowHeight - 2, aw-1, 2, dragReorder_playlist_marker);
                            } else if(cPlaylistManager.drag_target_id < cPlaylistManager.drag_source_id) {
                                gr.FillSolidRect(ax, ay + 1, aw-1, 2, dragReorder_playlist_marker);
                            };
                        };
                        
                        if(g_dragndrop_status && i == g_dragndrop_targetPlaylistId) {
							if(!this.rows[i].isAutoPlaylist){
								gr.FillSolidRect(ax, ay, aw, ah, dragdrop_bg_selected_item);
								//top
								gr.FillSolidRect(ax, ay, aw, 1, dragdrop_line_selected_item);	
								//bottom
								gr.FillSolidRect(ax, ay+ah-1, aw, 1, dragdrop_line_selected_item);		
							} else {
								gr.FillSolidRect(ax, ay, aw, ah, dragdrop_disabled_item);
							}								
                        }
                        
                        // draw blink rectangle after an external drag'n drop files
                        if(blink.counter > -1) {
                            if(i == blink.id && !this.rows[i].isAutoPlaylist) {
                                if(blink.counter <= 7 && blink.counter % 2 == 0) {
									gr.FillSolidRect(ax, ay, aw, ah, dragdrop_bg_selected_item);
									gr.FillSolidRect(ax, ay, aw, 1, dragdrop_line_selected_item);	
									gr.FillSolidRect(ax, ay+ah-1, aw, 1, dragdrop_line_selected_item);		
                                };
                            };
                        };
                        
                        // =====
                        // text
                        // =====
                        if(ay >= (0 - ah) && ay < this.y + this.h) {     
	
							if(fb.IsPlaying && this.rows[i].idx == plman.PlayingPlaylist) {
                                var font = g_font.boldplus1;								
								var playlist_icon = (g_seconds%2==0)?images.now_playing_0:images.now_playing_1;	
								icon_x = ax+this.paddingLeft+1;
								icon_y = ay+Math.round(ah/2-playlist_icon.Height/2)-2;	
								icon_w = playlist_icon.Width;		
								icon_h = playlist_icon.Height;	
								this.playing_icon_x = icon_x;
								this.playing_icon_y = icon_y;	
								this.playing_icon_w = icon_w;		
								this.playing_icon_h = icon_h;
                            } else {
                                var font = g_font.plus1;
								var playlist_icon = this.rows[i].icon;
								icon_x = ax+this.paddingLeft;
								icon_y = ay+Math.round(ah/2-playlist_icon.Height/2)-1;	
								icon_w = playlist_icon.Width;		
								icon_h = playlist_icon.Height;									
                            };
							
                            // playlist icon
							if(!MiniMode && properties.showPlaylistIcons){
								var rh = this.rows[i].icon.Width;
								gr.DrawImage(playlist_icon, icon_x, icon_y, icon_w, icon_h, 0, 0, icon_w, icon_h, 0, 255);
							} else var rh = 0;

                            // fields
                            var track_name_part = this.rows[i].name;
                            var track_total_part = plman.PlaylistItemCount(this.rows[i].idx);
                            
                            cColumns.track_name_part = gr.CalcTextWidth(track_name_part, font) + 15;
							if(properties.drawItemsCounter && this.rows[i].idx !=-1)
								cColumns.track_total_part = gr.CalcTextWidth(track_total_part, font);
							else cColumns.track_total_part = 0;
							
                            var tx = ax + rh + this.paddingLeft + 4;
                            var tw = aw;
                            
                            if(this.inputboxID == i) {
                                this.inputbox.draw(gr, tx+2, ay+5);
                            } else {
                                gr.gdiDrawText(track_name_part, font, g_color_normal_txt, tx, ay, aw - tx - cColumns.track_total_part - this.paddingRight - 5, ah, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_END_ELLIPSIS | DT_NOPREFIX);
								if(properties.drawItemsCounter)
                                gr.gdiDrawText(track_total_part, g_font.min2, g_color_faded_txt, ax + aw - cColumns.track_total_part - this.paddingRight, ay, cColumns.track_total_part, ah, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_END_ELLIPSIS | DT_NOPREFIX);
                            };
                        };
                    };
                };
			} 
			if((properties.showNewPlaylistButton && this.rows.length <= 1) || (!properties.showNewPlaylistButton && this.rows.length == 0)) {
				if(g_first_populate_done){ // no playlist, manager panel is empty
						var px = 0;
						var line_width = Math.min(150,Math.round(this.w-40));					
						var py = this.y + properties.rowHeight + Math.round(this.h  / 2)-1 - wh * 0.1;
						if(g_filterbox.inputbox.text!='') {
							var text1 = "No items";
							var text2 = "matching";											
						} else {
							var text1 = "";
							var text2 = "Nothing seleted";											
						}
						if(text1!='') {
							gr.gdiDrawText(text1, g_font.plus5, g_color_normal_txt, this.x, py - 40, this.w, 36, DT_CENTER | DT_BOTTOM | DT_CALCRECT | DT_END_ELLIPSIS | DT_NOPREFIX);
							gr.FillSolidRect(this.x+Math.round(this.w/2-line_width/2),py, line_width, 1, border_color);
							gr.gdiDrawText(text2, g_font.italicplus1, g_color_faded_txt, this.x, py + 6, this.w, 20, DT_CENTER | DT_TOP | DT_CALCRECT | DT_END_ELLIPSIS | DT_NOPREFIX);
						} else {
							gr.gdiDrawText(text2, g_font.italicplus1, g_color_faded_txt, this.x, py - 10, this.w, 20, DT_CENTER | DT_VCENTER | DT_CALCRECT | DT_END_ELLIPSIS | DT_NOPREFIX);						
						}
				} else { // no track, playlist is empty
						var px = 0;
						var line_width = Math.min(150,Math.round(this.w-40));
						var py = this.y + Math.round(this.h  / 2)-1;
						gr.gdiDrawText("Loading...", g_font.plus5, g_color_normal_txt, this.x, py - 40, this.w, 36, DT_CENTER | DT_BOTTOM | DT_CALCRECT | DT_END_ELLIPSIS | DT_NOPREFIX);
						gr.FillSolidRect(this.x+Math.round(this.w/2-line_width/2),py, line_width, 1, border_color);						
						gr.gdiDrawText("Playlists manager", g_font.italicplus1, g_color_faded_txt, this.x, py + 6, this.w, 20, DT_CENTER | DT_TOP | DT_CALCRECT | DT_END_ELLIPSIS | DT_NOPREFIX);
				}
			}
			// draw bottom gradient
			gr.FillGradRect(0, wh-fading_bottom_height+2, ww, fading_bottom_height, 90, grad_bottom_color2,  grad_bottom_color1,1);				 
			 
            // draw header
            if(properties.showHeaderBar) {
                var boxText = this.rows.length+" playlist"+(this.rows.length>1?"s  ":"  ");

                gr.FillSolidRect(this.x, 0, this.w - this.x -1, properties.headerBarHeight, headerbar_bgcolor);
                gr.FillSolidRect(this.x, properties.headerBarHeight, this.w - this.x -1, 1, headerbar_line_maincolor);
				
				if(g_filterbox.inputbox.text.length==0) {
					var text_width = gr.CalcTextWidth(boxText,g_font.plus1)
					var tx = cFilterBox.x + cFilterBox.w + Math.round(22 * g_zoom_percent / 100) + 5 - text_width;
					
					var tw = this.w - tx - 6;
					try {
						gr.gdiDrawText(boxText, g_font.min1, g_color_faded_txt, tx, properties.headerBarPaddingTop, tw, properties.headerBarHeight-properties.headerBarPaddingTop, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_END_ELLIPSIS);
					} catch(e) {console.log(e)};
				}
            };
			
			
			// draw scrollbar
			if(cScrollBar.enabled)  {
				brw.scrollbar && brw.scrollbar.draw(gr);
			};			
			gr.FillSolidRect(ww-1, 0, 1, wh, rightline_color);
        };
    };
        
    this._isHover = function(x, y) {
        return (x >= this.x && x <= this.x + this.w && y >= this.y && y <= this.y + this.h);
    };
	
    this.activateItem = function(index) {
        if(this.groups.length == 0) return;
        this.selectedIndex = index;
    };    
	
    this.on_mouse = function(event, x, y) {
        this.ishover = this._isHover(x, y);
		this.is_hover_scrollbar = this.scrollbar._isHover(x, y);
        // get hover row index (mouse cursor hover)
        this.activeRow = -1;	
		//isHoverCreatePlaylist = (y>properties.headerBarHeight && y<properties.headerBarHeight+properties.rowHeight && properties.showNewPlaylistButton);
		if(this.ishover && !this.is_hover_scrollbar) {				 
			if(y > this.y && y < this.y + this.h) {
				this.activeRow = Math.ceil((y + scroll_ - this.y) / properties.rowHeight - 1);	
				if(this.activeRow >= this.rows.length) this.activeRow = -1;
			}
		}
        if(brw.activeRow != brw.activeRowSaved){ //|| isHoverCreatePlaylistSaved != isHoverCreatePlaylist) {
            brw.activeRowSaved = brw.activeRow;
			//isHoverCreatePlaylistSaved = isHoverCreatePlaylist;
            this.repaint();
        };                

        switch(event) {
            case "down":
				this.down = true;
				if(cScrollBar.enabled && cScrollBar.visible && this.scrollbar._isHover(x, y)) {
					this.scrollbar && this.scrollbar.on_mouse(event, x, y);
				} else {				
					if(!cTouch.down && !timers.mouseDown && this.ishover && this.activeRow > -1 && Math.abs(scroll - scroll_) < 2) {
						this.selectedRow = this.activeRow;
						if(properties.showNewPlaylistButton && this.rows[this.activeRow].idx ==-1 && !avoidDbleClick){						
							avoidDbleClick = true;
							var total = plman.PlaylistCount;
							if(CreatePlaylist(total, "")){
								plman.MovePlaylist(total, total);
								plman.ActivePlaylist = total;
							}	
							window.SetCursor(IDC_ARROW);
							avoidDbleClickTimer = window.SetTimeout(function() {
								window.ClearTimeout(avoidDbleClickTimer);
								avoidDbleClick = false;
							}, 200);						
						}							
						else if(plman.ActivePlaylist != this.rows[this.activeRow].idx) {
							if(this.inputboxID > -1) this.inputboxID = -1;
							this.repaint();
							plman.ActivePlaylist = this.rows[this.activeRow].idx;
							cPlaylistManager.playlist_switch_pending = true;
							//window.SetCursor(IDC_WAIT);
						} else if(this.activeRow == this.inputboxID) {
							this.inputbox.check("down", x, y);
						} else {
							if(this.inputboxID > -1) this.inputboxID = -1;
							//if(this.selectedRow == this.rows[this.activeRow].idx) {
							if(!this.up) {
								// set dragged item to reorder list
								cPlaylistManager.drag_clicked = true;
								cPlaylistManager.drag_x = x;
								cPlaylistManager.drag_y = y;
								cPlaylistManager.drag_source_id = this.selectedRow;
							};
							//};
						};
						this.repaint();
					} else {
						/*if(isHoverCreatePlaylist && !avoidDbleClick){						
							avoidDbleClick = true;
							var total = plman.PlaylistCount;
							if(CreatePlaylist(total, "")){
								plman.MovePlaylist(total, total);
								plman.ActivePlaylist = total;
							}	
							window.SetCursor(IDC_ARROW);
							avoidDbleClickTimer = window.SetTimeout(function() {
								window.ClearTimeout(avoidDbleClickTimer);
								avoidDbleClick = false;
							}, 200);						
						}	*/
						if(this.inputboxID > -1) this.inputboxID = -1;
						// scrollbar
						if(cScrollBar.enabled && cScrollBar.visible) {
							this.scrollbar && this.scrollbar.on_mouse(event, x, y);
						};
					};
				}
				this.up = false;
                break;
            case "up":
                this.up = true;
                if(this.down) {
                    // scrollbar
                    if(cScrollBar.enabled && cScrollBar.visible) {
                        brw.scrollbar && brw.scrollbar.on_mouse(event, x, y);
                    };
                    
                    if(this.inputboxID >= 0) {
                        this.inputbox.check("up", x, y);
                    } else {
                        // drop playlist switch
                        if(cPlaylistManager.drag_target_id > -1) {
                            if(cPlaylistManager.drag_target_id != cPlaylistManager.drag_source_id) {
                                cPlaylistManager.drag_droped = true
                                if(cPlaylistManager.drag_target_id < cPlaylistManager.drag_source_id) {
                                    plman.MovePlaylist(this.rows[cPlaylistManager.drag_source_id].idx, this.rows[cPlaylistManager.drag_target_id].idx);
                                } else if(cPlaylistManager.drag_target_id > cPlaylistManager.drag_source_id) {
                                    plman.MovePlaylist(this.rows[cPlaylistManager.drag_source_id].idx, this.rows[cPlaylistManager.drag_target_id].idx);
                                };
                            };
                            this.selectedRow = cPlaylistManager.drag_target_id;
                        };
                    };
                    
                    if(timers.movePlaylist) {
                        timers.movePlaylist && window.ClearInterval(timers.movePlaylist);
                        timers.movePlaylist = false;
                    };
                };
                
                this.down = false;
                
                if(cPlaylistManager.drag_moved) window.SetCursor(IDC_ARROW);
                
                cPlaylistManager.drag_clicked = false;
                cPlaylistManager.drag_moved = false;
                cPlaylistManager.drag_source_id = -1;
                cPlaylistManager.drag_target_id = -1;
                cPlaylistManager.drag_x = -1;
                cPlaylistManager.drag_y = -1;
                break;
            case "dblclk":  //browser dblclk
			
                if(this.ishover && this.activeRow > -1 && Math.abs(scroll - scroll_) < 2) {
                    /*if(plman.ActivePlaylist != this.rows[this.activeRow].idx) {
                        if(this.inputboxID > -1) this.inputboxID = -1;
                        this.repaint();
                        plman.ActivePlaylist = this.rows[this.activeRow].idx;
                        cPlaylistManager.playlist_switch_pending = true;
                        window.SetCursor(IDC_WAIT);
                    };*/
					plman.ExecutePlaylistDefaultAction(this.rows[this.activeRow].idx,0);
                } else {
                    // scrollbar
                    if(cScrollBar.enabled && cScrollBar.visible && brw.scrollbar._isHover) {
                        brw.scrollbar && brw.scrollbar.on_mouse(event, x, y);
                    } else {
						var total = plman.PlaylistCount;
						if(CreatePlaylist(total, ""))
							plman.ActivePlaylist = total;	
						window.SetCursor(IDC_ARROW);
					}
                };
                break;
            case "move":
                this.up = false;
                if(this.inputboxID >= 0) {
                    this.inputbox.check("move", x, y);
                } else {
                    if(cPlaylistManager.drag_clicked && (Math.abs(cPlaylistManager.drag_x-x)>10 || Math.abs(cPlaylistManager.drag_y-y)>10)) {
                        cPlaylistManager.drag_moved = true;
						window.SetCursor(IDC_HELP);
                    };
                    if(cPlaylistManager.drag_moved) {
                        if(this.activeRow > -1) {
							if(properties.showNewPlaylistButton && this.rows[this.activeRow].idx ==-1) this.activeRow=this.activeRow+1							
                            if(timers.movePlaylist) {
                                timers.movePlaylist && window.ClearInterval(timers.movePlaylist);
                                timers.movePlaylist = false;
                            };
                            if(this.activeRow != cPlaylistManager.drag_source_id) {
                                if(this.activeRow != cPlaylistManager.drag_source_id) {
                                    cPlaylistManager.drag_target_id = this.activeRow;
                                };
                            } else if(y > this.rows[this.rowsCount - 1].y + properties.rowHeight && y < this.rows[this.rowsCount - 1].y + properties.rowHeight*2) {
                                cPlaylistManager.drag_target_id = this.rowsCount;
                            } else {
                                cPlaylistManager.drag_target_id = -1;
                            };						
                        } else {						
                            if(y < this.y) {
                                if(!timers.movePlaylist) {
                                    timers.movePlaylist = window.SetInterval(function() {
                                        scroll -= properties.rowHeight;
                                        scroll = check_scroll(scroll);
										if(properties.showNewPlaylistButton)
											cPlaylistManager.drag_target_id = cPlaylistManager.drag_target_id > 1 ? cPlaylistManager.drag_target_id - 1 : 1;
										else
											cPlaylistManager.drag_target_id = cPlaylistManager.drag_target_id > 0 ? cPlaylistManager.drag_target_id - 1 : 0;											
                                    }, 100);
                                }
                            } else if (y > this.y + this.h) {
                                if(!timers.movePlaylist) {
                                    timers.movePlaylist = window.SetInterval(function() {
                                        scroll += properties.rowHeight;
                                        scroll = check_scroll(scroll);
                                        cPlaylistManager.drag_target_id = cPlaylistManager.drag_target_id < this.rowsCount - 1 ? cPlaylistManager.drag_target_id + 1 : this.rowsCount - 1;
                                    }, 100);
                                }
                            };
                        };
                        brw.repaint();
                    };
                };

                // scrollbar
                if(cScrollBar.enabled && cScrollBar.visible) {
                    brw.scrollbar && brw.scrollbar.on_mouse(event, x, y);
                };
                break;
            case "right":
				g_rightClickedIndex = this.activeRow;
                if(this.inputboxID >= 0) {
                    this.inputbox.check("bidon", x, y);
                    if(!this.inputbox.hover) {
                        this.inputboxID = -1;
                        this.on_mouse("right", x, y);
                    } else {
                        this.inputbox.check("right", x, y);
                    };
                } else {            
                    if(this.ishover) {
                        if(this.activeRow > -1 && Math.abs(scroll - scroll_) < 2) {
                            if(!utils.IsKeyPressed(VK_SHIFT)) {
                                this.repaint();
                                this.selectedRow = this.activeRow;
                                //plman.ActivePlaylist = this.rows[this.activeRow].idx;
                               // if(!timers.rightClick) {
                                   // timers.rightClick = window.SetTimeout(function() {
                                        brw.context_menu(x, y, brw.selectedRow);
                                   //     timers.rightClick && window.ClearTimeout(timers.rightClick);
                                   //     timers.rightClick = false;
                                  //  },50);
                               // };
                            };
                            this.repaint();
                        } else {
                            this.context_menu(x, y, this.activeRow);
                        };
                    } else {
                        // scrollbar
                        if(cScrollBar.enabled && cScrollBar.visible) {
                            brw.scrollbar && brw.scrollbar.on_mouse(event, x, y);
                        };
                        // settings menu
                        if(!g_filterbox.inputbox.hover) {
                            this.context_menu(x, y);
                        };
                    };
					g_rightClickedIndex = -1;
                };
                break;
            case "wheel":
				//browser mouse event
                break;
            case "leave":
                // scrollbar
                if(cScrollBar.enabled && cScrollBar.visible) {
                    this.scrollbar && this.scrollbar.on_mouse(event, 0, 0);
                };
                break;
            case "drag_over":
				if(timers.movePlaylist) {
					timers.movePlaylist && window.ClearInterval(timers.movePlaylist);
					timers.movePlaylist = false;
				}			
                if(this.rows.length > 0) {
                    if(y > brw.y) {
                        if(this.activeRow > -1) {
                            if(this.rows[this.activeRow].isAutoPlaylist) {
                                g_dragndrop_targetPlaylistId = this.activeRow
                            } else {
                                g_dragndrop_targetPlaylistId = this.activeRow;
                            };
                        } else {
                            g_dragndrop_targetPlaylistId = -1;
                        };
                    };
					if(cScrollBar.visible){
						drag_scroll_zone_height = properties.rowHeight/3
						if(y < this.y+drag_scroll_zone_height) {
							if(!timers.movePlaylist) {
								timers.movePlaylist = window.SetInterval(function() {
									scroll -= properties.rowHeight;
									scroll = check_scroll(scroll);										
								}, 100);
							}
						} else if (y > this.y + this.h-drag_scroll_zone_height) {
							if(!timers.movePlaylist) {
								timers.movePlaylist = window.SetInterval(function() {
									scroll += properties.rowHeight;
									scroll = check_scroll(scroll);
								}, 100);
							}
						};			
					}
                } else {
                    g_dragndrop_bottom = true;
                    g_dragndrop_trackId = 0;
                    g_dragndrop_rowId = 0;
                };
                break;
        }
    }
    this.setRowHeight = function(step){	
		var zoomStep = 1;
		var previous = properties.defaultRowHeight;
		step = step*-1;
		if(!timers.mouseWheel) {
			properties.defaultRowHeight -= step * zoomStep;
			if(properties.defaultRowHeight < 20) properties.defaultRowHeight = 20;
			if(properties.defaultRowHeight > 450) properties.defaultRowHeight = 450;
			if(previous != properties.defaultRowHeight) {
				timers.mouseWheel = window.SetTimeout(function() {
					window.SetProperty("PROPERTY: Row Height", properties.defaultRowHeight);
					CollectGarbage();
					get_metrics();
					brw.repaint();
					timers.mouseWheel && window.ClearTimeout(timers.mouseWheel);
					timers.mouseWheel = false;
				}, 100)
			}
		}
    }
	this.resetTimer = function(){
		if(this.g_time) {
			window.ClearInterval(this.g_time);
			this.g_time = false;
		};
	}
	this.startTimer = function(){
		this.resetTimer();
		try{
			this.timerStartTime = Date.now();
		}catch(e){}
		brw.timerCounter = 0;
		this.g_time = window.SetInterval(function() {
			brw.timerCounter++;
			//Restart if the animation is desyncronised
			try{				
				if(Math.abs(brw.timerStartTime+brw.timerCounter*properties.refreshRate-Date.now())>500){
					brw.startTimer();
				}	
			}catch(e){}							
			brw.timerScript();
		}, properties.refreshRate);	
	}
    this.timerScript = function() {
		
        if(!window.IsVisible) {
            window_visible = false;
            return;
        };
        var repaint_1 = false;

		
        if(!window_visible){
            window_visible = true;
        };
        
        if(!g_first_populate_launched) {
            g_first_populate_launched = true;
            brw.launch_populate();
        };
        		
		
        // get hover row index (mouse cursor hover)
        /* if(m_y > brw.y && m_y < brw.y + brw.h) {
            brw.activeRow = Math.ceil((m_y + scroll_ - brw.y ) / properties.rowHeight - 1);
            if(brw.activeRow >= brw.rows.length) brw.activeRow = -1;
        } else {
            brw.activeRow = -1;
        }; */

        if(repaint_main1 == repaint_main2){
            repaint_main2 = !repaint_main1;
            repaint_1 = true;
        };

        scroll = check_scroll(scroll);
        if(Math.abs(scroll - scroll_) >= 1){
            scroll_ += (scroll - scroll_) / properties.scrollSmoothness;
            repaint_1 = true;
            isScrolling = true;
            //
            if(scroll_prev != scroll) brw.scrollbar.updateScrollbar();
        } else {
            if(isScrolling) {
                if(scroll_< 1) scroll_ = 0;
                isScrolling = false;
                repaint_1 = true;
            };
        };

        if(repaint_1){
            if(brw.rows.length > 0) brw.getlimits();
            repaintforced = true;
            repaint_main = true;
            window.Repaint();
        };
        
        scroll_prev = scroll;
        
        // tweak to fix bug in timer/memory/repaint handle in WSH Panel Mod with timers
        g_counter_repaint++;
        if(g_counter_repaint > 250) {
            g_counter_repaint = 0;
            CollectGarbage();
        };
        
    }

	this.context_menu = function(x, y, id) {
        var MF_SEPARATOR = 0x00000800;
        var MF_STRING = 0x00000000;
        var _menu = window.CreatePopupMenu();
        var _newplaylist = window.CreatePopupMenu();
        var _autoplaylist = window.CreatePopupMenu();
        var idx;
        var total_area, visible_area;
        var bout, z;
        var add_mode = (id == null || id < 0);
        var total = plman.PlaylistCount;

		_menu.AppendMenuItem(MF_STRING, 1, "Settings...");	
		_menu.AppendMenuSeparator();		
		
        if(!add_mode) {
            var pl_idx = this.rows[id].idx; 
            _newplaylist.AppendTo(_menu, (g_filterbox.inputbox.text.length > 0 ? MF_GRAYED | MF_DISABLED : MF_STRING), "Insert ...");
        } else {
            id = this.rowsCount;
            var pl_idx = total;
            _newplaylist.AppendTo(_menu, (g_filterbox.inputbox.text.length > 0 ? MF_GRAYED | MF_DISABLED : MF_STRING), "Add ...");
        };
        _newplaylist.AppendMenuItem(MF_STRING, 100, "New Playlist");
        _newplaylist.AppendMenuItem(MF_STRING, 101, "New Autoplaylist");
        _autoplaylist.AppendTo(_newplaylist, MF_STRING, "Preset Playlists");
        //_autoplaylist.AppendMenuItem(MF_STRING, 200, "Media Library (full)");
        _autoplaylist.AppendMenuItem(MF_STRING, 205, "History (tracks played in the last weeks)");
        _autoplaylist.AppendMenuItem(MF_STRING, 206, "Most Played tracks");    
        _autoplaylist.AppendMenuItem(MF_STRING, 207, "Top Rated tracks");   		
        _autoplaylist.AppendMenuItem(MF_STRING, 210, "Newly added tracks");
		_autoplaylist.AppendMenuItem(MF_SEPARATOR, 0, "");		
        _autoplaylist.AppendMenuItem(MF_STRING, 211, "Radios");
        _autoplaylist.AppendMenuItem(MF_STRING, 212, "External Files");
        _autoplaylist.AppendMenuItem(MF_STRING, 213, "Podcasts");
        //_autoplaylist.AppendMenuItem(MF_SEPARATOR, 0, "");
        //_autoplaylist.AppendMenuItem(MF_STRING, 250, "Loved Tracks");
        _menu.AppendMenuItem(MF_SEPARATOR, 0, "");
        _menu.AppendMenuItem(MF_STRING, 2, "Load a Playlist");
        if(!add_mode) {
            _menu.AppendMenuItem(MF_STRING, 4, "Save this Playlist");
            _menu.AppendMenuItem(MF_SEPARATOR, 0, "");
            _menu.AppendMenuItem(MF_STRING, 5, "Duplicate this playlist");

            _menu.AppendMenuItem(MF_STRING, 3, "Rename this playlist");
            _menu.AppendMenuItem(MF_STRING, 8, "Delete this playlist");


            if(plman.IsAutoPlaylist(this.rows[id].idx)) {
                _menu.AppendMenuItem(MF_SEPARATOR, 0, "");
                _menu.AppendMenuItem(MF_STRING, 6, "Autoplaylist properties...");
                _menu.AppendMenuItem(MF_STRING, 7, "Convert to a normal playlist");
            };

        };
	
        idx = _menu.TrackPopupMenu(x, y);

        switch (true) {
		case (idx==1):
			//window.ShowProperties();
			this.settings_context_menu(x, y);
			break;	
        case (idx==100):
			if(CreatePlaylist(total, "")){
				plman.MovePlaylist(total, pl_idx);
				plman.ActivePlaylist = pl_idx;
			}	
			window.SetCursor(IDC_ARROW);			
            /*plman.CreatePlaylist(total, "");
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;
            // set rename it
            var rh = properties.rowHeight - 10;
            var tw = this.w - rh - 20;
            this.inputbox = new oInputbox(tw, rh, plman.GetPlaylistName(pl_idx), "", g_color_normal_txt, g_color_normal_bg, g_color_normal_txt, g_color_selected_bg & 0xd0ffffff, "renamePlaylist()", "brw");
            this.inputbox.setSize(tw, rh, g_fsize+1); // set font_size
            this.inputboxID = id;
            // activate inputbox for edit
            this.inputbox.on_focus(true);
            this.inputbox.edit = true;
            this.inputbox.Cpos = this.inputbox.text.length;
            this.inputbox.anchor = this.inputbox.Cpos;
            this.inputbox.SelBegin = this.inputbox.Cpos;
            this.inputbox.SelEnd = this.inputbox.Cpos;
            if(!cInputbox.timer_cursor) {
                this.inputbox.resetCursorTimer();
            };
            this.inputbox.dblclk = true;
            this.inputbox.SelBegin = 0;
            this.inputbox.SelEnd = this.inputbox.text.length;
            this.inputbox.text_selected = this.inputbox.text;
            this.inputbox.select = true;*/			
            this.repaint();
            break;
        case (idx==101):
            var total = plman.PlaylistCount;
            g_avoid_on_playlists_changed = true;
			plman.CreatePlaylist(total, "");
			var new_label = plman.GetPlaylistName(total);
			plman.RemovePlaylist(total);
            g_avoid_on_playlists_changed = false;
			
			if(CreateAutoPlaylist(total, new_label, "enter your query here")){
				plman.MovePlaylist(total, pl_idx);
				plman.ActivePlaylist = pl_idx;
			}						
			window.SetCursor(IDC_ARROW);
            /*plman.CreateAutoPlaylist(total, new_label, "enter your query here", "", 0);
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;
            plman.ShowAutoPlaylistUI(pl_idx);
            // set rename it
            var rh = properties.rowHeight - 10;
            var tw = this.w - rh - 20;
            this.inputbox = new oInputbox(tw, rh, plman.GetPlaylistName(pl_idx), "", g_color_normal_txt, g_color_normal_bg, g_color_normal_txt, g_color_selected_bg & 0xd0ffffff, "renamePlaylist()", "brw");
            this.inputbox.setSize(tw, rh, g_fsize+1); // set font_size
            this.inputboxID = id;
            // activate inputbox for edit
            this.inputbox.on_focus(true);
            this.inputbox.edit = true;
            this.inputbox.Cpos = this.inputbox.text.length;
            this.inputbox.anchor = this.inputbox.Cpos;
            this.inputbox.SelBegin = this.inputbox.Cpos;
            this.inputbox.SelEnd = this.inputbox.Cpos;
            if(!cInputbox.timer_cursor) {
                this.inputbox.resetCursorTimer();
            };
            this.inputbox.dblclk = true;
            this.inputbox.SelBegin = 0;
            this.inputbox.SelEnd = this.inputbox.text.length;
            this.inputbox.text_selected = this.inputbox.text;
            this.inputbox.select = true; */
            this.repaint();
            break;
        case (idx==2):
            fb.RunMainMenuCommand("File/Load Playlist...");
            break;
        case (idx==3):
			playlistname = InputBox("Rename the playlist: "+plman.GetPlaylistName(pl_idx), "Rename a playlist", plman.GetPlaylistName(pl_idx));
			if(!playlistname || playlistname == "") playlistname = plman.GetPlaylistName(pl_idx);
			if (playlistname.length > 1 || (playlistname.length == 1 && (playlistname >= "a" && playlistname <= "z") || (playlistname >= "A" && playlistname <= "Z") || (playlistname >= "0" && playlistname <= "9"))) {
				//mytab[index].tabname = playlistname;
				plman.RenamePlaylist(pl_idx, playlistname);
				window.Repaint();
			}		
            // set rename it
			/*
            var rh = properties.rowHeight - 10;
            var tw = this.w - rh - 10;
            this.inputbox = new oInputbox(tw, rh, plman.GetPlaylistName(pl_idx), "", g_color_normal_txt, g_color_normal_bg, g_color_normal_txt, g_color_selected_bg & 0xd0ffffff, "renamePlaylist()", "brw");
            this.inputbox.setSize(tw, rh, g_fsize+1); // set font_size
            this.inputboxID = id;
            // activate inputbox for edit
            this.inputbox.on_focus(true);
            this.inputbox.edit = true;
            this.inputbox.Cpos = this.inputbox.text.length;
            this.inputbox.anchor = this.inputbox.Cpos;
            this.inputbox.SelBegin = this.inputbox.Cpos;
            this.inputbox.SelEnd = this.inputbox.Cpos;
            if(!cInputbox.timer_cursor) {
                this.inputbox.resetCursorTimer();
            };
            this.inputbox.dblclk = true;
            this.inputbox.SelBegin = 0;
            this.inputbox.SelEnd = this.inputbox.text.length;
            this.inputbox.text_selected = this.inputbox.text;
            this.inputbox.select = true; */
            this.repaint();
            break;
        case (idx==4):
            fb.RunMainMenuCommand("File/Save Playlist...");
            break;
        case (idx==5):
            plman.DuplicatePlaylist(pl_idx, "Copy of " + plman.GetPlaylistName(pl_idx));
            plman.ActivePlaylist = pl_idx + 1;
            break;
        case (idx==6):
            plman.ShowAutoPlaylistUI(pl_idx);
            break;
        case (idx==7):
            plman.DuplicatePlaylist(pl_idx, plman.GetPlaylistName(pl_idx));
            plman.RemovePlaylistSwitch(pl_idx);
            //plman.ActivePlaylist = pl_idx;
            break;
        case (idx==8):
            if(brw.rowsCount > 0) {
				DeletePlaylist(pl_idx);
                /*if(!this.delete_pending && !timers.deletePlaylist) {
                    this.delete_pending = true;
                    timers.deletePlaylist = window.SetTimeout(function(){
                        timers.deletePlaylist && window.ClearTimeout(timers.deletePlaylist);
                        timers.deletePlaylist = false;
                    }, 150);
                    //
                    var updateActivePlaylist = (this.selectedRow == plman.ActivePlaylist);
                    var id = this.selectedRow;
                    var row = this.getRowIdFromIdx(id);
                    plman.RemovePlaylistSwitch(id);
                        if(row < this.rowsCount - 1) {
                            this.selectedRow = id;
                        } else if(row > 0) {
                            this.selectedRow = id - 1;
                        };
                    if(updateActivePlaylist) {
                        if(row < this.rowsCount - 1) {
                            plman.ActivePlaylist = id;
                        } else if(row > 0) {
                            plman.ActivePlaylist = id - 1;
                        };
                    };
                };*/
            };
            break;
        case (idx==200):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreateAutoPlaylist(total, "Media Library", "ALL", "%album artist% | $if(%album%,%date%,'9999') | %album% | %discnumber% | %tracknumber% | %title%", 0);
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;
        case (idx==205):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreateAutoPlaylist(total, "History", "%last_played% DURING LAST 1 WEEK SORT DESCENDING BY %last_played%", "",1);
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;
        case (idx==206):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreateAutoPlaylist(total, "Most Played", "%play_count% GREATER 2 SORT DESCENDING BY %play_count%", "", 1);
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;
        case (idx==207):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreateAutoPlaylist(total, "Top Rated", "%rating% GREATER 1 SORT DESCENDING BY %rating%", "", 1);
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;			
        case (idx==210):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreateAutoPlaylist(total, "Newly Added", "%added% DURING LAST 12 WEEKS SORT DESCENDING BY %added%", "",1);
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;
        case (idx==211):
            var total = plman.PlaylistCount;
            //brw.inputboxID = -1;
            plman.CreatePlaylist(total, "Radios");
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;
        case (idx==212):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreatePlaylist(total, "External Files");
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;
        case (idx==213):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreatePlaylist(total, "Podcasts");
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;  
            break;
        case (idx==250):
            var total = plman.PlaylistCount;
            //p.playlistManager.inputboxID = -1;
            plman.CreateAutoPlaylist(total, "Loved Tracks", "%mood% GREATER 0", "%album artist% | $if(%album%,%date%,'9999') | %album% | %discnumber% | %tracknumber% | %title%", 0);
            plman.MovePlaylist(total, pl_idx);
            plman.ActivePlaylist = pl_idx;
            break;
        };
        _autoplaylist.Dispose();
        _newplaylist.Dispose();    
		_menu.Dispose();
        g_rbtn_click = false;
        brw.repaint();
		return true;
	};
    
    this.settings_context_menu = function(x, y) {
        var _menu = window.CreatePopupMenu();
        var _menu1 = window.CreatePopupMenu();
        var _menu2 = window.CreatePopupMenu();
		var _menu2A = window.CreatePopupMenu();
        var _menu3 = window.CreatePopupMenu();
        var _rowHeight = window.CreatePopupMenu();		
		
        var idx;
		
        _menu.AppendMenuItem(MF_GRAYED, 0, "Display :");				
        _menu.AppendMenuSeparator();

        _menu.AppendMenuItem(MF_STRING, 910, "Search bar");
        _menu.CheckMenuItem(910, properties.showHeaderBar);           
        _menu.AppendMenuItem(MF_STRING, 911, "Create Playlist Button");
        _menu.CheckMenuItem(911, properties.showNewPlaylistButton);   		
		
		_menu.AppendMenuItem(MF_STRING, 912, "Items count");
		_menu.CheckMenuItem(912, properties.drawItemsCounter);	
		
		_menu.AppendMenuItem(MF_STRING, 913, "Playlists Icons");
		_menu.CheckMenuItem(913, properties.showPlaylistIcons);			
		
		_menu.AppendMenuSeparator();
		
		_rowHeight.AppendMenuItem(MF_STRING, 1000, "Increase");
		_rowHeight.AppendMenuItem(MF_STRING, 1001, "Decrease");	
		_rowHeight.AppendMenuSeparator();
		_rowHeight.AppendMenuItem(MF_DISABLED, 0, "Tip: Hold SHIFT and use your");
		_rowHeight.AppendMenuItem(MF_DISABLED, 0, "mouse wheel over the panel!");			
		_rowHeight.AppendTo(_menu,MF_STRING, "Row height");		
		
		_menu2.AppendMenuItem(MF_STRING, 200, "Enable");
		_menu2.CheckMenuItem(200, properties.showwallpaper);
		_menu2.AppendMenuItem(MF_STRING, 220, "Blur");
		_menu2.CheckMenuItem(220, properties.wallpaperblurred);
		
		_menu2A.AppendMenuItem(MF_STRING, 221, "Filling");
		_menu2A.CheckMenuItem(221, properties.wallpaperdisplay==0);	
		_menu2A.AppendMenuItem(MF_STRING, 222, "Adjust");
		_menu2A.CheckMenuItem(222, properties.wallpaperdisplay==1);
		_menu2A.AppendMenuItem(MF_STRING, 223, "Stretch");
		_menu2A.CheckMenuItem(223, properties.wallpaperdisplay==2);
		_menu2A.AppendTo(_menu2,MF_STRING, "Wallpaper size");		
		//_menu2.AppendMenuSeparator();
		//_menu2.AppendMenuItem((!properties.showwallpaper ? MF_GRAYED | MF_DISABLED : MF_STRING), 210, "Default");
		//_menu2.AppendMenuItem((!properties.showwallpaper ? MF_GRAYED | MF_DISABLED : MF_STRING), 211, "Playing Album Cover");
		//_menu2.CheckMenuRadioItem(210, 211, properties.wallpapermode == 0 ? 211 : 210);

		_menu2.AppendTo(_menu,MF_STRING, "Background Wallpaper");		
		
        //_menu.AppendMenuSeparator();
        //_menu.AppendMenuItem(MF_STRING, 991, "Panel Properties");
        //_menu.AppendMenuItem(MF_STRING, 992, "Configure...");
        
        idx = _menu.TrackPopupMenu(x,y);
        
        switch(true) {
			case (idx == 200):
				toggleWallpaper();
				break;
			case (idx == 210):
				properties.wallpapermode = 99;on_colours_changed();		
				window.SetProperty("_SYSTEM: Wallpaper Mode", properties.wallpapermode);
				if(fb.IsPlaying) g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				brw.repaint();
				break;
			case (idx == 211):
				properties.wallpapermode = 0;on_colours_changed();		
				window.SetProperty("_SYSTEM: Wallpaper Mode", properties.wallpapermode);
				if(fb.IsPlaying) g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				brw.repaint();
				break;
			case (idx == 220):
				properties.wallpaperblurred = !properties.wallpaperblurred;on_colours_changed();		
				window.SetProperty("_DISPLAY: Wallpaper Blurred", properties.wallpaperblurred);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				brw.repaint();
				break;		
			case (idx == 221):
				properties.wallpaperdisplay = 0;
				window.SetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", properties.wallpaperdisplay);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				brw.repaint();
				break;	
			case (idx == 222):
				properties.wallpaperdisplay = 1;
				window.SetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", properties.wallpaperdisplay);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				brw.repaint();
				break;		
			case (idx == 223):
				properties.wallpaperdisplay = 2;
				window.SetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", properties.wallpaperdisplay);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				brw.repaint();
				break;					
            case (idx == 910):
                properties.showHeaderBar = !properties.showHeaderBar;
                window.SetProperty("DISPLAY: Show Top Bar", properties.showHeaderBar);
                get_metrics();
                brw.repaint();
                break;
            case (idx == 911):
                properties.showNewPlaylistButton = !properties.showNewPlaylistButton;
                window.SetProperty("DISPLAY: Show new playlist button", properties.showNewPlaylistButton);
				brw.populate(true, 3);
                get_metrics();
                brw.repaint();
                break;				
            case (idx == 912):
                properties.drawItemsCounter = !properties.drawItemsCounter;
                window.SetProperty("PROPERTY: Show numbers of items", properties.drawItemsCounter);
                get_metrics();
                brw.repaint();properties.showPlaylistIcons
                break;	
            case (idx == 913):
                properties.showPlaylistIcons = !properties.showPlaylistIcons;
                window.SetProperty("_PROPERTY: show an icon before the playlist name", properties.showPlaylistIcons);
                get_metrics();
                brw.repaint();
                break;					
            case (idx == 991):
                window.ShowProperties();
                break;
            case (idx == 992):
                window.ShowConfigure();
                break;
			case (idx == 1000):
				this.setRowHeight(-2);
				break;	
			case (idx == 1001):
				this.setRowHeight(2);
				break;					
        };
        _menu2.Dispose();
		_menu2A.Dispose();
        _menu1.Dispose();
        _menu.Dispose();
		_rowHeight.Dispose();		
        g_rbtn_click = false;
        return true;
    };
};

/* 
===================================================================================================
    Main
===================================================================================================
*/
var fso = new ActiveXObject("Scripting.FileSystemObject");
var WshShell = new ActiveXObject("WScript.Shell");
var htmlfile = new ActiveXObject('htmlfile');

var brw = null;
var g_1x1 = false;
var g_last = 0;
var isScrolling = false;
var g_zoom_percent = 100;

var g_filterbox = null;
var filter_text = "";

var g_counter_repaint = 0;

// fonts
var g_font_headers = null;
var g_font_group1 = null;
var g_font_group2 = null;
var g_font_rating = null;
var g_font_mood = null;

// drag'n drop from windows system
var g_dragndrop_status = false;
var g_dragndrop_x = -1;
var g_dragndrop_y = -1;
var g_dragndrop_trackId = -1;
var g_dragndrop_rowId = -1;
var g_dragndrop_targetPlaylistId = -1;
//
var ww = 0, wh = 0;
var g_metadb = null;
var g_focus = false;
var foo_playcount = utils.CheckComponent("foo_playcount", true);
clipboard = {
    selection: null
};

var m_x = 0, m_y = 0;
var g_active_playlist = null;
var g_focus_id = -1;
var g_focus_id_prev = -1;
var g_focus_row = 0;
var g_focus_album_id = -1;
var g_populate_opt = 1;
// color vars
var g_color_normal_bg = 0;
var g_color_selected_bg = 0;
var g_color_normal_txt = 0;
var g_color_selected_txt = 0;
var g_color_highlight = 0;
// boolean to avoid callbacks
var g_avoid_on_playlists_changed = false;
var g_avoid_on_item_focus_change = false;
var g_avoid_on_playlist_items_added = false;
var g_avoid_on_playlist_items_removed = false;
var g_avoid_on_playlist_items_removed_callbacks_on_sendItemToPlaylist = false;
var g_avoid_on_playlist_items_reordered = false;
// mouse actions
var g_lbtn_click = false;
var g_rbtn_click = false;
//
var g_first_populate_done = false;
var g_first_populate_launched = false;
//
var repaintforced = false;
var launch_time = fb.CreateProfiler("launch_time");
var form_text = "";
var repaint_main = true, repaint_main1 = true, repaint_main2 = true;
var window_visible = false;
var scroll_ = 0, scroll = 0, scroll_prev = 0;
var time222;
var g_start_ = 0, g_end_ = 0;
var g_last = 0;
var g_seconds = 0;
// START
function on_size() {
    window.DlgCode = 0x0004;
    
    ww = window.Width;
    wh = window.Height;
    
    if(!ww || !wh) {
        ww = 1;
        wh = 1;
    };	
	if(window.IsVisible || first_on_size){
		window.MinWidth = 1;
		window.MinHeight = 1;
		
		// set wallpaper
		if(properties.showwallpaper){
			g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
		} else update_wallpaper = true;
		
		// set Size of browser
		brw.setSize(0, (properties.showHeaderBar ? properties.headerBarHeight + properties.paddingTop: properties.paddingTop), ww, wh - (properties.showHeaderBar ? properties.headerBarHeight + properties.paddingTop: properties.paddingTop));
		update_size = false;
		first_on_size = false;		
	} else update_size = true;		
};
function set_update_function(string){
	if( Update_Required_function.indexOf("brw.populate(true")!=-1) return;
	else if(Update_Required_function.indexOf("brw.populate(false")!=-1) {
		if(string.indexOf("brw.populate(true")!=-1) Update_Required_function=string;
	}
	else Update_Required_function=string;
}
function on_paint(gr) {
	if(update_size) on_size();	
	if(Update_Required_function!="" && window.isVisible) {
		eval(Update_Required_function);
		Update_Required_function = "";
	}      
	
    if(!ww) return;
    
	if(update_wallpaper && properties.showwallpaper && properties.wallpapermode == 0){
		g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
	}		
	
    if(!g_1x1) {		
        // draw background under playlist
		gr.FillSolidRect(0, 0, ww, wh, g_color_normal_bg)
        if(fb.IsPlaying && g_wallpaperImg && properties.showwallpaper) {
            gr.DrawImage(g_wallpaperImg, 0, 0, ww, wh, 0, 0, g_wallpaperImg.Width, g_wallpaperImg.Height);
            gr.FillSolidRect(0, 0, ww, wh, (properties.wallpaperblurred)?wallpaper_overlay_blurred:wallpaper_overlay);
        } else {
            //gr.FillSolidRect(0, 0, ww, wh, g_color_normal_bg);
            if(g_wallpaperImg && properties.showwallpaper) {
                gr.DrawImage(g_wallpaperImg, 0, 0, ww, wh, 0, 0, g_wallpaperImg.Width, g_wallpaperImg.Height);
                gr.FillSolidRect(0, 0, ww, wh, (properties.wallpaperblurred)?wallpaper_overlay_blurred:wallpaper_overlay);
            } else {
                gr.FillSolidRect(0, 0, ww, wh, g_color_normal_bg);
            }
        }
		
        brw && brw.draw(gr);	
		
        if(properties.showHeaderBar) {
            // inputBox
            if(properties.showFilterBox && g_filterbox) {
                if(g_filterbox.inputbox.visible) {
                    g_filterbox.draw(gr, cFilterBox.x, Math.round(properties.headerBarHeight/2-cFilterBox.h/2)-2);
                };
            };
        };
    };

};

function on_mouse_lbtn_down(x, y) {
    g_lbtn_click = true;
    g_rbtn_click = false;
    
    // stop inertia
    if(cTouch.timer) {
        window.ClearInterval(cTouch.timer);
        cTouch.timer = false;
        // stop scrolling but not abrupt, add a little offset for the stop
        if(Math.abs(scroll - scroll_) > properties.rowHeight) {
            scroll = (scroll > scroll_ ? scroll_ + properties.rowHeight : scroll_ - properties.rowHeight);
            scroll = check_scroll(scroll);
        };
    };
    
    var is_scroll_enabled = brw.rowsCount > brw.totalRowsVis;
    if(properties.enableTouchControl && is_scroll_enabled) {
        if(brw._isHover(x, y) && !brw.scrollbar._isHover(x, y)) {
            if(!timers.mouseDown) {
                cTouch.y_prev = y;
                cTouch.y_start = y;
                if(cTouch.t1) {
                    cTouch.t1.Reset();
                } else {
                    cTouch.t1 = fb.CreateProfiler("t1");
                };
                timers.mouseDown = window.SetTimeout(function() {
                    window.ClearTimeout(timers.mouseDown);
                    timers.mouseDown = false;
                    if(Math.abs(cTouch.y_start - m_y) > 015) {
                        cTouch.down = true;
                    } else {
                        brw.on_mouse("down", x, y);
                    };
                },50);
            };
        } else {
            brw.on_mouse("down", x, y);
        };
    } else {
        brw.on_mouse("down", x, y);
    };
    
    // inputBox
    if(properties.showHeaderBar && properties.showFilterBox && g_filterbox.inputbox.visible) {
        g_filterbox.on_mouse("lbtn_down", x, y);
    };
};

function on_mouse_lbtn_up(x, y) {

    // inputBox
    if(properties.showHeaderBar && properties.showFilterBox && g_filterbox.inputbox.visible) {
        g_filterbox.on_mouse("lbtn_up", x, y);
    };
    
    brw.on_mouse("up", x, y);
    
    if(timers.mouseDown) {
        window.ClearTimeout(timers.mouseDown);
        timers.mouseDown = false;
        if(Math.abs(cTouch.y_start - m_y) <= 030) {
            brw.on_mouse("down", x, y);
        };
    };

    // create scroll inertia on mouse lbtn up
    if(cTouch.down) {
        cTouch.down = false;
        cTouch.y_end = y;
        cTouch.scroll_delta = scroll - scroll_;
        //cTouch.y_delta = cTouch.y_start - cTouch.y_end;
        if(Math.abs(cTouch.scroll_delta) > 030 ) {
            cTouch.multiplier = ((1000 - cTouch.t1.Time) / 20);
            cTouch.delta = Math.round((cTouch.scroll_delta) / 030);
            if(cTouch.multiplier < 1) cTouch.multiplier = 1;
            if(cTouch.timer) window.ClearInterval(cTouch.timer);
            cTouch.timer = window.SetInterval(function() {
                scroll += cTouch.delta * cTouch.multiplier;
                scroll = check_scroll(scroll);
                cTouch.multiplier = cTouch.multiplier - 1;
                cTouch.delta = cTouch.delta - (cTouch.delta / 10);
                if(cTouch.multiplier < 1) {
                    window.ClearInterval(cTouch.timer);
                    cTouch.timer = false;
                };
            }, 75);
        };
    };
    
    g_lbtn_click = false;
};

function on_mouse_lbtn_dblclk(x, y, mask) {
    if(y >= brw.y) {    
        brw.on_mouse("dblclk", x, y);	
    } else if(x > brw.x && x < brw.x + brw.w) {
        brw.showActivePlaylist();	
    } 	
};

function on_mouse_rbtn_down(x, y, mask) {
    g_rbtn_click = true;
    
    if(!utils.IsKeyPressed(VK_SHIFT)) {
        // inputBox
        if(properties.showHeaderBar && properties.showFilterBox && g_filterbox.inputbox.visible) {
            g_filterbox.on_mouse("rbtn_down", x, y);
        };

        brw.on_mouse("right", x, y);
    };
};

function on_mouse_rbtn_up(x, y){
    g_rbtn_click = false;
    
    if(!utils.IsKeyPressed(VK_SHIFT)) {
        return;
    };
};

function on_mouse_move(x, y) {
    
    if(m_x == x && m_y == y) return;
	notifyMouseMove(); 		
    // inputBox
    if(!cPlaylistManager.drag_moved) {
        if(properties.showHeaderBar && properties.showFilterBox && g_filterbox.inputbox.visible) {
            g_filterbox.on_mouse("move", x, y);
        };
    };

	if(g_dragndrop_status){
		if(y < brw.y) {
			if(!timers.movePlaylist) {
				timers.movePlaylist = window.SetInterval(function() {
					scroll -= properties.rowHeight;
					scroll = check_scroll(scroll);										
				}, 100);
			}
		} else if (y > brw.y + brw.h) {
			if(!timers.movePlaylist) {
				timers.movePlaylist = window.SetInterval(function() {
					scroll += properties.rowHeight;
					scroll = check_scroll(scroll);
				}, 100);
			}
		};			
	}
	
    if(cTouch.down) {
        cTouch.y_current = y;
        cTouch.y_move = (cTouch.y_current - cTouch.y_prev);
        if(x < brw.w) {
                scroll -= cTouch.y_move;
                cTouch.scroll_delta = scroll - scroll_;
                if(Math.abs(cTouch.scroll_delta) < 030) cTouch.y_start = cTouch.y_current;
                cTouch.y_prev = cTouch.y_current;
        };
    } else {
        brw.on_mouse("move", x, y);
    };

    m_x = x;
    m_y = y;
};

function on_mouse_wheel(step){
	
	if(typeof(stepstrait) == "undefined" || typeof(delta) == "undefined") intern_step = step;
	else intern_step = stepstrait/delta;
	
    if(cTouch.timer) {
        window.ClearInterval(cTouch.timer);
        cTouch.timer = false;
    };
    
    if(utils.IsKeyPressed(VK_CONTROL)) {
        var zoomStep = 1;
        var previous = properties.globalFontAdjustement;
        if(!timers.mouseWheel) {
            /*if(intern_step > 0) {
                properties.globalFontAdjustement += zoomStep;
                if(properties.globalFontAdjustement > 10) properties.globalFontAdjustement = 10;
            } else {
                properties.globalFontAdjustement -= zoomStep;
                if(properties.globalFontAdjustement < -2) properties.globalFontAdjustement = -2;
            };
            if(previous != properties.globalFontAdjustement) {
                timers.mouseWheel = window.SetTimeout(function() {
                    window.SetProperty("DISPLAY: Extra font size value", properties.globalFontAdjustement);
                    get_font();
                    get_metrics();
                    get_images();
                    brw.repaint();
                    timers.mouseWheel && window.ClearTimeout(timers.mouseWheel);
                    timers.mouseWheel = false;
                }, 100);
            };*/
        };
    } else if(utils.IsKeyPressed(VK_SHIFT)) { // increase/decrease row height
		brw.setRowHeight(intern_step);
    } else if(cScrollBar.visible) {
        var rowStep = properties.rowScrollStep;
        scroll -= intern_step * properties.rowHeight * rowStep;
        scroll = check_scroll(scroll);
        brw.on_mouse("wheel", m_x, m_y, intern_step);
    };
    
};

function on_mouse_leave() {
    // inputBox
    if(properties.showHeaderBar && properties.showFilterBox && g_filterbox.inputbox.visible) {
        g_filterbox.on_mouse("leave", 0, 0);
    };
    brw.on_mouse("leave", 0, 0);
};

//=================================================// Metrics & Fonts & Colors & Images
function get_metrics() {
    if(properties.showHeaderBar) {
        properties.headerBarHeight = Math.round(properties.defaultHeaderBarHeight * g_zoom_percent / 100);
        properties.headerBarHeight = Math.floor(properties.headerBarHeight / 2) != properties.headerBarHeight / 2 ? properties.headerBarHeight : properties.headerBarHeight - 1;
    } else {
        properties.headerBarHeight = 0;
    };

    var _defaultRowHeight = properties.defaultRowHeight;
    properties.rowHeight = Math.round(_defaultRowHeight * g_zoom_percent / 100);
    cScrollBar.width = Math.floor(cScrollBar.defaultWidth * g_zoom_percent / 100);
    cScrollBar.minCursorHeight = Math.round(cScrollBar.defaultMinCursorHeight * g_zoom_percent / 100);
    
    cFilterBox.w = Math.floor(cFilterBox.default_w * g_zoom_percent / 100);
    cFilterBox.h = Math.round(cFilterBox.default_h * g_zoom_percent / 100);
	
    properties.addedRows_end = properties.addedRows_end_default;
	
	/*if(properties.showNewPlaylistButton) {
		properties.paddingTop = properties.rowHeight;
	} else */
	properties.paddingTop = 0;	
    if(brw) {
        if(cScrollBar.enabled)  {
            //brw.setSize(0, (properties.showHeaderBar ? properties.headerBarHeight : 0), ww - cScrollBar.width, wh - (properties.showHeaderBar ? properties.headerBarHeight : 0));
			brw.setSize(0, (properties.showHeaderBar ? properties.headerBarHeight + properties.paddingTop: properties.paddingTop), ww, wh - (properties.showHeaderBar ? properties.headerBarHeight + properties.paddingTop: properties.paddingTop));
        } else {
            brw.setSize(0, (properties.showHeaderBar ? properties.headerBarHeight + properties.paddingTop: properties.paddingTop), ww, wh - (properties.showHeaderBar ? properties.headerBarHeight + properties.paddingTop: properties.paddingTop));
        };
        if(brw.rowsCount > 0) brw.getlimits();
    };
};

function playlistName2icon(name, auto_playlist){
	if(name==globalProperties.selection_playlist) return images.library_icon;	
	if(name==globalProperties.playing_playlist) return images.library_playback_icon;	
	if(name==globalProperties.whole_library) return images.whole_library_icon;	
	if(name=="Newly Added") return images.newly_added_icon;
	if(name=="Create Playlist") return images.create_playlist;	
	if(name=="History") return images.history_icon;	
	if(name=="Top Rated") return images.top_rated;		
	if(name=="Radios") return images.radios_icon;		
	if(name=="Most Played") return images.most_played_icon;		
	if(name=="Podcasts") return images.podcasts_icon;		
	if(name=="External Files") return images.external_files_icon;		
	if(name=="Search" || name=="Search Results") return images.search_icon;	
	if(auto_playlist) {
		//gr.DrawImage(images.icon_auto_pl.Resize(rh,rh,2) , ax, ay+5, rh, rh, 0, 0, rh, rh, 0, 255);
		return images.icon_auto_pl;
	} else {
		//gr.DrawImage(images.icon_normal_pl.Resize(rh,rh,2) , ax, ay+5, rh, rh, 0, 0, rh, rh, 0, 255);
		return images.icon_normal_pl;
	};
}

function get_images() {
    var gb;
    
	if(properties.darklayout) color_theme="white\\";
	else color_theme="";
	
    // normal playlist icon
	images.icon_normal_pl = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"playlist_icon2.png");
	images.icon_normal_pl_sel = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"playlist_icon2.png");
	images.icon_normal_pl_playing = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"auto_playlist_icon.png");
	images.icon_normal_pl_playing_sel = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"auto_playlist_icon.png");
	images.icon_auto_pl = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"playlist_icon.png");	
	images.icon_auto_pl_sel = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"playlist_icon.png");	
	images.icon_auto_pl_playing = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"auto_playlist_icon.png");		
	images.icon_auto_pl_playing_sel = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"auto_playlist_icon.png");	
	
	images.create_playlist = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"create_playlist.png");	
	images.newly_added_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"newly_added_icon.png");	
	images.top_rated = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"fav_icon.png");	
	images.history_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"history_icon.png");	
	images.whole_library_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"whole_library_icon.png");		
	images.library_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"library_icon.png");	
	images.library_playback_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"library_playback_icon.png");		
	images.radios_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"radios_icon.png");
	images.most_played_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"most_played_icon.png");	
	images.podcasts_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"podcasts_icon.png");
	images.external_files_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"external_files_icon.png");	
	images.search_icon = gdi.Image(theme_img_path + "\\icons\\"+color_theme+"search_icon.png");		
	
	if(!properties.darklayout){
	images.now_playing_1 = gdi.Image(theme_img_path + "\\graphic_browser\\now_playing_track1.png");
	images.now_playing_0 = gdi.Image(theme_img_path + "\\graphic_browser\\now_playing_track0.png");
	} else {
	images.now_playing_1 = gdi.Image(theme_img_path + "\\graphic_browser\\now_playing_progress1.png");
	images.now_playing_0 = gdi.Image(theme_img_path + "\\graphic_browser\\now_playing_progress0.png");			
	}	
};


function get_colors() {
	if(properties.darklayout){		
		wallpaper_overlay = GetGrey(25,230);
		wallpaper_overlay_blurred = GetGrey(0,200);	
		if(!properties.showwallpaper) {
			if(properties.wallpaperblurred) wallpaper_overlay_blurred = GetGrey(0,120);
			properties.wallpapermode_temp = 99;
		} else {
			properties.wallpapermode_temp = properties.wallpapermode;		
			
		}
		g_color_normal_bg = GetGrey(17);
		g_color_normal_txt = GetGrey(240);
		g_color_faded_txt = GetGrey(110);	
		g_color_full_txt = GetGrey(255);			
		g_color_selected_bg = RGBA(015,177,255,160);
		g_color_highlight = RGB(255,175,050);
		g_color_alternate_row = GetGrey(0,30);	

		scrollbar_normal_cursor_color = GetGrey(255,60);
		scrollbar_hover_cursor_color = GetGrey(225);
		scrollbar_down_cursor_color = scrollbar_hover_cursor_color;
		
		selected_item_bg = GetGrey(0,150);	
		selected_item_line = GetGrey(255,30);			
		color_marker_hover_item = GetGrey(255);
		width_marker_hover_item = 1;
		
		dragdrop_bg_selected_item = GetGrey(0,190);	
		dragdrop_line_selected_item = GetGrey(255,45);	
		dragdrop_disabled_item = RGBA(255,0,0,60)
		
		grad_bottom_color1 = GetGrey(0,70);
		grad_bottom_color2 = GetGrey(0,0);		
		fading_bottom_height = 50;
		
		headerbar_bgcolor = GetGrey(15,200);	
		headerbar_line_maincolor = GetGrey(255,38);	
		border_color = GetGrey(255,50);	
		
		rightline_color = GetGrey(255,25);
		reseticon_down = RGB(255,50,50);
		
		dragReorder_playlist_marker = GetGrey(255,205);
		
	} else {	
		properties.wallpapermode_temp = properties.wallpapermode;		
		wallpaper_overlay = GetGrey(255,235);
		wallpaper_overlay_blurred = GetGrey(255,235);	

		g_color_normal_bg = GetGrey(245);
		
		g_color_normal_txt = GetGrey(0);
		g_color_faded_txt = GetGrey(140);
        g_color_full_txt = GetGrey(0);		
		g_color_selected_bg = RGBA(015,177,255,100);
		g_color_highlight = RGB(255,175,050);
		g_color_alternate_row = GetGrey(0,5);

		scrollbar_normal_cursor_color = GetGrey(0,120);
		scrollbar_hover_cursor_color = GetGrey(0);
		scrollbar_down_cursor_color = scrollbar_hover_cursor_color;	
		
		selected_item_bg = GetGrey(0,17);	
		selected_item_line = GetGrey(0,16);	
		color_marker_hover_item = GetGrey(30);
		width_marker_hover_item = 2;
		
		dragdrop_bg_selected_item = GetGrey(220);	
		dragdrop_line_selected_item = GetGrey(205);
		dragdrop_disabled_item = RGBA(255,0,0,60)
		
		grad_bottom_color1 = GetGrey(0,10);
		grad_bottom_color2 = GetGrey(0,0);			
		fading_bottom_height = 39;
		
		if(properties.showwallpaper) {
			headerbar_bgcolor = GetGrey(255,240);		
			headerbar_line_maincolor = GetGrey(0,40);
		} else {
			headerbar_bgcolor = GetGrey(255,240);		
			headerbar_line_maincolor = GetGrey(215);			
		}		
		border_color = GetGrey(0,50);
		
		rightline_color = GetGrey(0,37);
		reseticon_down = RGB(255,50,50);	
		
		dragReorder_playlist_marker = GetGrey(20);
	}		
};

function on_font_changed() {
    get_font();
	g_filterbox.setSize(ww, cFilterBox.h+2, g_fsize+2);
    get_metrics();
    brw.repaint();
};

function on_colours_changed() {
    get_colors();
    get_images();
	brw.setIcons();
    if(brw) brw.scrollbar.setNewColors();
    g_filterbox.getImages();
    g_filterbox.reset_colors();
    brw.repaint();
};

function on_script_unload() {
    //brw.resetTimer();
};

//=================================================// Keyboard Callbacks
function on_key_up(vkey) {
    if(cSettings.visible) {

    } else {
        // inputBox
        if(properties.showFilterBox && g_filterbox.inputbox.visible) {
            g_filterbox.on_key("up", vkey);
        };
        
        // scroll keys up and down RESET (step and timers)
        brw.keypressed = false;
        cScrollBar.timerCounter = -1;
        cScrollBar.timerID && window.ClearTimeout(cScrollBar.timerID);
        cScrollBar.timerID = false;
        if(vkey == VK_SHIFT) {
            brw.SHIFT_start_id = null;
            brw.SHIFT_count = 0;
        };
    };
    brw.repaint();
};

function on_key_down(vkey) {
    var mask = GetKeyboardMask();
    
    if(cSettings.visible) {

    } else {
        if(brw.inputboxID >= 0) {
            if (mask == KMask.none) {
                switch (vkey) {
                case VK_ESCAPE:
					if(UIHacks.FullScreen) fb.RunMainMenuCommand('View/Fullscreen');
					break;					
                case 222:
                    brw.inputboxID = -1;
                    brw.repaint();
                    break;
                default:
                    brw.inputbox.on_key_down(vkey);
                };
            };
            
        } else {

            // inputBox
            if(properties.showFilterBox && g_filterbox.inputbox.visible && g_filterbox.inputbox.edit) {
                g_filterbox.on_key("down", vkey);
            };

            var act_pls = g_active_playlist;
            
            if (mask == KMask.none) {
                switch (vkey) {
                case VK_F2:
                    // set rename it
                    var rowId = brw.selectedRow;
                    if(rowId > -1) {
                        var rh = properties.rowHeight - 10;
                        var tw = brw.w - rh - 10;
                        brw.inputbox = new oInputbox(tw, rh, plman.GetPlaylistName(brw.rows[rowId].idx), "", g_color_normal_txt, g_color_normal_bg, g_color_normal_txt, g_color_selected_bg, "renamePlaylist()", "brw");
                        brw.inputbox.setSize(tw, rh, g_fsize+1); // set font_size
                        brw.inputboxID = rowId;
                        // activate inputbox for edit
                        brw.inputbox.on_focus(true);
                        brw.inputbox.edit = true;
                        brw.inputbox.Cpos = brw.inputbox.text.length;
                        brw.inputbox.anchor = brw.inputbox.Cpos;
                        brw.inputbox.SelBegin = brw.inputbox.Cpos;
                        brw.inputbox.SelEnd = brw.inputbox.Cpos;
                        if(!cInputbox.timer_cursor) {
                            brw.inputbox.resetCursorTimer();
                        };
                        brw.inputbox.dblclk = true;
                        brw.inputbox.SelBegin = 0;
                        brw.inputbox.SelEnd = brw.inputbox.text.length;
                        brw.inputbox.text_selected = brw.inputbox.text;
                        brw.inputbox.select = true;
                        brw.repaint();
                    };
                    break;
                case VK_F3:
                    brw.showActivePlaylist();
                    break;
                case VK_F5:
                    brw.repaint();
                    break;
                case VK_F6:

                    break;
                case VK_TAB:
                    break;
                case VK_BACK:
                    break;
                case VK_ESCAPE:
					if(UIHacks.FullScreen) fb.RunMainMenuCommand('View/Fullscreen');
					break;					
                case 222:
                    brw.inputboxID = -1;
                    break;
                case VK_UP:
                    if(brw.rowsCount > 0) {
                        if(g_filterbox.inputbox && g_filterbox.inputbox.edit) return;
                        var rowId = brw.selectedRow;
                        if(rowId > 0) {
                            if(brw.inputboxID > -1) brw.inputboxID = -1;
                            brw.repaint();
                            brw.selectedRow--;
                            if(brw.selectedRow < 0) brw.selectedRow = 0;
                            brw.showSelectedPlaylist();
                            brw.repaint();
                        };
                    };
                    break;
                case VK_DOWN:
                    if(brw.rowsCount > 0) {
                        if(g_filterbox.inputbox && g_filterbox.inputbox.edit) return;
                        var rowId = brw.selectedRow;
                        if(rowId < brw.rowsCount - 1) {
                            if(brw.inputboxID > -1) brw.inputboxID = -1;
                            brw.repaint();
                            brw.selectedRow++;
                            if(brw.selectedRow > brw.rowsCount - 1) brw.selectedRow = brw.rowsCount - 1;
                            brw.showSelectedPlaylist();
                            brw.repaint();
                        };
                    };
                    break;
				case VK_PGUP:
					if(brw.rowsCount > 0 && !brw.keypressed && !cScrollBar.timerID) {
						scroll -= brw.h-properties.rowHeight;
						scroll = check_scroll(scroll)
					};
					break;
				case VK_PGDN:
					if(brw.rowsCount > 0 && !brw.keypressed && !cScrollBar.timerID) {
						scroll += brw.h-properties.rowHeight;
						scroll = check_scroll(scroll)
					};
					break;
                case VK_RETURN:
                    if(brw.rowsCount > 0) {
                        if(g_filterbox.inputbox && g_filterbox.inputbox.edit) return;
                        brw.repaint();
                        plman.ActivePlaylist = brw.selectedRow;
                        cPlaylistManager.playlist_switch_pending = true;
                        //window.SetCursor(IDC_WAIT);
                    };
                    break;
				case VK_END:
					if(brw.rowsCount > 0) {
						scroll = ((brw.rowsCount+properties.addedRows_end) * properties.rowHeight) - (brw.totalRowsVis * properties.rowHeight);
						scroll = check_scroll(scroll)
					};
					break;
                case VK_HOME:
                    if(brw.rowsCount > 0) {
                        if(g_filterbox.inputbox && g_filterbox.inputbox.edit) return;
                        if(brw.inputboxID > -1) brw.inputboxID = -1;
                        brw.repaint();
                        brw.selectedRow = 0;
                        brw.showSelectedPlaylist();
                    };
                    break;
                case VK_DELETE:
                    if(!brw.delete_pending && !timers.deletePlaylist) {
                        if(g_filterbox.inputbox && g_filterbox.inputbox.edit) return;
                        if(brw.selectedRow > -1 && brw.selectedRow < brw.rowsCount && brw.rowsCount > 0) {
							var id = brw.selectedRow;
                            DeletePlaylist(id);
                            //brw.delete_pending = true;							
							/*
                            timers.deletePlaylist = window.SetTimeout(function(){
                                timers.deletePlaylist && window.ClearTimeout(timers.deletePlaylist);
                                timers.deletePlaylist = false;
                            }, 150);
                            //
                            var updateActivePlaylist = (brw.selectedRow == plman.ActivePlaylist);
                            var row = brw.getRowIdFromIdx(id);
                            plman.RemovePlaylistSwitch(id);
                                if(row < brw.rowsCount - 1) {
                                    brw.selectedRow = id;
                                } else if(row > 0) {
                                    brw.selectedRow = id - 1;
                                };
                            if(updateActivePlaylist) {
                                if(row < brw.rowsCount - 1) {
                                    plman.ActivePlaylist = id;
                                } else if(row > 0) {
                                    plman.ActivePlaylist = id - 1;
                                };
                            };*/
                        };
                    };
                    break;
                };
            } else {
                switch(mask) {
                    case KMask.shift:
                        switch(vkey) {
                            case VK_SHIFT: // SHIFT key alone
                                break;
                            case VK_UP: // SHIFT + KEY UP
                                break;
                            case VK_DOWN: // SHIFT + KEY DOWN
                                break;
                        };
                        break;
                    case KMask.ctrl:
                        if(vkey==65) { // CTRL+A

                        };
                        if(vkey==66) { // CTRL+B
                            cScrollBar.enabled = !cScrollBar.enabled;
                            window.SetProperty("DISPLAY: Show Scrollbar", cScrollBar.enabled);
                            get_metrics();
                            brw.repaint();
                        };
                        if(vkey==88) { // CTRL+X

                        };
                        if(vkey==67) { // CTRL+C

                        };
                        if(vkey==86) { // CTRL+V

                        };
                        if(vkey==70) { // CTRL+F
                            fb.RunMainMenuCommand("Edit/Search");
                        };
                        if(vkey==73) { // CTRL+I

                        };
                        if(vkey==78) { // CTRL+N
                            fb.RunMainMenuCommand("File/New playlist");
                        };
                        if(vkey==79) { // CTRL+O
                            fb.RunMainMenuCommand("File/Open...");
                        };
                        if(vkey==80) { // CTRL+P
                            fb.RunMainMenuCommand("File/Preferences");
                        };
                        if(vkey==83) { // CTRL+S
                            fb.RunMainMenuCommand("File/Save playlist...");
                        };
                        if(vkey==84) { // CTRL+T
                            properties.showHeaderBar = !properties.showHeaderBar;
                            window.SetProperty("DISPLAY: Show Top Bar", properties.showHeaderBar);
                            get_metrics();
                            brw.repaint();
                        };
                        if(vkey == 48 || vkey == 96) { // CTRL + 0
                            var previous = properties.globalFontAdjustement;
                            if(!timers.mouseWheel) {
                                properties.globalFontAdjustement = 0;
                                if(previous != properties.globalFontAdjustement) {
                                    timers.mouseWheel = window.SetTimeout(function() {
                                        window.SetProperty("DISPLAY: Extra font size value", properties.globalFontAdjustement);
                                        get_font();
                                        get_metrics();
                                        get_images();
                                        brw.repaint();
                                        timers.mouseWheel && window.ClearTimeout(timers.mouseWheel);
                                        timers.mouseWheel = false;
                                    }, 100);
                                };
                            };
                        };
                        break;
                    case KMask.alt:
                        switch(vkey) {
                        case 65: // ALT+A
                            fb.RunMainMenuCommand("View/Always on Top");
                            break;
                        case VK_ALT: // ALT key alone
                            break;
                        };
                        break;
                };
            };
        };

    };
};

function on_char(code) {
    // rename inputbox
    if(brw.inputboxID >= 0) {
        brw.inputbox.on_char(code);
    } else {
        // filter inputBox
        if(properties.showFilterBox && g_filterbox.inputbox.visible) {
            g_filterbox.on_char(code);
        };
    };
};

//=================================================// Playback Callbacks
function on_playback_stop(reason) { 
	g_seconds = 0;	
  	if(window.IsVisible) {		
		switch(reason) {
		case 0: // user stop
		case 1: // eof (e.g. end of playlist)
			brw.PlayingPlaylist = -1;		
			// update wallpaper
			if(properties.showwallpaper && properties.wallpapermode == 0) {
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, null);
			};
			brw.repaint();
			break;
		case 2: // starting_another (only called on user action, i.e. click on next button)
			break;
		};
	} else Update_Required_function = 'on_playback_stop('+reason+')';		
};

function on_playback_new_track(metadb) {
	g_seconds = 0;
	brw.FindPlayingPlaylist();
	if(window.IsVisible) {
		g_metadb = metadb;		
		if(properties.showwallpaper && properties.wallpapermode == 0) {
			g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, g_metadb);
		};		
		brw.repaint();
	} else if(properties.wallpapermode == 0) update_wallpaper = true;	
};
function on_playback_time(time) {
	g_seconds = time;
	if(window.IsVisible) window.RepaintRect(brw.playing_icon_x,brw.playing_icon_y,brw.playing_icon_w,brw.playing_icon_h);
}
//=================================================// Playlist Callbacks
function on_playlists_changed() {
	if(!g_avoid_on_playlists_changed && g_first_populate_done){	
		if(cPlaylistManager.drag_droped) {
			window.SetCursor(IDC_ARROW);
		} else {
			if(brw.previous_playlistCount != plman.PlaylistCount) g_filterbox.clearInputbox();
		};
		brw.populate(is_first_populate = false, 4, reset_scroll = false);
		
		if(brw.selectedRow > brw.rowsCount) brw.selectedRow = plman.ActivePlaylist;

		brw.repaint();
		brw.delete_pending = false;		
	}
};

function on_playlist_switch() { 
	if(window.IsVisible) {	  
		g_active_playlist = plman.ActivePlaylist;
		brw.showActivePlaylist();
		if(brw.selectedRow > brw.rowsCount) brw.selectedRow = plman.ActivePlaylist;
		brw.repaint();
	} else Update_Required_function = 'on_playlist_switch()';	
};

function on_playlist_items_added(playlist_idx) {
	if(window.IsVisible) {		
		brw.repaint();
	} else Update_Required_function = 'on_playlist_items_added('+playlist_idx+')';		
};

function on_playlist_items_removed(playlist_idx, new_count) {
	if(window.IsVisible) {		
		brw.repaint();
	} else Update_Required_function = 'on_playlist_items_removed('+playlist_idx+','+new_count+')';	
};


function on_focus(is_focused) {   
    g_focus = is_focused;
    if(!is_focused && g_filterbox.inputbox.edit) {
		g_filterbox.inputbox.on_focus(is_focused)
        brw.repaint();
    };
};

// ===================================================== // Wallpaper
function setWallpaperImg(defaultpath, metadb) {    
    if(metadb && properties.wallpapermode_temp == 0) {
		try{
			cachekey = process_cachekey(metadb)		
			var tmp_img = g_image_cache._cachelist[cachekey];
			if (typeof tmp_img == "undefined" || tmp_img==null) {
				tracktype = TrackType(metadb.rawpath.substring(0, 4));
				if(tracktype == 3) tmp_img = cover.stream_img			
				else tmp_img = utils.GetAlbumArtV2(metadb, properties.wallpapermode_temp);
			}			
		} catch(e){
			var tmp_img = utils.GetAlbumArtV2(metadb, properties.wallpapermode_temp);
		}

    } else {
        if(defaultpath) {
            tmp_img = gdi.Image(defaultpath);
        } else {
            tmp_img = null;
        };
    };
    if(!tmp_img) {
        if(defaultpath) {
            tmp_img = gdi.Image(defaultpath);
        } else {
            tmp_img = null;
        };
    };

    g_wallpaperImg = null;
	update_wallpaper = false;
    var img = FormatWallpaper(tmp_img, ww, wh, 2, properties.wallpaperdisplay, 0, "", false);
    return img;
};

//=================================================// Custom functions
function checkMediaLibrayPlaylist() {
    g_avoid_on_playlists_changed = true;
    
    // check if library playlist is present
    var isMediaLibraryFound = false;
    var total = plman.PlaylistCount;
    for (var i = 0; i < total; i++) {
        if(plman.GetPlaylistName(i) == "Media Library") {
            var mediaLibraryIndex = i;
            isMediaLibraryFound = true;
            break;
        };
    };
    if(!isMediaLibraryFound) {
        // create Media Library playlist (sort forced)
        // > sort: sort string expression.
        // > flags: 1 - always sort.
        // > boolean CreateAutoPlaylist(idx, name, query, sort = "", flags = 0);
        plman.CreateAutoPlaylist(total, "Media Library", "%path% PRESENT", "%album artist% | $if(%album%,%date%,'9999') | %album% | %discnumber% | %tracknumber% | %title%", 1);
        //plman.CreateAutoPlaylist(total, "Media Library", "%album% PRESENT", "%album artist% | %date% | %album% | %discnumber% | %tracknumber% | %title%", 1);
        // Move it to the top
        plman.MovePlaylist(total, 0);
    } else if(mediaLibraryIndex > 0) {
        // Always move it to the top
        plman.MovePlaylist(mediaLibraryIndex, 0);
    };
    
    g_avoid_on_playlists_changed = false;
};

function check_scroll(scroll___){
    if(scroll___ < 0)
        scroll___ = 0;
    var g1 = brw.h - (brw.totalRowsVis * properties.rowHeight);
    //var scroll_step = Math.ceil(properties.rowHeight / properties.scroll_divider);
    //var g2 = Math.floor(g1 / scroll_step) * scroll_step;

    var end_limit = ((brw.rowsCount+properties.addedRows_end) * properties.rowHeight) - (brw.totalRowsVis * properties.rowHeight) - g1;
    if(scroll___ != 0 && scroll___ > end_limit) {
        scroll___ = end_limit;
    };
    return scroll___;
};

function g_sendResponse() {

	if(g_filterbox.inputbox.text.length == 0) {
        filter_text = "";
    } else {
	    filter_text = g_filterbox.inputbox.text;
    };
       
    // filter in current panel
    brw.populate(true, 1);
    if(brw.selectedRow < 0 || brw.selectedRow > brw.rowsCount - 1) brw.selectedRow = 0;
};

function on_notify_data(name, info) {
    switch(name) {
		case "avoid_on_playlists_changed":  
			g_avoid_on_playlists_changed=info;
			//if(!g_avoid_on_playlists_changed) on_playlists_changed();
			break;	
		case "enable_screensaver":		
			globalProperties.enable_screensaver = info;
			window.SetProperty("GLOBAL enable screensaver", globalProperties.enable_screensaver);	
		break;				
		case "set_font":
			properties.globalFontAdjustement = info;
			window.SetProperty("MAINPANEL: Global Font Adjustement", properties.globalFontAdjustement),
			on_font_changed();
		break; 			
		case "rePopulate": 
			if(window.IsVisible){
				brw.populate(true, 16, true);
			} else {set_update_function("brw.populate(true, 16, true)");}
			break;				
		case "layout_state":
			layout_state = info;
			if(layout_state==1) window.NotifyOthers("pmanager_height",window.height);
			break;		
		case "wallpaperVisibility":
			if(window.IsVisible) toggleWallpaper(info);
		break; 	
		case "wallpaperBlur":
			if(window.IsVisible) toggleBlurWallpaper(info);
		break; 				
		case"playlists_dark_theme":			
			properties.darklayout = info;
			window.SetProperty("_DISPLAY: Dark layout", properties.darklayout);
			on_colours_changed();				
			if(properties.darklayout) g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.IsPlaying ? fb.GetNowPlaying() : null);
			brw.repaint();
		break;	
		case "cover_cache_finalized": 
			g_image_cache._cachelist = info;
			window.Repaint();
		break;			
		case "WSH_panels_reload":
			window.Reload();
		break; 			
    };
};
//=================================================// Cover Tools
image_cache = function () {
    this._cachelist = {};
    this.hit = function (metadb, albumIndex) {
        var img = this._cachelist[brw.groups[albumIndex].cachekey];
        if (typeof(img) == "undefined" || img == null) { // if image not in cache, we load it asynchronously	
            //if(!isScrolling  && !cScrollBar.timerID) { // and when no scrolling
                brw.groups[albumIndex].crc = check_cache(metadb, albumIndex);
                if(brw.groups[albumIndex].crc && brw.groups[albumIndex].load_requested == 0) {
					//Dont save as its already in the cache
					brw.groups[albumIndex].save_requested=true;					
                    // load img from cache
                    if(!timers.coverLoad) {
                        timers.coverLoad = window.SetTimeout(function() {
                            try {
                                brw.groups[albumIndex].tid = load_image_from_cache(metadb, brw.groups[albumIndex].crc);
                                brw.groups[albumIndex].load_requested = 1;
                            } catch(e) {};
                            timers.coverLoad && window.ClearTimeout(timers.coverLoad);
                            timers.coverLoad = false;
                        }, (!isScrolling  && !cScrollBar.timerID ? 5 : 25));
                    };
                } else if(brw.groups[albumIndex].load_requested == 0) {               
                    // load img default method
                    if(!timers.coverLoad) {
                        timers.coverLoad = window.SetTimeout(function() {
                            this.albumArtId = properties.albumArtId == 0 ? albumIndex + 5 : properties.albumArtId;
                            brw.groups[albumIndex].load_requested = 1;
                            utils.GetAlbumArtAsync(window.ID, metadb, this.albumArtId, true, false, false);
                            timers.coverLoad && window.ClearTimeout(timers.coverLoad);
                            timers.coverLoad = false;
                        }, (!isScrolling  && !cScrollBar.timerID ? 5 : 25));
                    };
                };
            //};
        };
        return img;
    };
    this.reset = function(key) {
        this._cachelist[key] = null;
    };
    this.getit = function (metadb, albumId, image) {
        var cw = globalProperties.thumbnailWidthMax;
        var ch = cw;
        var img = null;
        var cover_type = null;
        
        if(cover.keepaspectratio) {
            if(!image) {
                var pw = cw - cover.margin * 2;
                var ph = ch - cover.margin * 2;
            } else {
                if(image.Height>=image.Width) {
                    var ratio = image.Width / image.Height;
                    var pw = (cw - cover.margin * 2) * ratio;
                    var ph = ch - cover.margin * 2;
                } else {
                    var ratio = image.Height / image.Width;
                    var pw = cw - cover.margin * 2;
                    var ph = (ch - cover.margin * 2) * ratio;
                };
            };
        } else {
            var pw = cw - cover.margin * 2;
            var ph = ch - cover.margin * 2;
        };
        // cover.type : 0 = nocover, 1 = external cover, 2 = embedded cover, 3 = stream
        if(brw.groups[albumId].tracktype != 3) {
            if(metadb) {
                if(image) {
                    img = FormatCover(image, pw, ph, false);
                    cover_type = 1;
                } else {
                    //img = FormatCover(images.noart, pw, ph, false);
                    cover_type = 0;
                };
            };
        } else {
            //img = FormatNoCover(albumId, pw, ph, false, mode = 2);
            cover_type = 3;
            
        };
        if(cover_type == 1) {
            this._cachelist[brw.groups[albumId].cachekey] = img;
        };
        // save img to cache
        if(cover_type == 1 && !brw.groups[albumId].save_requested && image) {
            if(!timers.saveCover) {
                brw.groups[albumId].save_requested = true;
                save_image_to_cache(image, albumId); 
                timers.saveCover = window.SetTimeout(function() {
                    window.ClearTimeout(timers.saveCover);
                    timers.saveCover = false;
                }, 100);
            };
        };
        
        brw.groups[albumId].cover_type = cover_type;
        
        return img;
    };
};

function FormatCover(image, w, h, rawBitmap) {
	if(!image || w<=0 || h<=0) return image;
    if(rawBitmap) {
        return image.Resize(w, h, 2).CreateRawBitmap();
    } else {
        return image.Resize(w, h, 2);
    };
};


//=================================================// Drag'n'Drop Callbacks
function on_drag_enter() {
    g_dragndrop_status = true;
};

function on_drag_leave() {  
    g_dragndrop_status = false;
    g_dragndrop_trackId = -1;
    g_dragndrop_rowId = -1;
    g_dragndrop_targetPlaylistId = -1;
    brw.buttonclicked = false;
    cScrollBar.timerID && window.ClearInterval(cScrollBar.timerID);
    cScrollBar.timerID = false;
	brw.on_mouse("leave", 0, 0);
    brw.repaint();
};

function on_drag_over(action, x, y, mask) {
    
    if(x == g_dragndrop_x && y == g_dragndrop_y) return true;

    g_dragndrop_trackId = -1;
    g_dragndrop_rowId = -1;
    g_dragndrop_targetPlaylistId = -1;
    g_dragndrop_bottom = false;

    brw.on_mouse("drag_over", x, y);
    brw.repaint();
    
    g_dragndrop_x = x;
    g_dragndrop_y = y;
};

function on_drag_drop(action, x, y, mask) {
    if(y > brw.y) {
        var drop_done = false;
        if(brw.activeRow > -1) {
            drop_done = true;
            if(g_dragndrop_targetPlaylistId > -1 && brw.rows[g_dragndrop_targetPlaylistId].idx>-1) {		
                action.Effect = 1;
                action.Playlist = brw.rows[g_dragndrop_targetPlaylistId].idx;
				action.Base = plman.PlaylistItemCount(g_dragndrop_targetPlaylistId);
                action.ToSelect = true;
            } else {			
				drop_done = true;
				var total_pl = plman.PlaylistCount;
				plman.CreatePlaylist(total_pl, "Dropped Items");
				action.Effect = 1;
				action.Playlist = total_pl;
				action.ToSelect = true;		
				playlistname = InputBox("Give your playlist a name ?", "Rename a playlist", plman.GetPlaylistName(total_pl));
				if(!playlistname || playlistname == "") playlistname = plman.GetPlaylistName(total_pl);
				if (playlistname.length > 1 || (playlistname.length == 1 && (playlistname >= "a" && playlistname <= "z") || (playlistname >= "A" && playlistname <= "Z") || (playlistname >= "0" && playlistname <= "9"))) {
					plman.RenamePlaylist(total_pl, playlistname);
					window.Repaint();
				}						
			}
        } else {
            drop_done = true;
            var total_pl = plman.PlaylistCount;
            plman.CreatePlaylist(total_pl, "Dropped Items");
            action.Effect = 1;
            action.Playlist = total_pl;
            action.ToSelect = true;
        };	
        if(drop_done) {
            // create a timer to blink the playlist item where tracks have been droped!
            if(!blink.timer) { 
                blink.x = x;
                blink.y = y;
                blink.totaltracks = 1;
                blink.id = brw.activeRow;
                blink.counter = 0;
                blink.timer = window.SetInterval(function() {
                    blink.counter++;
                    if(blink.counter > 7) {
                        blink.timer && window.ClearInterval(blink.timer);
                        blink.timer = false;
                        blink.counter = -1;
                        blink.id = null;
                    };
                    brw.repaint();
                }, 125);
            };
        };
    } 	
    g_dragndrop_status = false;
    brw.repaint();
};

function toggleWallpaper(wallpaper_state){
	wallpaper_state = typeof wallpaper_state !== 'undefined' ? wallpaper_state : !properties.showwallpaper;	
	properties.showwallpaper = wallpaper_state;
	window.SetProperty("_DISPLAY: Show Wallpaper", properties.showwallpaper);
	on_colours_changed();				
	if(properties.showwallpaper) {
		g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.IsPlaying ? fb.GetNowPlaying() : null);
	}
	brw.repaint();	
}
function toggleBlurWallpaper(wallpaper_blur_state){
	wallpaper_blur_state = typeof wallpaper_blur_state !== 'undefined' ? wallpaper_blur_state : !properties.wallpaperblurred;	
	properties.wallpaperblurred = wallpaper_blur_state; on_colours_changed();		
	window.SetProperty("_DISPLAY: Wallpaper Blurred", properties.wallpaperblurred);
	if(fb.IsPlaying) g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
	brw.repaint();
}

function on_init() {
    window.DlgCode = 0x0004;
    
    get_font();
    get_colors();
    get_metrics();
	get_images();
	
	g_image_cache = new image_cache;	
    g_active_playlist = plman.ActivePlaylist;

    brw = new oBrowser("brw");
	brw.startTimer();	
	
    g_filterbox = new oFilterBox();
    g_filterbox.inputbox.visible = true;
};
on_init();