properties = {
	panelName: 'WSHtitle_bar',			
    Remember_previous_state: window.GetProperty("Resume panel state on startup, except on visualization tab", false),
    background_color: window.GetProperty("Background color", "255-255-255"),		
    globalFontAdjustement: window.GetProperty("MAINPANEL: Global Font Adjustement", 0),
	fullMode_savedwidth: window.GetProperty("Full mode saved width", 1100),
	fullMode_pmanagerheight: window.GetProperty("Full mode pmanager saved height", 820),
	miniMode_savedwidth: window.GetProperty("Mini mode saved width", 290),
	miniMode_playlistheight: window.GetProperty("Mini mode playlist saved height", 380),	
	miniMode_defaultwidth:290,
	miniMode_defaultheight:380,
	fullMode_defaultwidth:1100,
	fullMode_defaultheight:820,
	fullMode_minwidth:600,
	fullMode_minheight:500,	
	fullcontrolsHeight:72,
	minicontrolsHeight:51,
    searchHistory_max_items: window.GetProperty("Max items in search history", 6),
    library_dark_theme: window.GetProperty("LIBRARY dark theme", false),
    screensaver_dark_theme: window.GetProperty("SCREENSAVER dark theme", false),		
    playlists_dark_theme: window.GetProperty("PLAYLISTS dark theme", false),
    bio_dark_theme: window.GetProperty("BIO dark theme", false),	
	bio_stick2darklayout: window.GetProperty("BIO stick to Dark layout",false),
    visualization_dark_theme: window.GetProperty("VISUALIZATION dark theme", false),		
    minimode_dark_theme: window.GetProperty("MINIMODE dark theme", false),
    show_visualization: window.GetProperty("_PROPERTY show visualization tab", true),
	showwallpaper: window.GetProperty("_DISPLAY: Show Wallpaper", false),
    wallpapermode: window.GetProperty("_SYSTEM: Wallpaper Mode", 0),
    wallpaperblurred: window.GetProperty("_DISPLAY: Wallpaper Blurred", true),
    wallpaperblurvalue: window.GetProperty("_DISPLAY: Wallpaper Blur Value", 1.05),
    wallpaperdisplay: window.GetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", 0),	
	darklayout: window.GetProperty("_DISPLAY: Dark layout", false),		
	tracktitle_ontop: window.GetProperty("_DISPLAY: Track title", true),	
	tracktitle_format: window.GetProperty("_DISPLAY: Track title format", "[%artist%  -  ][%album%[  -  %tracknumber%] : ]%title%[  -  %date%]"),	
	showIdleScreenBtn: window.GetProperty("_DISPLAY: show idle screen btn", true),	
	showLightswitchBtn: window.GetProperty("_DISPLAY: show light switch btn", true),
	showNowPlayingBtn: window.GetProperty("_DISPLAY: show now playing btn", true),	
	showFullscreenBtn: window.GetProperty("_DISPLAY: show fullscreen btn", true),	
	LightswitchBtnGlobal: window.GetProperty("_DISPLAY: light switch btn global", true),		
	settings_caption:true,
	panelFontAdjustement: 0,
	toUpperCase: window.GetProperty("_DISPLAY: panels btn text to uppercase", true),	
	alwaysShowSearch: window.GetProperty("_DISPLAY: always show search box", false),			
}
if(globalProperties.deleteDiskCache) {
	delete_full_cache();
}

scheduler = {	
    shutdown_after_current: false,	
    shutdown_after_playlist: false,			
    hibernate_after_current: false,
    hibernate_after_playlist: false	
}
var g_searchbox = null;
var g_fsize=12;
var cSearchBox = {};
var g_genre_cache = null;
var cSearchBoxMainLight = { 
	width:270,
	marginRight:128,	
	marginLeft:5,
	marginTop:32,	
	marginBottom:4,	
	paddingLeft:37,
	paddingRight:40,
	paddingTop:5,
	paddingBottom:6
};		
var cSearchBoxMainDark = {
	width:270,
	marginRight:128,	
	marginLeft:5,
	marginTop:33,	
	marginBottom:3,	
	paddingLeft:37,
	paddingRight:40,
	paddingTop:5,
	paddingBottom:6
};
var cSearchBoxMini = {
	width:300,
	marginRight:34,	
	marginLeft:5,
	marginTop:34,	
	marginBottom:4,	
	paddingLeft:37,
	paddingRight:40,
	paddingTop:6,
	paddingBottom:4
};
var btn = {
	width:85,
	height:32,		
	padding:20,
	top_m:31,
	top_m_to_uppercase:32,	
	top_padding:1,
	left_m:23,
	margin:15,	
};

var search_results_order = fb.TitleFormat("%album artist%|%date%|%album%|%discnumber%|%tracknumber%");
	
var library_index = [],
    library_list = plman.GetPlaylistItems(-1);
	
// wallpaper infos
var wpp_img_info = {orient: 0, cut: 0, cut_offset: 0, ratio: 0, x: 0, y: 0, w: 0, h: 0};
var update_wallpaper = false;
var default_wallpaperpath = theme_img_path + "\\nothing_played_full.png";

var ww = 0, wh = 0;
var cur_btn;
var btn_down = false;
var m_x, m_y = 0;
var caption_title_default = "No sound - Nothing played";
var caption_title = caption_title_default;


var Library_width = btn.width;
var Artist_width = 30+btn.width;
var Visu_width = 31+btn.width;
var Playlists_width = 5+btn.width;
var Fullscreen_width = 36;
var Settings_width = 102;
var btn_initialized = false;

function setScheduler(schedulerState, dontNotify){
	dontNotify = typeof dontNotify !== 'undefined' ? dontNotify : false;	
	if(!dontNotify) window.NotifyOthers("schedulerState",schedulerState);	
	switch (true) {		
		case (schedulerState == 0):
			scheduler.hibernate_after_current = false;
			scheduler.shutdown_after_current = false;
			scheduler.hibernate_after_playlist = false;
			scheduler.shutdown_after_playlist = false;						
			fb.StopAfterCurrent=false;	
			break; 
		case (schedulerState == 1):
			scheduler.hibernate_after_current = false;
			scheduler.shutdown_after_current = false;	
			scheduler.hibernate_after_playlist = false;
			scheduler.shutdown_after_playlist = false;						
			fb.StopAfterCurrent=true;		
			break; 				
		case (schedulerState == 2):
			scheduler.hibernate_after_current = true;
			scheduler.shutdown_after_current = false;	
			scheduler.hibernate_after_playlist = false;
			scheduler.shutdown_after_playlist = false;						
			fb.StopAfterCurrent=true;	
			break; 			
		case (schedulerState == 3):
			scheduler.hibernate_after_current = false;
			scheduler.shutdown_after_current = true;
			scheduler.hibernate_after_playlist = false;
			scheduler.shutdown_after_playlist = false;						
			fb.StopAfterCurrent=true;		
			break; 	
		case (schedulerState == 4):
			scheduler.hibernate_after_current = false;
			scheduler.shutdown_after_current = false;	
			scheduler.hibernate_after_playlist = true;
			scheduler.shutdown_after_playlist = false;
			fb.StopAfterCurrent=false;						
			break; 
		case (schedulerState == 5):
			scheduler.hibernate_after_current = false;
			scheduler.shutdown_after_current = false;				
			scheduler.hibernate_after_playlist = false;
			scheduler.shutdown_after_playlist = true;	
			fb.StopAfterCurrent=false;				
			break;			
	}	
}
function build_images(){
	if(properties.darklayout) var icons_folder = "white"; else var icons_folder = "";	
	foobar_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\icon_foobar.png");

	artist_bio_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\artist_bio_icon.png");

	playlist_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\playlist_icon.png");

	visualization_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\nowplaying_icon.png");

	fullscreen_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\fullscreen_icon.png"); 
	
	search_toggle_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\search_icon.png"); 	

	lightswitch_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\lightswitch_icon.png"); 	
	
	idle_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\idle_icon.png"); 	
	
	minimode_on_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\minimode_on_icon.png");
	minimode_off_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\minimode_off_icon.png"); 

	library_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\library_icon.png");
	global_settings_img = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\global_settings.png");

	nowplaying_off_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\nowplaying_off.png");
	nowplaying_off_hover_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\nowplaying_off_hover.png");  
	nowplaying_on_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\nowplaying_on.png");
	nowplaying_on_hover_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\nowplaying_on_hover.png");
	
	if(layout_state==1) icon_prefix = "mini";
	else icon_prefix = "";
	close_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\"+icon_prefix+"close_icon.png");
	close_icon_hover = gdi.Image(theme_img_path + "\\icons\\white\\"+icon_prefix+"close_icon.png");
	max_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\"+icon_prefix+"max_icon.png");
	reduce_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\"+icon_prefix+"reduce_icon.png");	
	mini_icon = gdi.Image(theme_img_path + "\\icons\\"+icons_folder+"\\minimode_icon.png");		
		
	build_buttons();
}
function get_colors(){
	switch(true){
		case (main_panel_state==0 && properties.library_dark_theme && layout_state==0):
		case (main_panel_state==1 && properties.playlists_dark_theme && layout_state==0):		
		case (main_panel_state==2 && properties.bio_dark_theme && layout_state==0):
		case (main_panel_state==3 && properties.visualization_dark_theme && layout_state==0):	
		case (properties.minimode_dark_theme && layout_state==1):	
			properties.darklayout = true;		
		break;
		default:
			properties.darklayout = false;				
		break;		
	}
	if (properties.darklayout) {
		if(!properties.showwallpaper) properties.wallpapermode_temp = 99;
		else properties.wallpapermode_temp = properties.wallpapermode;	
		g_color_normal_bg = GetGrey(16);			
		wallpaper_overlay = GetGrey(0,200);
		wallpaper_overlay_blurred = GetGrey(0,140);		
		
		btn_inactive_opacity = 110;
		g_color_inactive_txt = GetGrey(110);
		active_tab_color = GetGrey(255);
		active_tab_line_height = 1;
		
		g_color_normal_txt = GetGrey(240);
		g_color_faded_txt = GetGrey(240);
		g_color_full_txt = GetGrey(255);	
		
		search_txt_color = GetGrey(240);	
		search_line_color = GetGrey(255,35);	
		search_reset_icon = GetGrey(255);
		bottom_line_color = GetGrey(255,35);		
		icons_folder = "white";
		g_color_selected_bg = RGBA(015,177,255,160);
		Titlebar_btn_hover_bg = GetGrey(255,50);	
		Settings_btn_hover_bg = GetGrey(255,30);		
		cSearchBox.marginBottom = 3;
	}
	else {
		properties.wallpapermode_temp = properties.wallpapermode;	
		g_color_normal_bg = GetGrey(255);				
		wallpaper_overlay = GetGrey(255,235);
		wallpaper_overlay_blurred = GetGrey(255,235);
		
		btn_inactive_opacity = 255;	
		g_color_inactive_txt = GetGrey(0);
		active_tab_color = GetGrey(0);
		active_tab_line_height = 2;
		
		g_color_normal_txt = GetGrey(0);
		g_color_faded_txt = GetGrey(0);
        g_color_full_txt = GetGrey(0);		
		
		search_txt_color = GetGrey(70);		
	
		search_line_color=GetGrey(0,49);
		search_reset_icon = GetGrey(0);		
		bottom_line_color =  GetGrey(210);	
		icons_folder = "";
		g_color_selected_bg = RGBA(015,177,255,100);	
		Titlebar_btn_hover_bg = GetGrey(0,27);		
		Settings_btn_hover_bg = GetGrey(0,7);			
	}		
	build_images();
} get_colors();

function Lightswitch(switch_all,new_state){	
	switch_all = typeof switch_all !== 'undefined' ? switch_all : false;
	new_state = typeof new_state !== 'undefined' ? new_state : !properties.darklayout;	

	if(layout_state==1 || switch_all){
		if(switch_all) properties.minimode_dark_theme=new_state;
		else properties.minimode_dark_theme=!properties.minimode_dark_theme;   
        window.NotifyOthers("minimode_dark_theme",properties.minimode_dark_theme);
		window.SetProperty("MINIMODE dark theme", properties.minimode_dark_theme);	
		get_colors();g_searchbox.adapt_look_to_layout();
        if(!switch_all) window.Repaint();	 		
	} 
	if((main_panel_state==0 && layout_state==0) || switch_all){
		if(switch_all) properties.library_dark_theme=new_state;		
		else properties.library_dark_theme=!properties.library_dark_theme;   
        window.NotifyOthers("library_dark_theme",properties.library_dark_theme);
		window.SetProperty("LIBRARY dark theme", properties.library_dark_theme);	
		on_notify_data("library_dark_theme",properties.library_dark_theme);		
        if(!switch_all) window.Repaint();				
	} 
	if((main_panel_state==1 && layout_state==0) || switch_all){
		if(switch_all) properties.playlists_dark_theme=new_state;		
		else properties.playlists_dark_theme=!properties.playlists_dark_theme;   
        window.NotifyOthers("playlists_dark_theme",properties.playlists_dark_theme);	
		window.SetProperty("PLAYLISTS dark theme", properties.playlists_dark_theme);	
		on_notify_data("playlists_dark_theme",properties.playlists_dark_theme);			
		fb.RunMainMenuCommand("View/ElPlaylist/Refresh");
        if(!switch_all) window.Repaint();		
	} 
	if((main_panel_state==2 && layout_state==0) || switch_all){
		if(switch_all) properties.bio_dark_theme=new_state;		
		else properties.bio_dark_theme=!properties.bio_dark_theme;   
        window.NotifyOthers("bio_dark_theme",properties.bio_dark_theme);
		window.SetProperty("BIO dark theme", properties.bio_dark_theme);	
		on_notify_data("bio_dark_theme",properties.bio_dark_theme);			
        if(!switch_all) window.Repaint();	
	} 
	if((main_panel_state==3 && layout_state==0) || switch_all){
		if(switch_all) properties.visualization_dark_theme=new_state;		
		else properties.visualization_dark_theme=!properties.visualization_dark_theme;   
        window.NotifyOthers("visualization_dark_theme",properties.visualization_dark_theme);
		window.SetProperty("VISUALIZATION dark theme", properties.visualization_dark_theme);	
		on_notify_data("visualization_dark_theme",properties.visualization_dark_theme);			
	}
	if(switch_all){	
		properties.screensaver_dark_theme=new_state;
		window.SetProperty("SCREENSAVER dark theme", properties.screensaver_dark_theme);				
		window.NotifyOthers('screensaver_dark_theme',properties.screensaver_dark_theme);	
	}
	if(switch_all) window.Repaint();
}
function toggleNowPlayingState(){
	switch(main_panel_state){
		case 0:
			set_nowplayinglib_state(1-nowplayinglib_state);
		break;
		case 1:
			set_nowplayingplaylist_state(1-nowplayingplaylist_state);
		break;
		case 2:
			set_nowplayingbio_state(1-nowplayingbio_state);
		break;
		case 3:
			set_nowplayingvisu_state(1-nowplayingvisu_state);
		break;		
	}
	build_buttons();
	window.Repaint();	
}
function build_buttons(){	
	if(btn_initialized){		
		buttons.Library.N_img = library_img;
		buttons.Library.H_img = library_img;
		buttons.Library.D_img = buttons.Library.H_img;
		
		buttons.Playlists.N_img = playlist_img;
		buttons.Playlists.H_img = playlist_img;
		buttons.Playlists.D_img = buttons.Playlists.H_img;
		
		buttons.Artist_Bio.H_img = artist_bio_img;
		buttons.Artist_Bio.N_img = artist_bio_img;
		buttons.Artist_Bio.D_img = buttons.Artist_Bio.H_img;
		
		buttons.Visualization.H_img = visualization_img;
		buttons.Visualization.N_img = visualization_img;
		buttons.Visualization.D_img = buttons.Visualization.H_img;

		buttons.Lightswitch.H_img = lightswitch_img;
		buttons.Lightswitch.N_img = lightswitch_img;
		buttons.Lightswitch.D_img = buttons.Lightswitch.H_img;	
		
		if(getNowPlayingState()==1) buttons.NowPlaying.H_img = nowplaying_on_icon;
		else buttons.NowPlaying.H_img = nowplaying_off_icon;
		buttons.NowPlaying.N_img = buttons.NowPlaying.H_img;
		buttons.NowPlaying.D_img = buttons.NowPlaying.H_img;			
			
		buttons.Idle.H_img = idle_img;
		buttons.Idle.N_img = idle_img;
		buttons.Idle.D_img = buttons.Idle.H_img;	
		
		buttons.ShowSearch.H_img = search_toggle_img;
		buttons.ShowSearch.N_img = search_toggle_img;
		buttons.ShowSearch.D_img = buttons.ShowSearch.H_img;			
		
		buttons.Fullscreen.H_img = fullscreen_img;
		buttons.Fullscreen.N_img = fullscreen_img;
		buttons.Fullscreen.D_img = buttons.Fullscreen.H_img;
				
		buttons.Settings.H_img = global_settings_img;
		buttons.Settings.N_img = global_settings_img;
		buttons.Settings.D_img = buttons.Settings.H_img;
				
		buttons.Close.N_img = close_icon;
		buttons.Close.H_img = close_icon_hover;
		buttons.Close.D_img = buttons.Close.H_img;
		
		buttons.Max.H_img = max_icon;
		buttons.Max.N_img = max_icon;
		buttons.Max.D_img = buttons.Max.H_img;
		buttons.Max.hover_color = Titlebar_btn_hover_bg;
		
		buttons.Mini.N_img = mini_icon;
		buttons.Mini.H_img = mini_icon;
		buttons.Mini.D_img = buttons.Mini.H_img;		
		buttons.Mini.hover_color = Titlebar_btn_hover_bg;		
		
		buttons.Reduce.H_img = reduce_icon;
		buttons.Reduce.N_img = reduce_icon;	
		buttons.Reduce.D_img = buttons.Reduce.H_img;
		buttons.Reduce.hover_color = Titlebar_btn_hover_bg;
	} else {
		btn_initialized = true;
		buttons = {	
			Library: new SimpleButton(btn.left_m+btn.margin*0, btn.top_m, Library_width, btn.height, "Library", function () {
				set_main_panel_state(0);
				get_colors();g_searchbox.adapt_look_to_layout();
			}, false,false,library_img,library_img,0, false, false, true),
			Playlists: new SimpleButton(btn.left_m+Library_width+btn.margin*1, btn.top_m, Playlists_width, btn.height, "Playlists", function () {
				set_main_panel_state(1);	
				get_colors();g_searchbox.adapt_look_to_layout();
			}, false,false,playlist_img,playlist_img,1, false, false, true),		
			Artist_Bio: new SimpleButton(btn.left_m+Library_width+Playlists_width+btn.margin*2, btn.top_m, Artist_width, btn.height, "Now playing", function () {
				set_main_panel_state(2);
				get_colors();g_searchbox.adapt_look_to_layout();		
			}, false,false,artist_bio_img,artist_bio_img,2, false, false, true),  
			Visualization: new SimpleButton(btn.left_m+Library_width+Playlists_width+Artist_width+btn.margin*3, btn.top_m, Visu_width, btn.height, "Visualization", function () {
				set_main_panel_state(3);
				get_colors();g_searchbox.adapt_look_to_layout();	
			}, false,false,visualization_img,visualization_img,3, false, false, true),
			NowPlaying: new SimpleButton(-36, btn.top_m, Fullscreen_width, btn.height, "", function () {
				toggleNowPlayingState();
			}, false, false,nowplaying_off_icon,nowplaying_off_icon,-1, false, false, true),			
			Lightswitch: new SimpleButton(-36, btn.top_m, Fullscreen_width, btn.height, "", function () {
				Lightswitch();
			}, false, false,lightswitch_img,lightswitch_img,-1, false, false, true),		
			Idle: new SimpleButton(-112, btn.top_m, Fullscreen_width, btn.height, "", function () {
				set_screensaver_state(1);SetPseudoCaption();
			}, false,false,idle_img,idle_img,-1, false, false, true),				
			Fullscreen: new SimpleButton(-74, btn.top_m, Fullscreen_width, btn.height, "", function () {
				fb.RunMainMenuCommand('View/Fullscreen');   
			}, false,false,fullscreen_img,fullscreen_img,-1, false, false, true),		
			ShowSearch: new SimpleButton(-150, btn.top_m, Fullscreen_width, btn.height, "", function () {
				toggleSearch();
			}, false,false,search_toggle_img,search_toggle_img,-1, false, false, true),				
			Settings: new SimpleButton(2, -2, Settings_width, btn.height-3, "Foobar", function () {
				draw_main_menu(0, 28);
			}, false,false,global_settings_img,global_settings_img,-1, false, false, false),
			Close: new SimpleButton(-45, 0, 45, 29, "", false, function () {
				fb.RunMainMenuCommand('File/Exit');   
			},false,close_icon,close_icon_hover,-1,false,RGB(232,17,35),true),
			Max: new SimpleButton(-90, 0, 45, 29, "", false, function () {
				if(layout_state==1){
					toggleLayoutMode();get_colors();g_searchbox.adapt_look_to_layout();
					buttons.Max.changeState(ButtonStates.normal);
				} else {
					if(UIHacks.MainWindowState==WindowState.Normal)
						UIHacks.MainWindowState=WindowState.Maximized;
					else
						UIHacks.MainWindowState=WindowState.Normal;	
				}				
			},false,max_icon,max_icon,-1,false,Titlebar_btn_hover_bg,true),	
			Mini: new SimpleButton(-135, 0, 45, 29, "", false, function () {
				toggleLayoutMode();get_colors();g_searchbox.adapt_look_to_layout();
			},false,mini_icon,mini_icon,-1,false,Titlebar_btn_hover_bg,true),			
			Reduce: new SimpleButton(-180, 0, 45, 29, "", false, function () {
				UIHacks.MainWindowState=WindowState.Minimized;
			},false,reduce_icon,reduce_icon,-1,false,Titlebar_btn_hover_bg,true)		
		}
	}	
}
function toggleSearch(new_search_state){
	g_searchbox.toggleVisibility();
	if(!g_searchbox.hide) g_searchbox.inputbox.activate(0,0);
}
function toggleLayoutMode(new_layout_state){
		new_layout_state = typeof new_layout_state !== 'undefined' ? new_layout_state : 1-layout_state;
		
		if(new_layout_state==1) {
			if(!UIHacks.FullScreen && UIHacks.MainWindowState==0){
				properties.fullMode_savedwidth=window.Width;
				window.SetProperty("Full mode saved width", properties.fullMode_savedwidth);			
			} else {
				UIHacks.FullScreen = false;
				UIHacks.MainWindowState=0;
			}
			set_layout_state(1);	
			UIHacks.MinSize.Width=globalProperties.miniMode_minwidth;
			UIHacks.MinSize.Height=globalProperties.miniMode_minwidth;			
			UIHacks.MaxSize.Width=properties.miniMode_savedwidth;
			UIHacks.MaxSize.Height=properties.miniMode_playlistheight+properties.minicontrolsHeight+window.Height;
			UIHacks.MaxSize=true;	
			maxsize_disabling = window.SetTimeout(function(){
				window.ClearTimeout(maxsize_disabling);
				maxsize_disabling = false;
				UIHacks.MaxSize=false;				
			}, 100);
			adapt_buttons_to_layout()
		} else {		
			if(!UIHacks.FullScreen && UIHacks.MainWindowState==0){
				properties.miniMode_savedwidth=window.Width;
				window.SetProperty("Mini mode saved width", properties.miniMode_savedwidth);	
			} else {
				UIHacks.FullScreen = false;
				UIHacks.MainWindowState=0;
			}
			set_layout_state(0);	
			UIHacks.MinSize=true;		
			UIHacks.MinSize.Width=Math.max(properties.fullMode_savedwidth,globalProperties.fullMode_minwidth);
			UIHacks.MinSize.Height=Math.max(properties.fullMode_pmanagerheight+properties.fullcontrolsHeight+window.Height,globalProperties.fullMode_minheight);		
			minsize_disabling = window.SetTimeout(function(){
				window.ClearTimeout(minsize_disabling);
				minsize_disabling = false;
				UIHacks.MinSize.Width=650;
				UIHacks.MinSize.Height=300;				
			}, 100);			
			adapt_buttons_to_layout()		
		}	
}
function adapt_buttons_to_layout(){
	if(layout_state==1) {
		g_searchbox.toggleVisibility(true);
		buttons.Artist_Bio.changeState(ButtonStates.hide)		
		buttons.Playlists.changeState(ButtonStates.hide)
		buttons.Library.changeState(ButtonStates.hide)
		buttons.Settings.changeState(ButtonStates.normal)
		buttons.Fullscreen.changeState(ButtonStates.hide)
		buttons.Idle.changeState(ButtonStates.hide)		
		buttons.Visualization.changeState(ButtonStates.hide)
		buttons.Mini.changeState(ButtonStates.hide)
		buttons.NowPlaying.changeState(ButtonStates.hide);		
		buttons.Mini.hide = true;		
		buttons.Settings.first_draw = true;

		if(!properties.showLightswitchBtn) 
			buttons.Lightswitch.changeState(ButtonStates.hide);
		else buttons.Lightswitch.changeState(ButtonStates.normal);		
		
		buttons.Lightswitch.x = -36;
		
		cSearchBoxMini.marginRight = ((properties.showLightswitchBtn)?34:0);		
				
		buttons.Close.x = -36;
		buttons.Close.y = 0;
		buttons.Close.w = 36;
		buttons.Close.h = 28;
		
		buttons.Max.x = -68;
		buttons.Max.y = 0;	
		buttons.Max.w = 32;
		buttons.Max.h = 28;
		
		buttons.Reduce.x = -100;
		buttons.Reduce.y = 0;	
		buttons.Reduce.w = 32;
		buttons.Reduce.h = 28;	

		if(properties.tracktitle_ontop) buttons.Settings.w = buttons.Settings.N_img.Width+4;
		else buttons.Settings.w = 55+buttons.Settings.N_img.Width+btn.padding/2;	
	} else{
		if(!properties.alwaysShowSearch && g_searchbox.inputbox.text.length == 0) {
			g_searchbox.toggleVisibility(false);
		} else g_searchbox.toggleVisibility(true);
		buttons.Mini.hide = false;				
		//buttons.Minimode.changeState(ButtonStates.normal)
		buttons.Mini.changeState(ButtonStates.normal)			
		//buttons.Visualization.changeState(ButtonStates.normal)	
		//buttons.Artist_Bio.changeState(ButtonStates.normal)		
		//buttons.Playlists.changeState(ButtonStates.normal)
		buttons.Library.changeState(ButtonStates.normal)
		buttons.Settings.changeState(ButtonStates.normal)

		if(!properties.showFullscreenBtn) 
			buttons.Fullscreen.changeState(ButtonStates.hide);
		else buttons.Fullscreen.changeState(ButtonStates.normal);			

		buttons.Idle.changeState(ButtonStates.normal)			
		//buttons.Minimode.x = -112;
		buttons.Settings.first_draw = true;	
		
		if(!properties.showIdleScreenBtn) 
			buttons.Idle.changeState(ButtonStates.hide);
		else buttons.Lightswitch.changeState(ButtonStates.normal);
		
		if(!properties.showLightswitchBtn) 
			buttons.Lightswitch.changeState(ButtonStates.hide);
		else buttons.Lightswitch.changeState(ButtonStates.normal);
		
		if(!properties.showNowPlayingBtn) 
			buttons.NowPlaying.changeState(ButtonStates.hide);
		else buttons.NowPlaying.changeState(ButtonStates.normal);
		
		buttons.Lightswitch.x = -36 - ((properties.showNowPlayingBtn)?38:0);
		buttons.Fullscreen.x = -36 - ((properties.showLightswitchBtn)?38:0) - ((properties.showNowPlayingBtn)?38:0);
		buttons.Idle.x = -36 - ((properties.showLightswitchBtn)?38:0) - ((properties.showFullscreenBtn)?38:0) - ((properties.showNowPlayingBtn)?38:0);
		buttons.ShowSearch.x = -36 - ((properties.showLightswitchBtn)?38:0) - ((properties.showIdleScreenBtn)?38:0) - ((properties.showFullscreenBtn)?38:0) - ((properties.showNowPlayingBtn)?38:0);
		
		cSearchBoxMainLight.marginRight = 14 + ((properties.showLightswitchBtn)?38:0) + ((properties.showIdleScreenBtn)?38:0) + ((properties.showFullscreenBtn)?38:0) + ((properties.showNowPlayingBtn)?38:0);
		cSearchBoxMainDark.marginRight = 14 + ((properties.showLightswitchBtn)?38:0) + ((properties.showIdleScreenBtn)?38:0) + ((properties.showFullscreenBtn)?38:0) + ((properties.showNowPlayingBtn)?38:0);
		if(!properties.showLightswitchBtn && !properties.showIdleScreenBtn && !properties.showFullscreenBtn && !properties.showNowPlayingBtn){
			cSearchBoxMainLight.marginRight -= 10;
			cSearchBoxMainDark.marginRight -= 10;
			
		}
		
		buttons.Close.x = -45;
		buttons.Close.y = 0;				
		buttons.Close.w = 45;
		buttons.Close.h = 29;
		
		buttons.Max.x = -90;
		buttons.Max.y = 0;	
		buttons.Max.w = 45;
		buttons.Max.h = 29;
		
		buttons.Reduce.x = -180;
		buttons.Reduce.y = 0;	
		buttons.Reduce.w = 45;
		buttons.Reduce.h = 29;		
		
		buttons.Settings.w = 55+buttons.Settings.N_img.Width+btn.padding/2;	
		
		if(properties.toUpperCase) var top_margin = btn.top_m_to_uppercase;
		else var top_margin = btn.top_m;	
		buttons.Library.y = top_margin;
		buttons.Playlists.y = top_margin;
		buttons.Artist_Bio.y = top_margin;
		buttons.Visualization.y = top_margin;			
	}	
	g_searchbox.adapt_look_to_layout();
	if(!properties.show_visualization) buttons.Visualization.changeState(ButtonStates.hide)
	if(!properties.settings_caption) buttons.Settings.changeState(ButtonStates.hide)
	SetCaptionTitleSize();
	SetPseudoCaption();
}
function SetCaptionTitleSize(){
	if(layout_state==1) {	
		caption_title_x = buttons.Settings.w+15;
		caption_title_w = window.Width-130-buttons.Settings.w;		
	} else {
		caption_title_x = buttons.Settings.w+13;
		caption_title_w = window.Width-195-buttons.Settings.w;			
	}	
}
function SimpleButton(x, y, w, h, text, fonDown, fonUp, fonDbleClick, N_img, H_img, btn_index, state, hover_color, hover_bar_bottom) {
    this.state = state ? state : ButtonStates.normal;
    this.x = x;
    this.y = y;
    this.w = w; 
    this.h = h;
    this.hide = false;	
    this.text = text;
    this.fonDown = fonDown;
    this.fonUp = fonUp;	
    this.fonDbleClick = fonDbleClick;
    this.N_img = N_img;
    this.H_img = H_img;   
    this.D_img = H_img; 
    this.btn_index = btn_index; 
	this.first_draw=true;	
    this.hover_color = hover_color;
	this.text_toUpper = '';
    this.hover_bar_bottom = hover_bar_bottom;
	
    this.opacity = 255;	
	
    this.containXY = function (x, y) {
		if(this.x<0) return (window.Width+this.x <= x) && (x <= window.Width + this.x + this.w) && (this.y <= y) && (y <= this.y + this.h);
        else return (this.x <= x) && (x <= this.x + this.w) && (this.y <= y) && (y <= this.y + this.h);
    }    
    this.changeState = function (state) {
        var old = this.state;
        this.state = state;
        return old;
    }    
    this.Togglehide = function () {
		this.hide = !this.hide;	
    }   	
    this.draw = function (gr) {
		
		if(this.first_draw && this.text!="") {
			if(this.text == "Foobar"){
				if(!(properties.tracktitle_ontop && layout_state==1)) 
					this.w = Math.round(gr.CalcTextWidth(this.text, g_font.normal)+this.N_img.Width+btn.padding/2)+17;
					SetCaptionTitleSize();					
			} else {
				if(properties.toUpperCase) {
					this.text_toUpper = this.text.toUpperCase();
					var text2_draw = this.text_toUpper;
				} else {
					this.text_toUpper = '';
					var text2_draw = this.text;			
				}
			
				this.w = Math.round(gr.CalcTextWidth(text2_draw, g_font.normal)+this.N_img.Width+btn.padding/2)+3;
			}
		}
		this.first_draw=false;
		
		if(this.x<0) var real_x_position = window.Width+this.x;
		else var real_x_position = this.x;
		
        if (this.state == ButtonStates.hide || this.hide) return;
        b_img=this.N_img;
				
        switch (this.state)
        {
			case ButtonStates.normal:
				b_img=this.N_img;
				break;
			case ButtonStates.hover:
				b_img=this.H_img;
				break;
			case ButtonStates.hoverinactive:
				b_img=this.N_img;
				break;
			case ButtonStates.down:
				b_img=this.D_img;       
				break;
			case ButtonStates.hide:
				return;
        }
		
		if(this.hover_color && (this.state==ButtonStates.hover || this.state==ButtonStates.down))  gr.FillSolidRect(real_x_position, this.y, this.w, this.h, this.hover_color);
		
		var adjust_bar_x = (this.text!="") ? 3 : 0;
		
		if(this.text == "Foobar"){
			gr.DrawRect(real_x_position-adjust_bar_x, -1, this.w+1, this.h, 1.0, search_line_color);
			if(this.state==ButtonStates.hover){
					gr.FillSolidRect(real_x_position-adjust_bar_x+1, -1, this.w, this.h, Settings_btn_hover_bg);
			}
			if(layout_state==0 || !properties.tracktitle_ontop){
				if(this.state==ButtonStates.hover){
					gr.DrawImage(g_searchbox.images.search_history_hover_icon, real_x_position-adjust_bar_x+this.w-20, Math.round(this.h/2 - g_searchbox.images.search_history_icon.Height/2), g_searchbox.images.search_history_hover_icon.Width, g_searchbox.images.search_history_hover_icon.Height, 0, 0, g_searchbox.images.search_history_hover_icon.Width, g_searchbox.images.search_history_hover_icon.Height,0,255);
				} else {
					gr.DrawImage(g_searchbox.images.search_history_icon, real_x_position-adjust_bar_x+this.w-20, Math.round(this.h/2 - g_searchbox.images.search_history_icon.Height/2), g_searchbox.images.search_history_icon.Width, g_searchbox.images.search_history_icon.Height, 0, 0, g_searchbox.images.search_history_icon.Width, g_searchbox.images.search_history_hover_icon.Height,0,255);			
				}	
			} else if(layout_state==1 && !properties.tracktitle_ontop){
				if(this.state==ButtonStates.hover){
					gr.DrawImage(g_searchbox.images.search_history_hover_icon, real_x_position-adjust_bar_x+this.w-21, Math.round(this.h/2 - g_searchbox.images.search_history_icon.Height/2)-2, g_searchbox.images.search_history_hover_icon.Width, g_searchbox.images.search_history_hover_icon.Height, 0, 0, g_searchbox.images.search_history_hover_icon.Width, g_searchbox.images.search_history_hover_icon.Height,0,255);
				} else {
					gr.DrawImage(g_searchbox.images.search_history_icon, real_x_position-adjust_bar_x+this.w-21, Math.round(this.h/2 - g_searchbox.images.search_history_icon.Height/2)-2, g_searchbox.images.search_history_icon.Width, g_searchbox.images.search_history_icon.Height, 0, 0, g_searchbox.images.search_history_icon.Width, g_searchbox.images.search_history_hover_icon.Height,0,255);			
				}	
			}		
		}
		

		text_color = g_color_normal_txt;
		if(this.text=="" && !this.hover_color && (this.state==ButtonStates.hover || this.state==ButtonStates.down)) {
			if(this.hover_bar_bottom) gr.FillSolidRect(real_x_position-adjust_bar_x, wh-active_tab_line_height, this.w-9, active_tab_line_height, active_tab_color);
			btn_opacity = 255;
		} else if((main_panel_state==this.btn_index || this.state==ButtonStates.hover || this.state==ButtonStates.down) && !this.hover_color ) {
			if(this.hover_bar_bottom) gr.FillSolidRect(real_x_position-adjust_bar_x, wh-active_tab_line_height, this.w, active_tab_line_height, active_tab_color);
			btn_opacity = 255;
			text_color = g_color_normal_txt;
		} else if(this.text=="") {
			btn_opacity = 255;
		} else {
			btn_opacity = (this.text == "Foobar")?255:btn_inactive_opacity;
			text_color = (this.text == "Foobar")?g_color_normal_txt:g_color_inactive_txt;			
		}
		
        switch (this.state)
        {    
        case ButtonStates.normal:            
            gr.DrawImage(b_img, real_x_position, this.y+Math.ceil((this.h-b_img.Height)/2)-1+btn.top_padding, b_img.Width, b_img.Height, 0, 0, b_img.Width, b_img.Height,0,btn_opacity);
            break;
        default:            
            gr.DrawImage(b_img, real_x_position, this.y+Math.ceil((this.h-b_img.Height)/2)-1+btn.top_padding, b_img.Width, b_img.Height, 0, 0, b_img.Width, b_img.Height,0,btn_opacity);
            break;            
        }   
		
		try{
			if(this.text!="" && !(this.text == "Foobar" && layout_state==1 && properties.tracktitle_ontop)) {
				if(this.text_toUpper!='') var text2_draw = this.text_toUpper;
				else var text2_draw = this.text;
				gr.GdiDrawText(text2_draw, g_font.normal, text_color, real_x_position+b_img.Width, this.y+btn.top_padding, this.w, this.h, DT_LEFT| DT_VCENTER | DT_CALCRECT | DT_NOPREFIX);			
			}
		} catch(e){}
    }
    this.onMouse = function (state) {    
		switch(state){
			case 'lbtn_down':
				this.fonDown && this.fonDown();
			break;				
			case 'lbtn_up':
				this.fonUp && this.fonUp();
			break;
			case 'dble_click':
				if(this.fonDbleClick) {this.fonDbleClick && this.fonDbleClick();}
			break;
		}
        
    }  
}

function drawAllButtons(gr) {
    for (var i in buttons) {
        buttons[i].draw(gr);
    }
}

function chooseButton(x, y) {
    for (var i in buttons) {
        if (buttons[i].containXY(x, y) && buttons[i].state != ButtonStates.hide && !buttons[i].hide) return buttons[i];
    }

    return null;
}
function set_main_btns_visibility(){
	if(!g_searchbox.hide) searchbox_width = cSearchBox.width;
	else searchbox_width = 0;
	
	if(properties.show_visualization){
		if(ww-cSearchBox.marginRight-searchbox_width<btn.left_m+Library_width+Playlists_width+Artist_width+Visu_width+btn.padding*3) buttons.Visualization.state = ButtonStates.hide
		else buttons.Visualization.state = ButtonStates.normal
	}
	if(ww-cSearchBox.marginRight-searchbox_width<btn.left_m+Library_width+Playlists_width+Artist_width+btn.padding*2) buttons.Artist_Bio.state = ButtonStates.hide
	else buttons.Artist_Bio.state = ButtonStates.normal;
	if(ww-cSearchBox.marginRight-searchbox_width<btn.left_m+Library_width+Playlists_width+btn.padding*1) buttons.Playlists.state = ButtonStates.hide
	else buttons.Playlists.state = ButtonStates.normal;		
}
// -------------------------------- WSH Callbacks -------------------------------------------
function on_size(){  
    ww = Math.max(window.Width,globalProperties.miniMode_minwidth);
    wh = window.Height;
	g_searchbox.on_size();	
	if(layout_state==0){
		if(!UIHacks.FullScreen && UIHacks.MainWindowState==0) properties.fullMode_savedwidth=ww;
		set_main_btns_visibility();
	}
	SetPseudoCaption();	
	SetCaptionTitleSize();
	if(UIHacks.FullScreen || UIHacks.MainWindowState==2){
		UIHacks.Aero.Left=0;
		UIHacks.Aero.Right=0;
		UIHacks.Aero.Top=0;
		UIHacks.Aero.Bottom=0;				
	} else {
		UIHacks.Aero.Left=0;
		UIHacks.Aero.Right=0;
		UIHacks.Aero.Top=0;
		UIHacks.Aero.Bottom=1;							
	}	
    // set wallpaper
    if(fb.IsPlaying && properties.showwallpaper) {
        //g_wallpaperImg = setWallpaperImg(default_wallpaperpath, fb.GetNowPlaying());
    }	
}  
function SetPseudoCaption(){
	if(screensaver_state==1){
		UIHacks.SetPseudoCaption(0, 8, ww-128, 25);
	} else if(layout_state==0) {
		UIHacks.SetPseudoCaption(buttons.Settings.w+buttons.Settings.x, 8, ww-280, 25);
	} else {
		UIHacks.SetPseudoCaption(buttons.Settings.w+buttons.Settings.x, 8, ww-103-buttons.Settings.w, 25);	
	}		
}
function on_paint(gr) {
	gr.SetTextRenderingHint(globalProperties.TextRendering);
	
    //BG
	if(!properties.showwallpaper){
		gr.FillSolidRect(0, 0, ww, wh, g_color_normal_bg);
	}
    // BG wallpaper	
    if(properties.showwallpaper && (typeof(g_wallpaperImg) == "undefined" || !g_wallpaperImg || update_wallpaper)) {
        g_wallpaperImg = setWallpaperImg(default_wallpaperpath, fb.GetNowPlaying());
    };	
	if(properties.showwallpaper && g_wallpaperImg) {
		gr.DrawImage(g_wallpaperImg, 0, 0, ww, wh, 0, 0, g_wallpaperImg.Width, g_wallpaperImg.Height);
		gr.FillSolidRect(0, 0, ww, wh, (properties.wallpaperblurred)?wallpaper_overlay_blurred:wallpaper_overlay);
	} 
	
	if(!properties.settings_caption){
		gr.DrawImage(foobar_icon, 10, 3, foobar_icon.Width, foobar_icon.Height, 0, 0, foobar_icon.Width, foobar_icon.Height,0,255);
	}

	switch(true){
		case (main_panel_state==0 && ((properties.library_dark_theme && !properties.darklayout) || (!properties.library_dark_theme && properties.darklayout)) && layout_state==0):
		case (main_panel_state==1 && ((properties.playlists_dark_theme && !properties.darklayout) || (!properties.playlists_dark_theme && properties.darklayout)) && layout_state==0):		
		case (main_panel_state==2 && ((properties.bio_dark_theme && !properties.darklayout) || (!properties.bio_dark_theme && (properties.darklayout || (properties.bio_stick2darklayout && nowplayingbio_state==0)))) && layout_state==0):
		case (main_panel_state==3 && layout_state==0 && nowplayingvisu_state==0):	
		case (((properties.minimode_dark_theme && !properties.darklayout) || (!properties.minimode_dark_theme && properties.darklayout)) && layout_state==1):			
		break;
		default:
			gr.FillSolidRect(0, wh-1, ww, 2, bottom_line_color);		
		break;		
	}	
    drawAllButtons(gr);	
	
	if(properties.tracktitle_ontop){
		gr.GdiDrawText(caption_title, g_font.normal, g_color_normal_txt, caption_title_x, 0, caption_title_w, 29, DT_LEFT| DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_END_ELLIPSIS);
	}	
	
	if(layout_state==0){
		g_searchbox.draw(gr, ww - cSearchBox.width - cSearchBox.marginRight, cSearchBox.marginTop);			
	} else {
		g_searchbox.draw(gr, cSearchBox.marginLeft, cSearchBox.marginTop);	
	}
}
function on_playback_new_track(metadb){
	setPlaybackPlaylist();
	eval_caption_title(metadb);
	if(properties.showwallpaper && properties.wallpapermode == 0) {
		g_wallpaperImg = setWallpaperImg(default_wallpaperpath, metadb);
	};
	window.Repaint();	
}
function eval_caption_title(metadb){
	if(metadb)
		caption_title = fb.TitleFormat(properties.tracktitle_format).evalWithMetadb(metadb);	
}
function on_playback_stop(reason) {
	switch(reason) {
	case 0: // user stop
	case 1: // eof (e.g. end of playlist)
		caption_title = caption_title_default;
		g_wallpaperImg = null;		
		break;
	case 2: // starting_another (only called on user action, i.e. click on next button)
		break;
	};	
	window.Repaint();
}

function on_mouse_move(x,y){
	if(m_x==x && m_y==y) return;
	notifyMouseMove();	
	m_x = x;
	m_y = y;	
    g_searchbox.on_mouse("move", x, y);
	//Buttons
    var old = cur_btn;
    cur_btn = chooseButton(x, y);
    
    if (old == cur_btn) {
       // if (btn_down) return;
    } else if (btn_down && cur_btn && cur_btn.state != ButtonStates.down) {
        cur_btn.changeState(ButtonStates.down);
        window.Repaint();
        return;
    } else {        
        old && old.changeState(ButtonStates.normal);
        cur_btn && cur_btn.changeState(ButtonStates.hover);
        window.Repaint();	
    }
}

function on_mouse_leave() {
    g_searchbox.on_mouse("leave", 0, 0);	
    btn_down = false;    
    if (cur_btn) {
        cur_btn.changeState(ButtonStates.normal);
		repaint=true;
        cur_btn=null;
    }	
	window.Repaint();
}

function on_mouse_lbtn_down(x,y){
	g_searchbox.on_mouse("lbtn_down", x, y);
    btn_down = true;
    if (cur_btn !== null && typeof cur_btn === 'object') {	
        cur_btn.changeState(ButtonStates.down);	
		cur_btn.onMouse('lbtn_down');			
        window.Repaint();
    }	
}

function on_mouse_lbtn_up(x,y){
	g_searchbox.on_mouse("lbtn_up", x, y);
    btn_down = false;    
    if (cur_btn !== null && typeof cur_btn === 'object') {
		cur_btn.onMouse('lbtn_up');
        window.Repaint();
    }
}
function on_mouse_lbtn_dblclk(x, y) {
    if (cur_btn) {
        cur_btn.onMouse('dble_click');
        window.Repaint();
    }
}
function on_mouse_rbtn_down(x, y, mask) {
	g_searchbox.on_mouse("rbtn_down", x, y);
}
function on_mouse_rbtn_up(x, y){
        var _menu = window.CreatePopupMenu();	
        var _screensaver = window.CreatePopupMenu();			
        var idx;
		
		_menu.AppendMenuItem(MF_STRING, 103, "Settings...");
		_menu.AppendMenuSeparator();	
		
		if(layout_state==0) {
			_menu.AppendMenuItem(MF_STRING, 1, "Library");			
			_menu.AppendMenuItem(MF_STRING, 2, "Playlists");	
			_menu.AppendMenuItem(MF_STRING, 3, "Now playing");	
			if(properties.show_visualization) _menu.AppendMenuItem(MF_STRING, 4, "Visualization");			
			_menu.CheckMenuRadioItem(1, 4, main_panel_state+1);
			_menu.AppendMenuSeparator();
			_screensaver.AppendMenuItem(MF_STRING, 8, "Activate Now");	
			_screensaver.AppendMenuSeparator(); 
			_screensaver.AppendMenuItem(MF_STRING, 9, "Enable");	
			_screensaver.CheckMenuItem(9,globalProperties.enable_screensaver);
			_screensaver.AppendMenuItem(MF_STRING, 10, "Escape on mouse move");	
			_screensaver.CheckMenuItem(10,globalProperties.escape_on_mouse_move);	
			_screensaver.AppendMenuSeparator(); 
			_screensaver.AppendMenuItem(MF_STRING, 13, "Light theme");			
			_screensaver.AppendMenuItem(MF_STRING, 12, "Dark theme");
			_screensaver.CheckMenuRadioItem(12, 13, (properties.screensaver_dark_theme)?12:13);		
			_screensaver.AppendMenuSeparator(); 
			_screensaver.AppendMenuItem(MF_STRING, 11, "Set time (current: "+Math.round(globalProperties.mseconds_before_screensaver/1000)+"s)");			
			_screensaver.AppendTo(_menu,MF_STRING, "Idle screen");				
			_menu.AppendMenuItem(MF_STRING, 6, "Switch to Compact player");	
			if(UIHacks.FullScreen)
				_menu.AppendMenuItem(MF_STRING, 5, "Quit Fullscreen");	
			else
				_menu.AppendMenuItem(MF_STRING, 5, "Fullscreen");			
		} else {
			_menu.AppendMenuItem(MF_STRING, 7, "Switch to Main player");			
		}

		
		if(utils.IsKeyPressed(VK_SHIFT)) {
			_menu.AppendMenuSeparator();		
			_menu.AppendMenuItem(MF_STRING, 100, "Properties ");
			_menu.AppendMenuItem(MF_STRING, 101, "Configure...");	
            _menu.AppendMenuSeparator();                  
			_menu.AppendMenuItem(MF_STRING, 102, "Reload");            
		}
        idx = _menu.TrackPopupMenu(x,y);
        switch(true) {
            case (idx == 1):
				set_main_panel_state(0);
				get_colors();g_searchbox.adapt_look_to_layout();
                break;  		
            case (idx == 2):
				set_main_panel_state(1);
				get_colors();g_searchbox.adapt_look_to_layout();
                break; 
            case (idx == 3):
				set_main_panel_state(2);
				get_colors();g_searchbox.adapt_look_to_layout();
                break; 
            case (idx == 4):
				set_main_panel_state(3);
				get_colors();g_searchbox.adapt_look_to_layout();
                break;	
            case (idx == 5):
				fb.RunMainMenuCommand('View/Fullscreen');
                break;		
            case (idx == 6):
				toggleLayoutMode(1);get_colors();g_searchbox.adapt_look_to_layout();
                break;	
            case (idx == 7):
				toggleLayoutMode(0);get_colors();g_searchbox.adapt_look_to_layout();
                break;	
            case (idx == 8):
				set_screensaver_state(1);SetPseudoCaption();
                break;			
            case (idx == 9):
				enableScreensaver(!globalProperties.enable_screensaver);	
                break;			
            case (idx == 10):
				escapeOnMouseMove(!globalProperties.escape_on_mouse_move);	
                break;			
            case (idx == 11):
				new_mseconds_before_screensaver = InputBox("Seconds of mouse inactivity before activation of the idle screen", "Idle screen", globalProperties.mseconds_before_screensaver/1000);
				if (!(new_mseconds_before_screensaver == "" || typeof new_mseconds_before_screensaver == 'undefined')) {
					globalProperties.mseconds_before_screensaver = Number(new_mseconds_before_screensaver);
					if(globalProperties.mseconds_before_screensaver<=0) globalProperties.mseconds_before_screensaver = 60;
					globalProperties.mseconds_before_screensaver = globalProperties.mseconds_before_screensaver*1000;
					setScreensaverTime(globalProperties.mseconds_before_screensaver);
				}				
                break;		
            case (idx == 12):
				properties.screensaver_dark_theme=true;
				window.SetProperty("SCREENSAVER dark theme", properties.screensaver_dark_theme);			
				window.NotifyOthers('screensaver_dark_theme',properties.screensaver_dark_theme);
                break;	
            case (idx == 13):
				properties.screensaver_dark_theme=false;
				window.SetProperty("SCREENSAVER dark theme", properties.screensaver_dark_theme);				
				window.NotifyOthers('screensaver_dark_theme',properties.screensaver_dark_theme);
                break;					
            case (idx == 100):
                window.ShowProperties();
                break;  
            case (idx == 101):
                window.ShowConfigure();
                break;
            case (idx == 102):
                window.Reload();
                break; 
			case (idx == 103):	
				draw_settings_menu(x,y);
                break; 				
            default:
				return true;
        }
        _menu.Dispose();
		_screensaver.Dispose();
        return true;
}
function draw_settings_menu(x,y){
        var _menu = window.CreatePopupMenu();
		var _menu3 = window.CreatePopupMenu();	
		var _menu3A = window.CreatePopupMenu();
		var _menu_button = window.CreatePopupMenu();		
        var idx;
			
		_menu.AppendMenuItem(MF_STRING, 1800, "Display played track title on top");
		_menu.CheckMenuItem(1800, properties.tracktitle_ontop)		
		_menu.AppendMenuItem(MF_STRING, 1809, "Played track title format...");		
		_menu.AppendMenuItem(MF_STRING, 1805, "Capitalize panel buttons text");
		_menu.CheckMenuItem(1805, properties.toUpperCase)			
		_menu.AppendMenuItem(MF_STRING, 1801, "Always show the search box");
		_menu.CheckMenuItem(1801, properties.alwaysShowSearch)		
		
	
		

		_menu.AppendMenuItem(MF_STRING, 1900, "Resume panel state on startup");
		_menu.CheckMenuItem(1900, properties.Remember_previous_state)
		
		_menu.AppendMenuSeparator();
		_menu_button.AppendMenuItem(MF_STRING, 1806, "Now playing");
		_menu_button.CheckMenuItem(1806, properties.showNowPlayingBtn);		
		_menu_button.AppendMenuItem(MF_STRING, 1802, "Idle screen");
		_menu_button.CheckMenuItem(1802, properties.showIdleScreenBtn);			
		_menu_button.AppendMenuItem(MF_STRING, 1803, "Light switch");
		_menu_button.CheckMenuItem(1803, properties.showLightswitchBtn);		
		_menu_button.AppendMenuItem(MF_STRING, 1804, "Fullscreen");
		_menu_button.CheckMenuItem(1804, properties.showFullscreenBtn);
		_menu_button.AppendTo(_menu,MF_STRING, "Buttons");			
		
		_menu3.AppendMenuItem(MF_STRING, 2000, "Enable");
		_menu3.CheckMenuItem(2000, properties.showwallpaper);
		_menu3.AppendMenuItem(MF_STRING, 2200, "Blur");
		_menu3.CheckMenuItem(2200, properties.wallpaperblurred);
		
		_menu3A.AppendMenuItem(MF_STRING, 2210, "Filling");
		_menu3A.CheckMenuItem(2210, properties.wallpaperdisplay==0);	
		_menu3A.AppendMenuItem(MF_STRING, 2220, "Adjust");
		_menu3A.CheckMenuItem(2220, properties.wallpaperdisplay==1);
		_menu3A.AppendMenuItem(MF_STRING, 2230, "Stretch");
		_menu3A.CheckMenuItem(2230, properties.wallpaperdisplay==2);
		_menu3A.AppendTo(_menu3,MF_STRING, "Wallpaper size");		
		
		_menu3.AppendTo(_menu,MF_STRING, "Background Wallpaper");	
		
        idx = _menu.TrackPopupMenu(x,y);
        switch(true) {
			case (idx == 1800):
				properties.tracktitle_ontop = !properties.tracktitle_ontop;
				window.SetProperty("_DISPLAY: Track title", properties.tracktitle_ontop);
				adapt_buttons_to_layout();
				window.Repaint();
				break;		
			case (idx == 1801):
				properties.alwaysShowSearch = !properties.alwaysShowSearch;
				window.SetProperty("_DISPLAY: always show search box", properties.alwaysShowSearch);
				g_searchbox.toggleVisibility(true);				
				adapt_buttons_to_layout();
				window.Repaint();
				break;			
			case (idx == 1802):
				properties.showIdleScreenBtn = !properties.showIdleScreenBtn;
				window.SetProperty("_DISPLAY: show idle screen btn", properties.showIdleScreenBtn);		
				adapt_buttons_to_layout();
				window.Repaint();
				break;							
			case (idx == 1803):
				properties.showLightswitchBtn = !properties.showLightswitchBtn;
				window.SetProperty("_DISPLAY: show light switch btn", properties.showLightswitchBtn);		
				adapt_buttons_to_layout();
				window.Repaint();
				break;	
			case (idx == 1804):
				properties.showFullscreenBtn = !properties.showFullscreenBtn;
				window.SetProperty("_DISPLAY: show fullscreen btn", properties.showFullscreenBtn);		
				adapt_buttons_to_layout();
				window.Repaint();
				break;
			case (idx == 1805):
				properties.toUpperCase = !properties.toUpperCase;
				window.SetProperty("_DISPLAY: panels btn text to uppercase", properties.toUpperCase);		
				on_font_changed();
				window.Repaint();
				break;		
			case (idx == 1806):
				properties.showNowPlayingBtn = !properties.showNowPlayingBtn;
				window.SetProperty("_DISPLAY: show now playing btn", properties.showNowPlayingBtn);		
				adapt_buttons_to_layout();
				window.Repaint();
				break;
			case (idx == 1809):
				new_caption_format = InputBox("Enter a title formatting script.\nYou can use the full foobar2000 title formatting syntax here.\n\nSee http://tinyurl.com/lwhay6f\nfor informations about foobar title formatting.", "Custom windows title", properties.tracktitle_format);
				if (!(new_caption_format == "" || typeof new_caption_format == 'undefined')) {
					properties.tracktitle_format = new_caption_format;
					window.SetProperty("_DISPLAY: Track title format", properties.tracktitle_format);	
					eval_caption_title(fb.GetNowPlaying());
				}
				window.Repaint();
				break;				
			case (idx == 1900):
				properties.Remember_previous_state = !properties.Remember_previous_state;
				window.SetProperty("Resume panel state on startup, except on visualization tab", properties.Remember_previous_state);
				window.Repaint();
				break;			
			case (idx == 2000):
				properties.showwallpaper = !properties.showwallpaper;
				window.SetProperty("_DISPLAY: Show Wallpaper", properties.showwallpaper);
				get_colors();				
				if(properties.showwallpaper) {
					g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.IsPlaying ? fb.GetNowPlaying() : null);
				};
				window.Repaint();
				break;
			case (idx == 2100):
				properties.wallpapermode = 99;
				window.SetProperty("_SYSTEM: Wallpaper Mode", properties.wallpapermode);
				if(fb.IsPlaying) g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				window.Repaint();
				break;
			case (idx == 2110):
				properties.wallpapermode = 0;
				window.SetProperty("_SYSTEM: Wallpaper Mode", properties.wallpapermode);
				if(fb.IsPlaying) g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				window.Repaint();
				break;
			case (idx == 2200):
				properties.wallpaperblurred = !properties.wallpaperblurred;
				window.SetProperty("_DISPLAY: Wallpaper Blurred", properties.wallpaperblurred);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				window.Repaint();
				break;		
			case (idx == 2210):
				properties.wallpaperdisplay = 0;
				window.SetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", properties.wallpaperdisplay);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				window.Repaint();
				break;	
			case (idx == 2220):
				properties.wallpaperdisplay = 1;
				window.SetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", properties.wallpaperdisplay);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				window.Repaint();
				break;		
			case (idx == 2230):
				properties.wallpaperdisplay = 2;
				window.SetProperty("_DISPLAY: Wallpaper 0=Filling 1=Adjust 2=Stretch", properties.wallpaperdisplay);
				g_wallpaperImg = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				window.Repaint();
				break;					 					
            default:
				return true;
        }
						
        _menu.Dispose();
		_menu3.Dispose();
		_menu3A.Dispose();
		_menu_button.Dispose();
        return true;	
}

function draw_main_menu(x,y){

    var basemenu = window.CreatePopupMenu();
    var contextman = fb.CreateContextMenuManager();

    contextman.InitNowPlaying();
    
    var child1 = window.CreatePopupMenu(); //File
    var child2 = window.CreatePopupMenu(); //Edit
    var child3 = window.CreatePopupMenu(); //View
    var child4 = window.CreatePopupMenu(); //Playback
    var child5 = window.CreatePopupMenu(); //Library
    var child6 = window.CreatePopupMenu(); //Help
    var child7 = window.CreatePopupMenu(); //Now playing
    var _screensaver = window.CreatePopupMenu();
	
    var menuman1 = fb.CreateMainMenuManager();
    var menuman2 = fb.CreateMainMenuManager();
    var menuman3 = fb.CreateMainMenuManager();
    var menuman4 = fb.CreateMainMenuManager();
    var menuman5 = fb.CreateMainMenuManager();
    var menuman6 = fb.CreateMainMenuManager();

    child1.AppendTo(basemenu, MF_STRING, "File");
    child2.AppendTo(basemenu, MF_STRING, "Edit");
    child3.AppendTo(basemenu, MF_STRING, "View");
    child4.AppendTo(basemenu, MF_STRING, "Playback");
    child5.AppendTo(basemenu, MF_STRING, "Library");
    child6.AppendTo(basemenu, MF_STRING, "Help");
    child7.AppendTo(basemenu, MF_STRING, "Now Playing"); 

	
	/*basemenu.AppendMenuSeparator();
	var schedulerMenu = window.CreatePopupMenu();
	schedulerMenu.AppendMenuItem(MF_STRING, 3018, "Do nothing");
	schedulerMenu.AppendMenuSeparator();		
	schedulerMenu.AppendMenuItem(MF_STRING, 3019, "Stop after current");
	schedulerMenu.AppendMenuItem(MF_STRING, 3020, "Hibernate after current");		
	schedulerMenu.AppendMenuItem(MF_STRING, 3021, "Shutdown after current");
	schedulerMenu.AppendMenuSeparator();
	schedulerMenu.AppendMenuItem(MF_STRING, 3022, "Hibernate after playlist");		
	schedulerMenu.AppendMenuItem(MF_STRING, 3023, "Shutdown after playlist");		
		checked_item=0;
		switch (true) {			
			case (scheduler.hibernate_after_current):
				checked_item=3020
				break; 					
			case (scheduler.shutdown_after_current):
				checked_item=3021
				break;  
			case (scheduler.hibernate_after_playlist):
				checked_item=3022
				break;  
			case (scheduler.shutdown_after_playlist):
				checked_item=3023
				break;  					
			case (fb.StopAfterCurrent):
				checked_item=3019
				break;  					
			default:
				checked_item=3018
				break;				
		}		
	schedulerMenu.CheckMenuRadioItem(3018, 3023, checked_item);		
	schedulerMenu.AppendTo(basemenu, MF_STRING, "Scheduler");	*/	
	
	library_menu = window.CreatePopupMenu();
	playlists_menu = window.CreatePopupMenu();
	bio_menu = window.CreatePopupMenu();	
	visu_menu = window.CreatePopupMenu();
	minimode_menu = window.CreatePopupMenu();
	appearance_menu = window.CreatePopupMenu();
	
	basemenu.AppendMenuSeparator();
	
	wallpaper_visibility = window.CreatePopupMenu();
	wallpaper_visibility.AppendMenuItem(MF_STRING, 4005, "Enable");	
	wallpaper_visibility.AppendMenuItem(MF_STRING, 4006, "Disable");	
	wallpaper_blur = window.CreatePopupMenu();
	wallpaper_blur.AppendMenuItem(MF_STRING, 4007, "Enable");	
	wallpaper_blur.AppendMenuItem(MF_STRING, 4008, "Disable");	
			
	if(layout_state==1){	
		minimode_menu.AppendTo(appearance_menu,MF_STRING, "Current panel");		
		minimode_menu.AppendMenuItem(MF_STRING, 3990, "Dark theme");	
		minimode_menu.CheckMenuItem(3990, properties.minimode_dark_theme);
		wallpaper_visibility.AppendTo(minimode_menu,MF_STRING, "Wallpapers visibility");			
		wallpaper_blur.AppendTo(minimode_menu,MF_STRING, "Wallpapers blur");		 		
	} else if(main_panel_state==0){
		library_menu.AppendTo(appearance_menu,MF_STRING, "Current panel");		
		library_menu.AppendMenuItem(MF_STRING, 4000, "Dark theme");	
		library_menu.CheckMenuItem(4000, properties.library_dark_theme);
		wallpaper_visibility.AppendTo(library_menu,MF_STRING, "Wallpapers visibility");			
		wallpaper_blur.AppendTo(library_menu,MF_STRING, "Wallpapers blur");					
	} else if(main_panel_state==1){
		playlists_menu.AppendTo(appearance_menu,MF_STRING, "Current panel");		
		playlists_menu.AppendMenuItem(MF_STRING, 4001, "Dark theme");	
		playlists_menu.CheckMenuItem(4001, properties.playlists_dark_theme);
		wallpaper_visibility.AppendTo(playlists_menu,MF_STRING, "Wallpapers visibility");			
		wallpaper_blur.AppendTo(playlists_menu,MF_STRING, "Wallpapers blur");			
	} else if(main_panel_state==2){
		bio_menu.AppendTo(appearance_menu,MF_STRING, "Current panel");			
		bio_menu.AppendMenuItem(MF_STRING, 4002, "Dark theme");
		bio_menu.CheckMenuItem(4002, properties.bio_dark_theme); 			
		wallpaper_visibility.AppendTo(bio_menu,MF_STRING, "Wallpapers visibility");			
		wallpaper_blur.AppendTo(bio_menu,MF_STRING, "Wallpapers blur");			
	} else if(main_panel_state==3){
		visu_menu.AppendTo(appearance_menu,MF_STRING, "Current panel");			
		visu_menu.AppendMenuItem(MF_STRING, 4003, "Dark theme");
		visu_menu.CheckMenuItem(4003, properties.visualization_dark_theme);	
	}
	appearance_menu.AppendMenuSeparator(); 
	font_size = window.CreatePopupMenu();
	font_size.AppendTo(appearance_menu,MF_STRING, "Font size");	
	font_size.AppendMenuItem(MF_STRING, 4012, "Increase");	
	font_size.AppendMenuItem(MF_STRING, 4013, "Decrease");	
	font_size.AppendMenuItem(MF_STRING, 4014, "Reset");	
	appearance_menu.AppendTo(basemenu,MF_STRING, "Skin settings");	
	
	appearance_menu.AppendMenuItem(MF_STRING, 4021,"Dark theme globally");	
	appearance_menu.AppendMenuItem(MF_STRING, 4022,"Light theme globally");		
	appearance_menu.AppendMenuSeparator();  	
	appearance_menu.AppendMenuItem(MF_STRING, 4025, "Enable disk cover cache");
	appearance_menu.CheckMenuItem(4025, globalProperties.enableDiskCache);		
	appearance_menu.AppendMenuItem((globalProperties.enableDiskCache)?MF_STRING:MF_GRAYED, 4023, "Load all covers at startup");
	appearance_menu.CheckMenuItem(4023, globalProperties.load_covers_at_startup);
	appearance_menu.AppendMenuItem((globalProperties.enableDiskCache)?MF_STRING:MF_GRAYED, 4024, "Load all artist thumbnails at startup");
	appearance_menu.CheckMenuItem(4024, globalProperties.load_artist_img_at_startup);			
	appearance_menu.AppendMenuItem(MF_STRING, 4026, "Reset images cache");	
	
	basemenu.AppendMenuSeparator();  	
	_screensaver.AppendMenuItem(MF_STRING, 4015, "Activate Now");	
	_screensaver.AppendMenuSeparator(); 
	_screensaver.AppendMenuItem(MF_STRING, 4016, "Enable");	
	_screensaver.CheckMenuItem(4016,globalProperties.enable_screensaver);
	_screensaver.AppendMenuItem(MF_STRING, 4017, "Escape on mouse move");	
	_screensaver.CheckMenuItem(4017,globalProperties.escape_on_mouse_move);	
	_screensaver.AppendMenuSeparator(); 
	_screensaver.AppendMenuItem(MF_STRING, 4020, "Light theme");		
	_screensaver.AppendMenuItem(MF_STRING, 4019, "Dark theme");	
	_screensaver.CheckMenuRadioItem(4019, 4020, (properties.screensaver_dark_theme)?4019:4020);		
	_screensaver.AppendMenuSeparator(); 
	_screensaver.AppendMenuItem(MF_STRING, 4018, "Set time (current: "+Math.round(globalProperties.mseconds_before_screensaver/1000)+"s)");	
	_screensaver.AppendTo(basemenu,MF_STRING, "Idle screen");		
	
	if(layout_state==0) {
		basemenu.AppendMenuItem(MF_STRING, 4010, "Switch to Compact player");	
		if(UIHacks.FullScreen)
			basemenu.AppendMenuItem(MF_STRING, 4009, "Quit Fullscreen");	
		else
			basemenu.AppendMenuItem(MF_STRING, 4009, "Fullscreen");			
	} else {
		basemenu.AppendMenuItem(MF_STRING, 4011, "Switch to Main player");			
	}
	
    menuman1.Init("file");
    menuman2.Init("edit");
    menuman3.Init("View");
    menuman4.Init("playback");
    menuman5.Init("library");
    menuman6.Init("help");

    menuman1.BuildMenu(child1, 1001, 200);
    menuman2.BuildMenu(child2, 1201, 200);
    menuman3.BuildMenu(child3, 1401, 200);
    menuman4.BuildMenu(child4, 1601, 300);
    menuman5.BuildMenu(child5, 1901, 300);
    menuman6.BuildMenu(child6, 2201, 100);

    contextman.InitNowPlaying();
    contextman.BuildMenu(child7, 2301, -1);
    idx = 0;

    idx = basemenu.TrackPopupMenu(x, y);
	
    switch (true) {       
    case(idx >= 1001 && idx < 1201):
        menuman1.ExecuteByID(idx - 1001);
        break;

    case (idx >= 1201 && idx < 1401):
        menuman2.ExecuteByID(idx - 1201);
        break;

    case (idx >= 1401 && idx < 1601):
        menuman3.ExecuteByID(idx - 1401);
        break;

    case (idx >= 1601 && idx < 1901):
        menuman4.ExecuteByID(idx - 1601);
        break;

    case (idx >= 1901 && idx < 2201):
        menuman5.ExecuteByID(idx - 1901);
        break;

    case (idx >= 2201 && idx < 2301):
        menuman6.ExecuteByID(idx - 2201);
        break;

    case (idx >= 2301 && idx < 3000):
        contextman.ExecuteByID(idx - 2301);
        break;
	case (idx == 3018):
		setScheduler(0);		
		break; 
	case (idx == 3019):
		setScheduler(1);		
		break; 				
	case (idx == 3020):
		setScheduler(2);		
		break; 			
	case (idx == 3021):
		setScheduler(3);	
		break; 	
	case (idx == 3022):
		setScheduler(4);					
		break; 
	case (idx == 3023):
		setScheduler(5);			
		break;		
   case (idx == 3990):
		properties.minimode_dark_theme=!properties.minimode_dark_theme;   
        window.NotifyOthers("minimode_dark_theme",properties.minimode_dark_theme);
		window.SetProperty("MINIMODE dark theme", properties.minimode_dark_theme);	
		get_colors();g_searchbox.adapt_look_to_layout();
        window.Repaint();
        break;			
   case (idx == 4000):
		properties.library_dark_theme=!properties.library_dark_theme;   
        window.NotifyOthers("library_dark_theme",properties.library_dark_theme);
		window.SetProperty("LIBRARY dark theme", properties.library_dark_theme);	
		on_notify_data("library_dark_theme",properties.library_dark_theme);		
        window.Repaint();
        break;		
   case (idx == 4001):
		properties.playlists_dark_theme=!properties.playlists_dark_theme;   
        window.NotifyOthers("playlists_dark_theme",properties.playlists_dark_theme);	
		window.SetProperty("PLAYLISTS dark theme", properties.playlists_dark_theme);	
		on_notify_data("playlists_dark_theme",properties.playlists_dark_theme);			
		fb.RunMainMenuCommand("View/ElPlaylist/Refresh");
        window.Repaint();
        break;		
   case (idx == 4002):
		properties.bio_dark_theme=!properties.bio_dark_theme;   
        window.NotifyOthers("bio_dark_theme",properties.bio_dark_theme);
		window.SetProperty("BIO dark theme", properties.bio_dark_theme);	
		on_notify_data("bio_dark_theme",properties.bio_dark_theme);			
        window.Repaint();
        break;
   case (idx == 4003):
		properties.visualization_dark_theme=!properties.visualization_dark_theme;   
        window.NotifyOthers("visualization_dark_theme",properties.visualization_dark_theme);
		window.SetProperty("VISUALIZATION dark theme", properties.visualization_dark_theme);	
		on_notify_data("visualization_dark_theme",properties.visualization_dark_theme);		
        break;		
   case (idx == 4005):  
        window.NotifyOthers("wallpaperVisibility",true);
        break;		
   case (idx == 4006):  
        window.NotifyOthers("wallpaperVisibility",false);
        break;		
   case (idx == 4007):  
        window.NotifyOthers("wallpaperBlur",true);
        break;		
   case (idx == 4008):  
        window.NotifyOthers("wallpaperBlur",false);
        break;	
	case (idx == 4009):
		fb.RunMainMenuCommand('View/Fullscreen');
		break;		
	case (idx == 4010):
		toggleLayoutMode(1);get_colors();g_searchbox.adapt_look_to_layout();
		break;	
	case (idx == 4011):
		toggleLayoutMode(0);get_colors();g_searchbox.adapt_look_to_layout();
		break;	
	case (idx == 4012):
		properties.globalFontAdjustement++;
		window.SetProperty("MAINPANEL: Global Font Adjustement", properties.globalFontAdjustement);
		window.NotifyOthers('set_font',properties.globalFontAdjustement);
		on_font_changed();		
		break;	
	case (idx == 4013):
		properties.globalFontAdjustement--;
		window.SetProperty("MAINPANEL: Global Font Adjustement", properties.globalFontAdjustement);
		window.NotifyOthers('set_font',properties.globalFontAdjustement);
		on_font_changed();			
		break;
	case (idx == 4014):
		properties.globalFontAdjustement = 0;
		window.SetProperty("MAINPANEL: Global Font Adjustement", properties.globalFontAdjustement);
		window.NotifyOthers('set_font',properties.globalFontAdjustement);
		on_font_changed();		
		break;	
	case (idx == 4015):
		set_screensaver_state(1);SetPseudoCaption();	
		break;		
	case (idx == 4016):
		enableScreensaver(!globalProperties.enable_screensaver);	
		break;	
	case (idx == 4017):
		escapeOnMouseMove(!globalProperties.escape_on_mouse_move);	
		break;		
	case (idx == 4018):
		new_mseconds_before_screensaver = InputBox("Seconds of mouse inactivity before activation of the idle screen", "Idle screen", globalProperties.mseconds_before_screensaver/1000);
		if (!(new_mseconds_before_screensaver == "" || typeof new_mseconds_before_screensaver == 'undefined')) {
			globalProperties.mseconds_before_screensaver = Number(new_mseconds_before_screensaver);
			if(globalProperties.mseconds_before_screensaver<=0) globalProperties.mseconds_before_screensaver = 60;
			globalProperties.mseconds_before_screensaver = globalProperties.mseconds_before_screensaver*1000;
			setScreensaverTime(globalProperties.mseconds_before_screensaver);
		}				
		break;			
	case (idx == 4019):
		properties.screensaver_dark_theme=true;
		window.SetProperty("SCREENSAVER dark theme", properties.screensaver_dark_theme);				
		window.NotifyOthers('screensaver_dark_theme',properties.screensaver_dark_theme);
		break;	
	case (idx == 4020):
		properties.screensaver_dark_theme=false;
		window.SetProperty("SCREENSAVER dark theme", properties.screensaver_dark_theme);				
		window.NotifyOthers('screensaver_dark_theme',properties.screensaver_dark_theme);
		break;			
	case (idx == 4021):
		Lightswitch(true,true);
		break;		
	case (idx == 4022):
		Lightswitch(true,false);
		break;		
	case (idx == 4023):
		enableCoversAtStartupGlobaly();			
		break;	
	case (idx == 4024):
		enableArtistImgAtStartupGlobaly();			
		break;	
	case (idx == 4025):
		enableDiskCacheGlobaly();			
		break;	
	case (idx == 4026):
		delete_full_cache();
		break;
    }

    basemenu.Dispose();
    contextman.Dispose();
    menuman1.Dispose();
    menuman2.Dispose();
    menuman3.Dispose();
    menuman4.Dispose();
    menuman5.Dispose();
    menuman6.Dispose();
	_screensaver.Dispose();
	minimode_menu.Dispose();
	font_size.Dispose();	
	//schedulerMenu.Dispose();
    library_menu.Dispose();
    playlists_menu.Dispose();	
    bio_menu.Dispose();	
    wallpaper_visibility.Dispose();	
    wallpaper_blur.Dispose();	
}
function on_font_changed() {
	get_font();
	g_searchbox.on_size();		
    for (var i in buttons) {
        buttons[i].first_draw = true;
    }	
	adapt_buttons_to_layout();
	window.Repaint();	
};
function on_library_items_added() {
	timer.lib_update();
}
function on_library_items_removed() {
	timer.lib_update();
}
function on_metadb_changed(metadbs, fromhook) {
	//g_genre_cache.on_metadb_changed(metadbs, fromhook);
}
function on_key_up(vkey) {
	g_searchbox.on_key("up", vkey);
}
function on_char(code) {
	g_searchbox.on_char(code);
	
}
function on_key_down(vkey) {
	g_searchbox.on_key("down", vkey);
	switch (vkey) {
	case VK_ESCAPE:
		if(UIHacks.FullScreen) fb.RunMainMenuCommand('View/Fullscreen');
		break;
	};	
}	
function on_focus(is_focused) {
	if(!is_focused && g_searchbox.inputbox.text.length > 3){
		g_searchHistory.add(g_searchbox.inputbox.text);
		writeSearchHistoryIni(g_searchHistory.historyList);
	}
	g_searchbox.on_focus(is_focused)
}
function on_notify_data(name, info) {
    switch(name) {	
		case "history_previous":
			g_searchbox.clearInputbox();
			window.Repaint();
		break;			
		case "nowplayinglib_state":
			nowplayinglib_state=info;
		break; 
		case "nowplayingplaylist_state":
			nowplayingplaylist_state=info;
		break; 
		case "nowplayingbio_state":
			nowplayingbio_state=info;
		break; 
		case "nowplayingvisu_state":
			nowplayingvisu_state=info;
		break; 		
		case "WSH_panels_reload":
			window.Reload();
		break;	  
		case "enable_screensaver":			
			globalProperties.enable_screensaver = info;
			window.SetProperty("GLOBAL enable screensaver", globalProperties.enable_screensaver);	
		break;	
		case "escape_on_mouse_move":			
			globalProperties.escape_on_mouse_move = info;
			window.SetProperty("GLOBAL screensaver escape on mouse move", globalProperties.escape_on_mouse_move);	
		break;		
		case "set_font":	
			properties.globalFontAdjustement = info;
			window.SetProperty("MAINPANEL: Global Font Adjustement", properties.globalFontAdjustement),
			get_font();
			window.Repaint();
		break;		
		case "library_dark_theme":
			properties.library_dark_theme=info;
			window.SetProperty("LIBRARY dark theme", properties.library_dark_theme);
			get_colors()		
			g_searchbox.adapt_look_to_layout();
			window.Repaint();		
		break;	
		case "screensaver_dark_theme":
			properties.screensaver_dark_theme=info;
			window.SetProperty("SCREENSAVER dark theme", properties.screensaver_dark_theme);
		break;	
		case "bio_stick_to_dark_theme":
			properties.bio_stick2darklayout=info;
			window.SetProperty("BIO stick to Dark layout", properties.bio_stick2darklayout);
			window.Repaint();		
		break;	
		case "libraryfilter_state":
			libraryfilter_state=info;
		break;
		case "playlists_dark_theme":
			properties.playlists_dark_theme=info;
			window.SetProperty("PLAYLISTS dark theme", properties.playlists_dark_theme);
			set_darkplaylist_state((properties.playlists_dark_theme)?1:0);
			get_colors()		
			g_searchbox.adapt_look_to_layout();
			window.Repaint();		
		break;		
		case "bio_dark_theme":
			properties.bio_dark_theme=info;
			window.SetProperty("BIO dark theme", properties.bio_dark_theme);
			get_colors();		
			g_searchbox.adapt_look_to_layout();
			window.Repaint();		
		break;	    
		case "visualization_dark_theme":
			properties.visualization_dark_theme=info;
			window.SetProperty("VISUALIZATION dark theme", properties.visualization_dark_theme);
			get_colors();		
			g_searchbox.adapt_look_to_layout();
			window.Repaint();		
		break;	
		case "layout_state":
			layout_state = info;
			g_searchbox.adapt_look_to_layout();
			get_colors()
			window.Repaint();
		break;	
		case"DiskCacheState":
			globalProperties.enableDiskCache = info;
			window.SetProperty("COVER Disk Cache", globalProperties.enableDiskCache);			
		break;  	
		case"LoadAllCoversState":
			globalProperties.load_covers_at_startup = info;
			window.SetProperty("COVER Load all at startup", globalProperties.load_covers_at_startup);	
		break; 	
		case"LoadAllArtistImgState":
			globalProperties.load_artist_img_at_startup = info;
			window.SetProperty("ARTIST IMG Load all at startup", globalProperties.load_artist_img_at_startup);	
		break; 		
		case "pmanager_height":
			if(!UIHacks.FullScreen && UIHacks.MainWindowState==0){
				properties.fullMode_pmanagerheight=info;
				window.SetProperty("Full mode pmanager saved height", properties.fullMode_pmanagerheight);
			}
		break;
		case "schedulerState":
			setScheduler(info,true);
		break;	
		case "playlist_height":
			if(!UIHacks.FullScreen && UIHacks.MainWindowState==0){		
				properties.miniMode_playlistheight=info;
				window.SetProperty("Mini mode playlist saved height", properties.miniMode_playlistheight);
			}
		break;		
		case "minimode_dark_theme":
			if(layout_state==1){
				properties.minimode_dark_theme=info;
				window.SetProperty("MINIMODE dark theme", properties.minimode_dark_theme);
				get_colors()
				window.Repaint();	
			}		
		break;		
		case "main_panel_state":
			if(main_panel_state!=info) {
				main_panel_state = info;
				get_colors()
				window.Repaint();
			}
		break;	
		case "screensaver_state":
			if(screensaver_state!=info) {			
				screensaver_state = info;
				SetPseudoCaption();
			}
		break;	
		case "giveMeGenreList":
			if(!g_genre_cache.isEmpty()){
				window.NotifyOthers("hereIsGenreList",g_genre_cache);			
			}
		break;	
	}
}

function oTimers() {
    var timer_arr = ["update"];
    for (var i = 0; i < timer_arr.length; i++) this[timer_arr[i]] = false;
    this.reset = function(timer, n) {
        if (timer) window.ClearTimeout(timer);
        this[timer_arr[n]] = false;
    }
    this.lib_update = function() {
        this.reset(this.update, 0);
        this.update = window.SetTimeout(function() {
            get_library();
            timer.reset(timer.update, 0);
        }, 500);
    }
}
// ----------------------- Search Object ---------------------------
oSearch = function() {
	this.w = 0;
	this.h = 0;
	this.x = 0;
	this.y = 0;	
	this.isHover = false;
	this.hide = false;
	this.images = {
        magnify: null,
        resetIcon_off: null,
        resetIcon_ov: null
	};
	this.repaint = function() {window.Repaint()}
    this.getImages = function() {
		var gb;
        var button_size = 18;
		this.images.search_icon = gdi.Image(theme_img_path  + "\\icons\\"+icons_folder+"\\search_icon.png");
		this.search_bt = new button(this.images.search_icon, this.images.search_icon, this.images.search_icon);
		
		this.images.search_history_icon = gdi.Image(theme_img_path  + "\\icons\\"+icons_folder+"\\search_history.png");
		this.images.search_history_hover_icon = gdi.Image(theme_img_path  + "\\icons\\"+icons_folder+"\\search_history_hover.png");
		
        this.images.resetIcon_off = gdi.CreateImage(button_size, button_size);
        gb = this.images.resetIcon_off.GetGraphics();
            gb.setSmoothingMode(2);
			var resetIcon_off_size=5;
            gb.DrawLine(resetIcon_off_size, resetIcon_off_size, button_size-resetIcon_off_size, button_size-resetIcon_off_size, 1.0, search_reset_icon);
            gb.DrawLine(resetIcon_off_size, button_size-resetIcon_off_size, button_size-resetIcon_off_size, resetIcon_off_size, 1.0, search_reset_icon);
            gb.setSmoothingMode(0);
        this.images.resetIcon_off.ReleaseGraphics(gb);

        this.images.resetIcon_ov = gdi.CreateImage(button_size, button_size);
        gb = this.images.resetIcon_ov.GetGraphics();
            gb.setSmoothingMode(2);
			var resetIcon_ov_size=3;
            gb.DrawLine(resetIcon_ov_size, resetIcon_ov_size, button_size-resetIcon_ov_size, button_size-resetIcon_ov_size, 1.0, search_reset_icon);
            gb.DrawLine(resetIcon_ov_size, button_size-resetIcon_ov_size, button_size-resetIcon_ov_size, resetIcon_ov_size, 1.0, search_reset_icon);
            gb.setSmoothingMode(0);
        this.images.resetIcon_ov.ReleaseGraphics(gb);

        this.images.resetIcon_dn = gdi.CreateImage(button_size, button_size);
        gb = this.images.resetIcon_dn.GetGraphics();
            gb.setSmoothingMode(2);
			var resetIcon_dn_size=5;
            gb.DrawLine(resetIcon_dn_size, resetIcon_dn_size, button_size-resetIcon_dn_size, button_size-resetIcon_dn_size, 1.0, RGB(255,50,50));
            gb.DrawLine(resetIcon_dn_size, button_size-resetIcon_dn_size, button_size-resetIcon_dn_size, resetIcon_dn_size, 1.0, RGB(255,50,50));
            gb.setSmoothingMode(0);
        this.images.resetIcon_dn.ReleaseGraphics(gb);

        this.reset_bt = new button(this.images.resetIcon_off, this.images.resetIcon_ov, this.images.resetIcon_dn);
	};
	this.getImages();    
    this.reset_colors = function() {
        this.inputbox.textcolor = g_color_normal_txt;
        this.inputbox.backselectioncolor = g_color_selected_bg;
		this.getImages();    
    };

    this.setSize = function(w, h, font_size) {
		this.w = w;
		this.h = h;
        this.inputbox.setSize(w-cSearchBox.paddingRight-cSearchBox.paddingLeft, h-cSearchBox.paddingTop-cSearchBox.paddingBottom, font_size);
    };
	this.on_size = function() {
		if(layout_state==0){
			this.setSize(cSearchBox.width, wh-cSearchBox.marginTop-cSearchBox.marginBottom, g_fsize);		
		} else {
			this.setSize(ww-cSearchBox.marginRight-cSearchBox.marginLeft, wh-cSearchBox.marginTop-cSearchBox.marginBottom, g_fsize);			
		}		
	}
	this.toggleVisibility = function(new_state) {
		if(typeof new_state !== 'undefined') this.hide = !new_state;
		else this.hide = !this.hide;
		if(!this.hide) {
			buttons.ShowSearch.hide = true;
			
		} else {
			buttons.ShowSearch.hide = false;
			this.clearInputbox();
			window.NotifyOthers("reset_filters",0);
		}
		set_main_btns_visibility();
		g_searchbox.repaint();		
	}
    this.adapt_look_to_layout = function() {
		this.reset_colors();
		if(layout_state==1){
			for (var c in cSearchBoxMini) 
				if(cSearchBoxMini.hasOwnProperty(c))
					cSearchBox[c] = cSearchBoxMini[c]	
		} else {
			switch(true){
				case (main_panel_state==0 && properties.library_dark_theme):
				case (main_panel_state==1 && properties.playlists_dark_theme):		
				case (main_panel_state==2 && properties.bio_dark_theme):
				case (main_panel_state==3):	
					for (var c in cSearchBoxMainDark) 
						if(cSearchBoxMainDark.hasOwnProperty(c))
							cSearchBox[c] = cSearchBoxMainDark[c]									
				break;
				default:
					for (var c in cSearchBoxMainLight) 
						if(cSearchBoxMainLight.hasOwnProperty(c))
							cSearchBox[c] = cSearchBoxMainLight[c]												
				break;		
			}			
		}
		this.on_size();		
	}	
    this.clearInputbox = function() {
        if(this.inputbox.text.length > 0) {					
			this.inputbox.text = "";
			this.inputbox.offset = 0;
			this.reset_bt.state=ButtonStates.normal;
        };
    };
    
	this.draw = function(gr, x, y) {
		this.x = x;
		this.y = y;
		if(this.hide) return; 	
		
		if(this.isHoverHistory){
			gr.DrawImage(this.images.search_history_hover_icon, this.x+this.w-Math.round(cSearchBox.paddingRight/2 + this.images.search_history_icon.Width/2), this.y+Math.round(this.h/2 - this.images.search_history_icon.Height/2), this.images.search_history_hover_icon.Width, this.images.search_history_hover_icon.Height, 0, 0, this.images.search_history_hover_icon.Width, this.images.search_history_hover_icon.Height,0,255);
		} else {
			gr.DrawImage(this.images.search_history_icon, this.x+this.w-Math.round(cSearchBox.paddingRight/2 + this.images.search_history_icon.Width/2), this.y+Math.round(this.h/2 - this.images.search_history_icon.Height/2), this.images.search_history_icon.Width, this.images.search_history_icon.Height, 0, 0, this.images.search_history_icon.Width, this.images.search_history_hover_icon.Height,0,255);			
		}

        if(this.inputbox.text.length > 0 || (!properties.alwaysShowSearch && layout_state==0)) {
            this.reset_bt.draw(gr, this.x+cSearchBox.paddingLeft-this.images.search_icon.Width-1, this.y+Math.floor((this.h-cSearchBox.paddingBottom)/2-this.reset_bt.img[0].Height/2)+1, 255);
        } else {
			this.search_bt.draw(gr, this.x+cSearchBox.paddingLeft-this.images.search_icon.Width-4, this.y+Math.floor((this.h-cSearchBox.paddingBottom)/2-this.images.search_icon.Height/2)+3, 255);					
			//gr.DrawImage(this.images.search_icon, this.x+cSearchBox.paddingLeft-this.images.search_icon.Width-4, this.y+Math.floor((this.h-cSearchBox.paddingBottom)/2-this.images.search_icon.Height/2)+3, this.images.search_icon.Width, this.images.search_icon.Height, 0, 0, this.images.search_icon.Width, this.images.search_icon.Height, 0, 255);
        };
		this.inputbox.draw(gr, this.x+cSearchBox.paddingLeft, this.y+cSearchBox.paddingTop, 0, 0);
		if(layout_state==0){	
			gr.FillSolidRect(this.x, this.y+this.h - 1, this.w, 1, search_line_color); //bottom line
			gr.FillSolidRect(this.x+this.w-1, this.y, 1, this.h-1, search_line_color); //right line
		}			
    };
    
    this.on_mouse = function(event, x, y, delta) {
        switch(event) {
            case "lbtn_down":
				if(this.isHover){
					this.inputbox.check("down", x, y);
					if(this.inputbox.text.length > 0) this.reset_bt.checkstate("down", x, y);
					else this.search_bt.checkstate("down", x, y);					
					if(this.isHoverHistory) draw_searchHistory_menu(this.x+this.w,this.h+this.y-1);	
				}
				else if(!properties.alwaysShowSearch && this.inputbox.text.length == 0 && layout_state==0 && !this.hide){
					this.toggleVisibility(false);
				} else {
					this.on_focus(false);
				}
                break;
            case "lbtn_up":
                if((this.inputbox.text.length > 0 || (!properties.alwaysShowSearch && layout_state==0)) &&  !this.hide) {
                    if(this.reset_bt.checkstate("up", x, y) == ButtonStates.hover && !this.inputbox.drag) {
						if(fb.isPlaying && this.inputbox.text.length > 0) showNowPlaying();						
                        this.clearInputbox();
						window.NotifyOthers("reset_filters",0);
						if(!properties.alwaysShowSearch && layout_state==0) g_searchbox.toggleVisibility(false);
						g_searchbox.repaint();
                    };
                } else if(properties.alwaysShowSearch) {
					if(this.search_bt.checkstate("up", x, y) == ButtonStates.hover && !this.inputbox.drag) {
						this.inputbox.activate(x,y);
						this.inputbox.repaint();
					};					
				}			
				this.inputbox.check("up", x, y);
                break;
            case "lbtn_dblclk":
				if(!this.hide)
					this.inputbox.check("dblclk", x, y);
                break;
            case "rbtn_down":
				if(!this.hide)			
					this.inputbox.check("right", x, y);
                break;
            case "move":
				this.isHoverHistoryOld = this.isHoverHistory;
				this.checkHover(x,y);
				if(!this.hide) this.inputbox.check("move", x, y);
                if((this.inputbox.text.length > 0 || (!properties.alwaysShowSearch && layout_state==0)) && !this.hide) this.reset_bt.checkstate("move", x, y);
				if(x > this.x+this.w-cSearchBox.paddingRight && x<this.x+this.w && y>cSearchBox.marginTop && !this.hide) this.isHoverHistory = true;
				else this.isHoverHistory = false;
				if(this.isHoverHistoryOld!=this.isHoverHistory) this.repaint();
                break;
            case "leave":
				if(this.isHoverHistory) {
					this.isHoverHistory = false;
					this.repaint();
				}
                break;				
        };
    };
    this.checkHover = function(x, y) {
		this.isHover = (x < this.x+this.w && x > this.x && y <  this.y+this.h &&  y > this.y && !this.hide);
	}
    this.on_key = function(event, vkey) {
        switch(event) {
            case "down":
				if(!this.hide)				
					this.inputbox.on_key_down(vkey);
                break;
        };
    };
    
    this.on_char = function(code) {
		if(this.hide) return;
		if(code==13) {//ENTER
			if(this.inputbox.text.length < 3)
				return;
			g_launchSearch();	
			g_searchHistory.add(this.inputbox.text);	
			writeSearchHistoryIni(g_searchHistory.historyList);			
		} else if(code!="")	{
			this.inputbox.on_char(code);
			if(this.inputbox.text.length==0) window.NotifyOthers("reset_filters",0);
		}

    };
    
	this.on_focus = function(is_focused) {
		this.inputbox.on_focus(is_focused);
		if(!is_focused && !properties.alwaysShowSearch && this.inputbox.text.length == 0 && layout_state==0){
			this.toggleVisibility(false);
		}
		else if(is_focused && this.isHover && this.inputbox.edit && (main_panel_state!=0 && main_panel_state!=1) && layout_state==0){
			set_main_panel_state(0);
			get_colors();g_searchbox.adapt_look_to_layout();
		}		
	};
	this.on_init = function() {
		this.inputbox = new oInputbox(this.w, this.h, "", "Search...", search_txt_color , 0, 0, g_color_selected_bg, g_launchSearch, "g_searchbox");
        this.inputbox.autovalidation = true;
		this.adapt_look_to_layout();
    };
	this.on_init();	
};
function g_launchSearch() {
	if(g_searchbox.inputbox.text.length < 3)
		return;
	var search_results = fb.GetQueryItems(library_list, g_searchbox.inputbox.text);
	//window.NotifyOthers("search_launched",0);	
	apply_playlist(search_results,false,true,false);
	search_results.Dispose();	
	window.NotifyOthers("refresh_filters",0);
	g_searchbox.repaint();	
	return;
};	

function get_library(){
	if (library_list) library_list.Dispose();
	library_list = fb.GetLibraryItems();
}

// ---------- Search history ------------------
searchHistory = function () {
    this.historyList = Array();
    this.searchExist = function (search_item) {		
		for (var i = 0; i < this.historyList.length; i++) {
			if(this.historyList[i][0]==search_item) return true;
		}
		return false;
    };		
    this.add = function (search_item, datetime) {		
		if(!this.searchExist(search_item)) {
			var currentdate = new Date(); 
			datetime = typeof datetime !== 'undefined' ? datetime : currentdate.getDate() + "/"	+ (currentdate.getMonth()+1)  + "/"	+ currentdate.getFullYear() + " @ "	  
							+ currentdate.getHours() + ":" + currentdate.getMinutes() + ":" + currentdate.getSeconds();			
			this.historyList[this.historyList.length] = Array(search_item,datetime);
			if(this.historyList.length>properties.searchHistory_max_items) this.historyList.shift();			
			return true;
		}		
		return false;
    };	
	this.onFinish = function (genre) {
		this.sort();		
	}	
	this.sort = function () {
		//this.historyList.sort();
	}
	this.reset = function () {
		this.historyList = Array();
		try {
			if(fso.FileExists(SettingsPath + "SearchHistory.ini")) fso.DeleteFile(SettingsPath + "SearchHistory.ini");
		} catch(e) {}		
	}	
    this.trace = function (genre) {		
		for (var i = 0; i < this.historyList.length; i++) {
			console.log(this.historyList[i][0])
		}
    };		
}

function draw_searchHistory_menu(x, y) {
    var basemenu = window.CreatePopupMenu();
	if (typeof x == "undefined") x=ww;
	if (typeof y == "undefined") y=30;	
		
    basemenu.AppendMenuItem(MF_GRAYED, 0, "Search history :");
	basemenu.AppendMenuSeparator(); 
	
	for (var i = g_searchHistory.historyList.length-1; i >=0; i--) {
		basemenu.AppendMenuItem(MF_STRING, i+1, g_searchHistory.historyList[i][0].replace("&","&&"));
	}
	if(g_searchHistory.historyList.length==0) {
		basemenu.AppendMenuItem(MF_GRAYED, 0, "The search history is empty");
	} else {
		basemenu.AppendMenuSeparator();
		basemenu.AppendMenuItem(MF_STRING, properties.searchHistory_max_items+10, "Clear history");
	}
	
    idx = 0;
    idx = basemenu.TrackPopupMenu(x, y, 0x0008);

    switch (true) {
    case (idx > 0 && idx <= properties.searchHistory_max_items+1):
		 g_searchbox.inputbox.text = g_searchHistory.historyList[idx-1][0];
		 g_searchbox.on_char();
		 window.Repaint();
        break;           
    case (idx == properties.searchHistory_max_items+10):
        g_searchHistory.reset();
        break;			
    }
    basemenu.Dispose();
}

function writeSearchHistoryIni(argSearchHistory){
	if(argSearchHistory.length>0){
		try {
			if(fso.FileExists(SettingsPath + "SearchHistory.ini")) fso.DeleteFile(SettingsPath + "SearchHistory.ini");
			var MyFile = fso.CreateTextFile(SettingsPath+"SearchHistory.ini", true);
			for (var i = 0; i <argSearchHistory.length; i++) {
				MyFile.WriteLine(argSearchHistory[i][0]+" ## "+argSearchHistory[i][1]);
				if(i==properties.searchHistory_max_items) break;
			}	
			MyFile.Close();
		} catch(e) {}
	}
}
function readSearchHistoryIni(){
	var g_searchHistory = new searchHistory();
	if(fso.FileExists(SettingsPath + "SearchHistory.ini")) {
		historyFile = fso.OpenTextFile(SettingsPath + "SearchHistory.ini", 1);
		// Read from the file and add the results.
		while (!historyFile.AtEndOfStream){
			read_history = historyFile.ReadLine();
			arguments = read_history.split(" ## ");
			g_searchHistory.add(arguments[0],arguments[1]);					
		}
		g_searchHistory.onFinish();			
		historyFile.Close();			
	}
	return g_searchHistory.historyList;		
}
// ===================================================== // Wallpaper
function setWallpaperImg(defaultpath, metadb) {    
    if(metadb && properties.wallpapermode_temp == 0) {
		var tmp_img = get_albumArt(metadb);
    } else {
        if(defaultpath) {
            tmp_img = gdi.Image(defaultpath);
        } else {
            tmp_img = null;
        };
    };
    if(!tmp_img) {
        if(defaultpath) {
            tmp_img = gdi.Image(defaultpath);
        } else {
            tmp_img = null;
        };
    };
	//if(metadb!==null) {default_wallpaperImg = null;}
    //else g_wallpaperImg = null;
	if(metadb!==null) g_wallpaperImg = null;
	update_wallpaper = false;
    var img = FormatWallpaper(tmp_img, ww, wh, 2, properties.wallpaperdisplay, 0, "", false);
    return img;
};
function on_init(){
	get_font();	
	get_colors();	
	if(screensaver_state==1) 
		set_screensaver_state(0);
	if(properties.Remember_previous_state && main_panel_state==3) {
		set_main_panel_state(0);
	} else if(!properties.Remember_previous_state){
		set_main_panel_state(0);		
	}
    g_searchbox = new oSearch();
	g_searchHistory = new searchHistory;
	g_searchHistory.historyList = readSearchHistoryIni();
	timer = new oTimers();
	get_library();
	adapt_buttons_to_layout();
	g_genre_cache = new genre_cache();
	g_genre_cache.build_from_library();	
	UIHacks.FrameStyle=3;
	UIHacks.Aero.Effect=2;
	if(fb.IsPlaying) caption_title = fb.TitleFormat("[%artist%  -  ][%album%[  -  %tracknumber%] : ]%title%[  -  %date%]").Eval();
}
on_init();

